/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         nft_parse
#define yylex           nft_lex
#define yyerror         nft_error
#define yydebug         nft_debug
#define yynerrs         nft_nerrs


/* Copy the first part of user declarations.  */
#line 11 "parser_bison.y" /* yacc.c:339  */


#include <stddef.h>
#include <stdio.h>
#include <inttypes.h>
#include <syslog.h>
#include <netinet/ip.h>
#include <netinet/if_ether.h>
#include <linux/netfilter.h>
#include <linux/netfilter/nf_tables.h>
#include <linux/netfilter/nf_conntrack_tuple_common.h>
#include <linux/netfilter/nf_nat.h>
#include <linux/netfilter/nf_log.h>
#include <netinet/ip_icmp.h>
#include <netinet/icmp6.h>
#include <libnftnl/common.h>
#include <libnftnl/set.h>

#include <rule.h>
#include <statement.h>
#include <expression.h>
#include <headers.h>
#include <utils.h>
#include <parser.h>
#include <erec.h>

#include "parser_bison.h"

void parser_init(struct nft_ctx *nft, struct parser_state *state,
		 struct list_head *msgs, struct list_head *cmds)
{
	memset(state, 0, sizeof(*state));
	init_list_head(&state->top_scope.symbols);
	state->msgs = msgs;
	state->cmds = cmds;
	state->scopes[0] = scope_init(&state->top_scope, NULL);
	state->ectx.nft = nft;
	state->ectx.msgs = msgs;
}

static void yyerror(struct location *loc, struct nft_ctx *nft, void *scanner,
		    struct parser_state *state, const char *s)
{
	erec_queue(error(loc, "%s", s), state->msgs);
}

static struct scope *current_scope(const struct parser_state *state)
{
	return state->scopes[state->scope];
}

static void open_scope(struct parser_state *state, struct scope *scope)
{
	assert(state->scope < array_size(state->scopes) - 1);
	scope_init(scope, current_scope(state));
	state->scopes[++state->scope] = scope;
}

static void close_scope(struct parser_state *state)
{
	assert(state->scope > 0);
	state->scope--;
}

static void location_init(void *scanner, struct parser_state *state,
			  struct location *loc)
{
	memset(loc, 0, sizeof(*loc));
	loc->indesc = state->indesc;
}

static void location_update(struct location *loc, struct location *rhs, int n)
{
	if (n) {
		loc->indesc       = rhs[n].indesc;
		loc->token_offset = rhs[1].token_offset;
		loc->line_offset  = rhs[1].line_offset;
		loc->first_line   = rhs[1].first_line;
		loc->first_column = rhs[1].first_column;
		loc->last_line    = rhs[n].last_line;
		loc->last_column  = rhs[n].last_column;
	} else {
		loc->indesc       = rhs[0].indesc;
		loc->token_offset = rhs[0].token_offset;
		loc->line_offset  = rhs[0].line_offset;
		loc->first_line   = loc->last_line   = rhs[0].last_line;
		loc->first_column = loc->last_column = rhs[0].last_column;
	}
}

#define YYLLOC_DEFAULT(Current, Rhs, N)	location_update(&Current, Rhs, N)

#define symbol_value(loc, str) \
	symbol_expr_alloc(loc, SYMBOL_VALUE, current_scope(state), str)

/* Declare those here to avoid compiler warnings */
void nft_set_debug(int, void *);
int nft_lex(void *, void *, void *);

#line 172 "parser_bison.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_NFT_PARSER_BISON_H_INCLUDED
# define YY_NFT_PARSER_BISON_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int nft_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOKEN_EOF = 0,
    JUNK = 258,
    NEWLINE = 259,
    COLON = 260,
    SEMICOLON = 261,
    COMMA = 262,
    DOT = 263,
    EQ = 264,
    NEQ = 265,
    LT = 266,
    GT = 267,
    GTE = 268,
    LTE = 269,
    LSHIFT = 270,
    RSHIFT = 271,
    AMPERSAND = 272,
    CARET = 273,
    NOT = 274,
    SLASH = 275,
    ASTERISK = 276,
    DASH = 277,
    AT = 278,
    VMAP = 279,
    INCLUDE = 280,
    DEFINE = 281,
    REDEFINE = 282,
    UNDEFINE = 283,
    FIB = 284,
    SOCKET = 285,
    TRANSPARENT = 286,
    HOOK = 287,
    DEVICE = 288,
    DEVICES = 289,
    TABLE = 290,
    TABLES = 291,
    CHAIN = 292,
    CHAINS = 293,
    RULE = 294,
    RULES = 295,
    SETS = 296,
    SET = 297,
    ELEMENT = 298,
    MAP = 299,
    MAPS = 300,
    FLOWTABLE = 301,
    HANDLE = 302,
    RULESET = 303,
    TRACE = 304,
    INET = 305,
    NETDEV = 306,
    ADD = 307,
    UPDATE = 308,
    REPLACE = 309,
    CREATE = 310,
    INSERT = 311,
    DELETE = 312,
    GET = 313,
    LIST = 314,
    RESET = 315,
    FLUSH = 316,
    RENAME = 317,
    DESCRIBE = 318,
    IMPORT = 319,
    EXPORT = 320,
    MONITOR = 321,
    ALL = 322,
    ACCEPT = 323,
    DROP = 324,
    CONTINUE = 325,
    JUMP = 326,
    GOTO = 327,
    RETURN = 328,
    TO = 329,
    CONSTANT = 330,
    INTERVAL = 331,
    AUTOMERGE = 332,
    TIMEOUT = 333,
    GC_INTERVAL = 334,
    ELEMENTS = 335,
    POLICY = 336,
    MEMORY = 337,
    PERFORMANCE = 338,
    SIZE = 339,
    FLOW = 340,
    OFFLOAD = 341,
    METER = 342,
    METERS = 343,
    FLOWTABLES = 344,
    NUM = 345,
    STRING = 346,
    QUOTED_STRING = 347,
    ASTERISK_STRING = 348,
    LL_HDR = 349,
    NETWORK_HDR = 350,
    TRANSPORT_HDR = 351,
    BRIDGE = 352,
    ETHER = 353,
    SADDR = 354,
    DADDR = 355,
    TYPE = 356,
    VLAN = 357,
    ID = 358,
    CFI = 359,
    PCP = 360,
    ARP = 361,
    HTYPE = 362,
    PTYPE = 363,
    HLEN = 364,
    PLEN = 365,
    OPERATION = 366,
    IP = 367,
    HDRVERSION = 368,
    HDRLENGTH = 369,
    DSCP = 370,
    ECN = 371,
    LENGTH = 372,
    FRAG_OFF = 373,
    TTL = 374,
    PROTOCOL = 375,
    CHECKSUM = 376,
    ICMP = 377,
    CODE = 378,
    SEQUENCE = 379,
    GATEWAY = 380,
    MTU = 381,
    OPTIONS = 382,
    IP6 = 383,
    PRIORITY = 384,
    FLOWLABEL = 385,
    NEXTHDR = 386,
    HOPLIMIT = 387,
    ICMP6 = 388,
    PPTR = 389,
    MAXDELAY = 390,
    AH = 391,
    RESERVED = 392,
    SPI = 393,
    ESP = 394,
    COMP = 395,
    FLAGS = 396,
    CPI = 397,
    UDP = 398,
    SPORT = 399,
    DPORT = 400,
    UDPLITE = 401,
    CSUMCOV = 402,
    TCP = 403,
    ACKSEQ = 404,
    DOFF = 405,
    WINDOW = 406,
    URGPTR = 407,
    OPTION = 408,
    ECHO = 409,
    EOL = 410,
    MAXSEG = 411,
    NOOP = 412,
    SACK = 413,
    SACK0 = 414,
    SACK1 = 415,
    SACK2 = 416,
    SACK3 = 417,
    SACK_PERMITTED = 418,
    TIMESTAMP = 419,
    KIND = 420,
    COUNT = 421,
    LEFT = 422,
    RIGHT = 423,
    TSVAL = 424,
    TSECR = 425,
    DCCP = 426,
    SCTP = 427,
    VTAG = 428,
    RT = 429,
    RT0 = 430,
    RT2 = 431,
    RT4 = 432,
    SEG_LEFT = 433,
    ADDR = 434,
    LAST_ENT = 435,
    TAG = 436,
    SID = 437,
    HBH = 438,
    FRAG = 439,
    RESERVED2 = 440,
    MORE_FRAGMENTS = 441,
    DST = 442,
    MH = 443,
    META = 444,
    MARK = 445,
    IIF = 446,
    IIFNAME = 447,
    IIFTYPE = 448,
    OIF = 449,
    OIFNAME = 450,
    OIFTYPE = 451,
    SKUID = 452,
    SKGID = 453,
    NFTRACE = 454,
    RTCLASSID = 455,
    IBRIPORT = 456,
    OBRIPORT = 457,
    IBRIDGENAME = 458,
    OBRIDGENAME = 459,
    PKTTYPE = 460,
    CPU = 461,
    IIFGROUP = 462,
    OIFGROUP = 463,
    CGROUP = 464,
    CLASSID = 465,
    NEXTHOP = 466,
    CT = 467,
    L3PROTOCOL = 468,
    PROTO_SRC = 469,
    PROTO_DST = 470,
    ZONE = 471,
    DIRECTION = 472,
    EVENT = 473,
    EXPIRATION = 474,
    HELPER = 475,
    LABEL = 476,
    STATE = 477,
    STATUS = 478,
    ORIGINAL = 479,
    REPLY = 480,
    COUNTER = 481,
    NAME = 482,
    PACKETS = 483,
    BYTES = 484,
    AVGPKT = 485,
    COUNTERS = 486,
    QUOTAS = 487,
    LIMITS = 488,
    HELPERS = 489,
    LOG = 490,
    PREFIX = 491,
    GROUP = 492,
    SNAPLEN = 493,
    QUEUE_THRESHOLD = 494,
    LEVEL = 495,
    LIMIT = 496,
    RATE = 497,
    BURST = 498,
    OVER = 499,
    UNTIL = 500,
    QUOTA = 501,
    USED = 502,
    NANOSECOND = 503,
    MICROSECOND = 504,
    MILLISECOND = 505,
    SECOND = 506,
    MINUTE = 507,
    HOUR = 508,
    DAY = 509,
    WEEK = 510,
    _REJECT = 511,
    WITH = 512,
    ICMPX = 513,
    SNAT = 514,
    DNAT = 515,
    MASQUERADE = 516,
    REDIRECT = 517,
    RANDOM = 518,
    FULLY_RANDOM = 519,
    PERSISTENT = 520,
    QUEUE = 521,
    QUEUENUM = 522,
    BYPASS = 523,
    FANOUT = 524,
    DUP = 525,
    FWD = 526,
    NUMGEN = 527,
    INC = 528,
    MOD = 529,
    OFFSET = 530,
    JHASH = 531,
    SYMHASH = 532,
    SEED = 533,
    POSITION = 534,
    INDEX = 535,
    COMMENT = 536,
    XML = 537,
    JSON = 538,
    VM = 539,
    NOTRACK = 540,
    EXISTS = 541,
    MISSING = 542,
    EXTHDR = 543
  };
#endif
/* Tokens.  */
#define TOKEN_EOF 0
#define JUNK 258
#define NEWLINE 259
#define COLON 260
#define SEMICOLON 261
#define COMMA 262
#define DOT 263
#define EQ 264
#define NEQ 265
#define LT 266
#define GT 267
#define GTE 268
#define LTE 269
#define LSHIFT 270
#define RSHIFT 271
#define AMPERSAND 272
#define CARET 273
#define NOT 274
#define SLASH 275
#define ASTERISK 276
#define DASH 277
#define AT 278
#define VMAP 279
#define INCLUDE 280
#define DEFINE 281
#define REDEFINE 282
#define UNDEFINE 283
#define FIB 284
#define SOCKET 285
#define TRANSPARENT 286
#define HOOK 287
#define DEVICE 288
#define DEVICES 289
#define TABLE 290
#define TABLES 291
#define CHAIN 292
#define CHAINS 293
#define RULE 294
#define RULES 295
#define SETS 296
#define SET 297
#define ELEMENT 298
#define MAP 299
#define MAPS 300
#define FLOWTABLE 301
#define HANDLE 302
#define RULESET 303
#define TRACE 304
#define INET 305
#define NETDEV 306
#define ADD 307
#define UPDATE 308
#define REPLACE 309
#define CREATE 310
#define INSERT 311
#define DELETE 312
#define GET 313
#define LIST 314
#define RESET 315
#define FLUSH 316
#define RENAME 317
#define DESCRIBE 318
#define IMPORT 319
#define EXPORT 320
#define MONITOR 321
#define ALL 322
#define ACCEPT 323
#define DROP 324
#define CONTINUE 325
#define JUMP 326
#define GOTO 327
#define RETURN 328
#define TO 329
#define CONSTANT 330
#define INTERVAL 331
#define AUTOMERGE 332
#define TIMEOUT 333
#define GC_INTERVAL 334
#define ELEMENTS 335
#define POLICY 336
#define MEMORY 337
#define PERFORMANCE 338
#define SIZE 339
#define FLOW 340
#define OFFLOAD 341
#define METER 342
#define METERS 343
#define FLOWTABLES 344
#define NUM 345
#define STRING 346
#define QUOTED_STRING 347
#define ASTERISK_STRING 348
#define LL_HDR 349
#define NETWORK_HDR 350
#define TRANSPORT_HDR 351
#define BRIDGE 352
#define ETHER 353
#define SADDR 354
#define DADDR 355
#define TYPE 356
#define VLAN 357
#define ID 358
#define CFI 359
#define PCP 360
#define ARP 361
#define HTYPE 362
#define PTYPE 363
#define HLEN 364
#define PLEN 365
#define OPERATION 366
#define IP 367
#define HDRVERSION 368
#define HDRLENGTH 369
#define DSCP 370
#define ECN 371
#define LENGTH 372
#define FRAG_OFF 373
#define TTL 374
#define PROTOCOL 375
#define CHECKSUM 376
#define ICMP 377
#define CODE 378
#define SEQUENCE 379
#define GATEWAY 380
#define MTU 381
#define OPTIONS 382
#define IP6 383
#define PRIORITY 384
#define FLOWLABEL 385
#define NEXTHDR 386
#define HOPLIMIT 387
#define ICMP6 388
#define PPTR 389
#define MAXDELAY 390
#define AH 391
#define RESERVED 392
#define SPI 393
#define ESP 394
#define COMP 395
#define FLAGS 396
#define CPI 397
#define UDP 398
#define SPORT 399
#define DPORT 400
#define UDPLITE 401
#define CSUMCOV 402
#define TCP 403
#define ACKSEQ 404
#define DOFF 405
#define WINDOW 406
#define URGPTR 407
#define OPTION 408
#define ECHO 409
#define EOL 410
#define MAXSEG 411
#define NOOP 412
#define SACK 413
#define SACK0 414
#define SACK1 415
#define SACK2 416
#define SACK3 417
#define SACK_PERMITTED 418
#define TIMESTAMP 419
#define KIND 420
#define COUNT 421
#define LEFT 422
#define RIGHT 423
#define TSVAL 424
#define TSECR 425
#define DCCP 426
#define SCTP 427
#define VTAG 428
#define RT 429
#define RT0 430
#define RT2 431
#define RT4 432
#define SEG_LEFT 433
#define ADDR 434
#define LAST_ENT 435
#define TAG 436
#define SID 437
#define HBH 438
#define FRAG 439
#define RESERVED2 440
#define MORE_FRAGMENTS 441
#define DST 442
#define MH 443
#define META 444
#define MARK 445
#define IIF 446
#define IIFNAME 447
#define IIFTYPE 448
#define OIF 449
#define OIFNAME 450
#define OIFTYPE 451
#define SKUID 452
#define SKGID 453
#define NFTRACE 454
#define RTCLASSID 455
#define IBRIPORT 456
#define OBRIPORT 457
#define IBRIDGENAME 458
#define OBRIDGENAME 459
#define PKTTYPE 460
#define CPU 461
#define IIFGROUP 462
#define OIFGROUP 463
#define CGROUP 464
#define CLASSID 465
#define NEXTHOP 466
#define CT 467
#define L3PROTOCOL 468
#define PROTO_SRC 469
#define PROTO_DST 470
#define ZONE 471
#define DIRECTION 472
#define EVENT 473
#define EXPIRATION 474
#define HELPER 475
#define LABEL 476
#define STATE 477
#define STATUS 478
#define ORIGINAL 479
#define REPLY 480
#define COUNTER 481
#define NAME 482
#define PACKETS 483
#define BYTES 484
#define AVGPKT 485
#define COUNTERS 486
#define QUOTAS 487
#define LIMITS 488
#define HELPERS 489
#define LOG 490
#define PREFIX 491
#define GROUP 492
#define SNAPLEN 493
#define QUEUE_THRESHOLD 494
#define LEVEL 495
#define LIMIT 496
#define RATE 497
#define BURST 498
#define OVER 499
#define UNTIL 500
#define QUOTA 501
#define USED 502
#define NANOSECOND 503
#define MICROSECOND 504
#define MILLISECOND 505
#define SECOND 506
#define MINUTE 507
#define HOUR 508
#define DAY 509
#define WEEK 510
#define _REJECT 511
#define WITH 512
#define ICMPX 513
#define SNAT 514
#define DNAT 515
#define MASQUERADE 516
#define REDIRECT 517
#define RANDOM 518
#define FULLY_RANDOM 519
#define PERSISTENT 520
#define QUEUE 521
#define QUEUENUM 522
#define BYPASS 523
#define FANOUT 524
#define DUP 525
#define FWD 526
#define NUMGEN 527
#define INC 528
#define MOD 529
#define OFFSET 530
#define JHASH 531
#define SYMHASH 532
#define SEED 533
#define POSITION 534
#define INDEX 535
#define COMMENT 536
#define XML 537
#define JSON 538
#define VM 539
#define NOTRACK 540
#define EXISTS 541
#define MISSING 542
#define EXTHDR 543

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 131 "parser_bison.y" /* yacc.c:355  */

	uint64_t		val;
	const char *		string;

	struct list_head	*list;
	struct cmd		*cmd;
	struct handle		handle;
	struct table		*table;
	struct chain		*chain;
	struct rule		*rule;
	struct stmt		*stmt;
	struct expr		*expr;
	struct set		*set;
	struct obj		*obj;
	struct flowtable	*flowtable;
	struct counter		*counter;
	struct quota		*quota;
	struct ct		*ct;
	struct limit		*limit;
	const struct datatype	*datatype;
	struct handle_spec	handle_spec;
	struct position_spec	position_spec;
	const struct exthdr_desc *exthdr_desc;

#line 815 "parser_bison.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int nft_parse (struct nft_ctx *nft, void *scanner, struct parser_state *state);

#endif /* !YY_NFT_PARSER_BISON_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 845 "parser_bison.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4961

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  298
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  294
/* YYNRULES -- Number of rules.  */
#define YYNRULES  897
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1413

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   543

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,   293,     2,     2,     2,
     294,   295,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   289,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   296,     2,   297,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   290,   292,   291,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   744,   744,   745,   763,   764,   767,   768,   771,   779,
     793,   800,   811,   819,   820,   821,   822,   854,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,   865,   866,
     867,   868,   871,   875,   882,   886,   894,   898,   902,   909,
     916,   920,   927,   936,   940,   944,   949,   955,   961,   965,
     972,   976,   984,   991,   998,  1002,  1009,  1018,  1022,  1026,
    1030,  1036,  1042,  1046,  1050,  1054,  1058,  1062,  1066,  1070,
    1074,  1078,  1082,  1086,  1090,  1094,  1098,  1102,  1106,  1112,
    1118,  1122,  1126,  1130,  1134,  1138,  1142,  1146,  1150,  1154,
    1158,  1162,  1166,  1170,  1174,  1178,  1182,  1186,  1190,  1194,
    1198,  1202,  1206,  1210,  1214,  1218,  1224,  1228,  1232,  1236,
    1240,  1244,  1250,  1254,  1258,  1262,  1266,  1270,  1274,  1280,
    1287,  1293,  1301,  1307,  1315,  1324,  1325,  1328,  1329,  1330,
    1331,  1332,  1333,  1334,  1335,  1338,  1339,  1342,  1343,  1344,
    1347,  1356,  1362,  1376,  1377,  1378,  1379,  1380,  1391,  1401,
    1412,  1422,  1433,  1444,  1453,  1467,  1473,  1474,  1475,  1476,
    1477,  1478,  1486,  1491,  1492,  1493,  1494,  1499,  1504,  1509,
    1514,  1519,  1524,  1527,  1528,  1531,  1535,  1538,  1539,  1540,
    1544,  1549,  1550,  1551,  1552,  1557,  1568,  1577,  1586,  1595,
    1600,  1605,  1608,  1612,  1618,  1619,  1623,  1628,  1629,  1630,
    1631,  1644,  1650,  1657,  1662,  1667,  1670,  1678,  1692,  1693,
    1713,  1718,  1719,  1720,  1721,  1728,  1729,  1730,  1731,  1738,
    1739,  1740,  1741,  1747,  1748,  1749,  1750,  1757,  1758,  1759,
    1760,  1761,  1764,  1792,  1793,  1796,  1797,  1800,  1811,  1812,
    1815,  1818,  1819,  1820,  1823,  1838,  1839,  1842,  1843,  1844,
    1845,  1846,  1847,  1850,  1859,  1868,  1876,  1884,  1892,  1900,
    1908,  1917,  1924,  1931,  1939,  1947,  1955,  1963,  1971,  1979,
    1983,  1988,  1996,  2003,  2010,  2022,  2026,  2033,  2037,  2043,
    2055,  2061,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2090,  2094,  2100,  2106,  2111,  2120,  2125,  2130,
    2133,  2139,  2144,  2152,  2153,  2155,  2159,  2167,  2171,  2174,
    2178,  2184,  2185,  2188,  2194,  2198,  2201,  2206,  2211,  2216,
    2221,  2226,  2232,  2262,  2266,  2270,  2274,  2278,  2284,  2288,
    2291,  2295,  2301,  2310,  2329,  2337,  2338,  2339,  2342,  2343,
    2346,  2347,  2362,  2378,  2386,  2387,  2388,  2391,  2392,  2393,
    2394,  2409,  2410,  2411,  2412,  2413,  2416,  2419,  2426,  2430,
    2441,  2452,  2462,  2468,  2471,  2472,  2475,  2476,  2477,  2478,
    2479,  2480,  2481,  2482,  2483,  2484,  2487,  2488,  2492,  2498,
    2499,  2505,  2506,  2512,  2513,  2519,  2522,  2523,  2542,  2543,
    2546,  2550,  2553,  2559,  2565,  2576,  2577,  2578,  2581,  2582,
    2583,  2586,  2590,  2594,  2599,  2604,  2608,  2612,  2618,  2619,
    2622,  2625,  2629,  2634,  2640,  2641,  2644,  2647,  2651,  2655,
    2659,  2664,  2671,  2676,  2684,  2685,  2688,  2693,  2702,  2703,
    2709,  2710,  2711,  2714,  2715,  2718,  2724,  2728,  2731,  2736,
    2742,  2743,  2749,  2750,  2753,  2754,  2757,  2763,  2770,  2779,
    2780,  2783,  2792,  2799,  2802,  2808,  2812,  2815,  2821,  2830,
    2841,  2847,  2865,  2866,  2873,  2882,  2893,  2894,  2895,  2896,
    2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,  2905,  2908,
    2931,  2932,  2933,  2936,  2937,  2938,  2939,  2940,  2943,  2947,
    2950,  2951,  2955,  2961,  2962,  2968,  2969,  2975,  2976,  2982,
    2985,  2986,  3005,  3011,  3017,  3018,  3019,  3022,  3028,  3029,
    3030,  3033,  3040,  3045,  3050,  3053,  3057,  3061,  3067,  3068,
    3075,  3081,  3082,  3085,  3091,  3095,  3098,  3102,  3108,  3109,
    3112,  3113,  3116,  3117,  3120,  3131,  3139,  3160,  3168,  3171,
    3172,  3175,  3190,  3197,  3202,  3213,  3235,  3243,  3247,  3251,
    3257,  3263,  3271,  3272,  3273,  3276,  3277,  3281,  3287,  3288,
    3294,  3295,  3301,  3302,  3308,  3311,  3312,  3331,  3332,  3335,
    3343,  3344,  3345,  3346,  3347,  3348,  3349,  3350,  3351,  3352,
    3353,  3354,  3357,  3358,  3359,  3360,  3361,  3368,  3375,  3382,
    3389,  3396,  3403,  3410,  3417,  3424,  3431,  3438,  3441,  3442,
    3443,  3444,  3445,  3446,  3449,  3453,  3457,  3461,  3465,  3469,
    3475,  3479,  3483,  3499,  3500,  3503,  3504,  3505,  3506,  3509,
    3510,  3511,  3512,  3513,  3514,  3515,  3516,  3517,  3518,  3519,
    3520,  3521,  3522,  3523,  3524,  3525,  3526,  3527,  3528,  3531,
    3535,  3539,  3553,  3557,  3563,  3569,  3572,  3573,  3576,  3577,
    3580,  3586,  3591,  3596,  3602,  3603,  3606,  3610,  3630,  3631,
    3632,  3635,  3639,  3643,  3649,  3650,  3653,  3654,  3655,  3656,
    3657,  3658,  3659,  3660,  3661,  3662,  3663,  3664,  3665,  3666,
    3667,  3670,  3671,  3672,  3673,  3674,  3675,  3676,  3679,  3680,
    3683,  3684,  3685,  3686,  3689,  3690,  3693,  3699,  3707,  3720,
    3726,  3735,  3736,  3737,  3738,  3739,  3740,  3741,  3742,  3743,
    3744,  3745,  3746,  3747,  3748,  3749,  3750,  3753,  3762,  3763,
    3764,  3767,  3773,  3774,  3775,  3778,  3784,  3785,  3786,  3787,
    3790,  3796,  3797,  3798,  3799,  3800,  3803,  3809,  3810,  3811,
    3812,  3813,  3814,  3815,  3816,  3817,  3818,  3819,  3820,  3823,
    3829,  3830,  3831,  3832,  3833,  3834,  3835,  3838,  3844,  3845,
    3846,  3847,  3848,  3849,  3850,  3851,  3852,  3854,  3860,  3861,
    3862,  3863,  3864,  3865,  3866,  3867,  3870,  3876,  3877,  3878,
    3879,  3880,  3883,  3889,  3890,  3893,  3899,  3900,  3901,  3904,
    3910,  3911,  3912,  3913,  3916,  3922,  3923,  3924,  3925,  3928,
    3932,  3936,  3943,  3944,  3945,  3946,  3947,  3948,  3949,  3950,
    3951,  3952,  3955,  3956,  3957,  3958,  3959,  3960,  3961,  3962,
    3963,  3964,  3965,  3966,  3969,  3970,  3971,  3972,  3973,  3974,
    3975,  3976,  3979,  3985,  3986,  3987,  3990,  3996,  3997,  3998,
    3999,  4002,  4003,  4004,  4005,  4006,  4007,  4008,  4009,  4012,
    4018,  4019,  4022,  4028,  4029,  4030,  4031,  4034,  4040,  4046,
    4052,  4055,  4061,  4062,  4063,  4064,  4070,  4076,  4077,  4078,
    4079,  4080,  4081,  4084,  4090,  4091,  4094,  4100,  4101,  4102,
    4103,  4104,  4107,  4121,  4122,  4123,  4124,  4125
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "$undefined", "\"junk\"", "\"newline\"",
  "\"colon\"", "\"semicolon\"", "\"comma\"", "\".\"", "\"==\"", "\"!=\"",
  "\"<\"", "\">\"", "\">=\"", "\"<=\"", "\"<<\"", "\">>\"", "\"&\"",
  "\"^\"", "\"!\"", "\"/\"", "\"*\"", "\"-\"", "\"@\"", "\"vmap\"",
  "\"include\"", "\"define\"", "\"redefine\"", "\"undefine\"", "\"fib\"",
  "\"socket\"", "\"transparent\"", "\"hook\"", "\"device\"", "\"devices\"",
  "\"table\"", "\"tables\"", "\"chain\"", "\"chains\"", "\"rule\"",
  "\"rules\"", "\"sets\"", "\"set\"", "\"element\"", "\"map\"", "\"maps\"",
  "\"flowtable\"", "\"handle\"", "\"ruleset\"", "\"trace\"", "\"inet\"",
  "\"netdev\"", "\"add\"", "\"update\"", "\"replace\"", "\"create\"",
  "\"insert\"", "\"delete\"", "\"get\"", "\"list\"", "\"reset\"",
  "\"flush\"", "\"rename\"", "\"describe\"", "\"import\"", "\"export\"",
  "\"monitor\"", "\"all\"", "\"accept\"", "\"drop\"", "\"continue\"",
  "\"jump\"", "\"goto\"", "\"return\"", "\"to\"", "\"constant\"",
  "\"interval\"", "\"auto-merge\"", "\"timeout\"", "\"gc-interval\"",
  "\"elements\"", "\"policy\"", "\"memory\"", "\"performance\"",
  "\"size\"", "\"flow\"", "\"offload\"", "\"meter\"", "\"meters\"",
  "\"flowtables\"", "\"number\"", "\"string\"", "\"quoted string\"",
  "\"string with a trailing asterisk\"", "\"ll\"", "\"nh\"", "\"th\"",
  "\"bridge\"", "\"ether\"", "\"saddr\"", "\"daddr\"", "\"type\"",
  "\"vlan\"", "\"id\"", "\"cfi\"", "\"pcp\"", "\"arp\"", "\"htype\"",
  "\"ptype\"", "\"hlen\"", "\"plen\"", "\"operation\"", "\"ip\"",
  "\"version\"", "\"hdrlength\"", "\"dscp\"", "\"ecn\"", "\"length\"",
  "\"frag-off\"", "\"ttl\"", "\"protocol\"", "\"checksum\"", "\"icmp\"",
  "\"code\"", "\"seq\"", "\"gateway\"", "\"mtu\"", "\"options\"",
  "\"ip6\"", "\"priority\"", "\"flowlabel\"", "\"nexthdr\"",
  "\"hoplimit\"", "\"icmpv6\"", "\"param-problem\"", "\"max-delay\"",
  "\"ah\"", "\"reserved\"", "\"spi\"", "\"esp\"", "\"comp\"", "\"flags\"",
  "\"cpi\"", "\"udp\"", "\"sport\"", "\"dport\"", "\"udplite\"",
  "\"csumcov\"", "\"tcp\"", "\"ackseq\"", "\"doff\"", "\"window\"",
  "\"urgptr\"", "\"option\"", "\"echo\"", "\"eol\"", "\"maxseg\"",
  "\"noop\"", "\"sack\"", "\"sack0\"", "\"sack1\"", "\"sack2\"",
  "\"sack3\"", "\"sack-permitted\"", "\"timestamp\"", "\"kind\"",
  "\"count\"", "\"left\"", "\"right\"", "\"tsval\"", "\"tsecr\"",
  "\"dccp\"", "\"sctp\"", "\"vtag\"", "\"rt\"", "\"rt0\"", "\"rt2\"",
  "\"srh\"", "\"seg-left\"", "\"addr\"", "\"last-entry\"", "\"tag\"",
  "\"sid\"", "\"hbh\"", "\"frag\"", "\"reserved2\"", "\"more-fragments\"",
  "\"dst\"", "\"mh\"", "\"meta\"", "\"mark\"", "\"iif\"", "\"iifname\"",
  "\"iiftype\"", "\"oif\"", "\"oifname\"", "\"oiftype\"", "\"skuid\"",
  "\"skgid\"", "\"nftrace\"", "\"rtclassid\"", "\"ibriport\"",
  "\"obriport\"", "\"ibrname\"", "\"obrname\"", "\"pkttype\"", "\"cpu\"",
  "\"iifgroup\"", "\"oifgroup\"", "\"cgroup\"", "\"classid\"",
  "\"nexthop\"", "\"ct\"", "\"l3proto\"", "\"proto-src\"", "\"proto-dst\"",
  "\"zone\"", "\"direction\"", "\"event\"", "\"expiration\"", "\"helper\"",
  "\"label\"", "\"state\"", "\"status\"", "\"original\"", "\"reply\"",
  "\"counter\"", "\"name\"", "\"packets\"", "\"bytes\"", "\"avgpkt\"",
  "\"counters\"", "\"quotas\"", "\"limits\"", "\"helpers\"", "\"log\"",
  "\"prefix\"", "\"group\"", "\"snaplen\"", "\"queue-threshold\"",
  "\"level\"", "\"limit\"", "\"rate\"", "\"burst\"", "\"over\"",
  "\"until\"", "\"quota\"", "\"used\"", "\"nanosecond\"",
  "\"microsecond\"", "\"millisecond\"", "\"second\"", "\"minute\"",
  "\"hour\"", "\"day\"", "\"week\"", "\"reject\"", "\"with\"", "\"icmpx\"",
  "\"snat\"", "\"dnat\"", "\"masquerade\"", "\"redirect\"", "\"random\"",
  "\"fully-random\"", "\"persistent\"", "\"queue\"", "\"num\"",
  "\"bypass\"", "\"fanout\"", "\"dup\"", "\"fwd\"", "\"numgen\"",
  "\"inc\"", "\"mod\"", "\"offset\"", "\"jhash\"", "\"symhash\"",
  "\"seed\"", "\"position\"", "\"index\"", "\"comment\"", "\"xml\"",
  "\"json\"", "\"vm\"", "\"notrack\"", "\"exists\"", "\"missing\"",
  "\"exthdr\"", "'='", "'{'", "'}'", "'|'", "'$'", "'('", "')'", "'['",
  "']'", "$accept", "input", "stmt_separator", "opt_newline",
  "common_block", "line", "base_cmd", "add_cmd", "replace_cmd",
  "create_cmd", "insert_cmd", "delete_cmd", "get_cmd", "list_cmd",
  "reset_cmd", "flush_cmd", "rename_cmd", "import_cmd", "export_cmd",
  "monitor_cmd", "monitor_event", "monitor_object", "monitor_format",
  "markup_format", "describe_cmd", "table_block_alloc", "table_options",
  "table_block", "chain_block_alloc", "chain_block", "set_block_alloc",
  "set_block", "set_block_expr", "set_flag_list", "set_flag",
  "map_block_alloc", "map_block", "set_mechanism", "set_policy_spec",
  "flowtable_block_alloc", "flowtable_block", "flowtable_expr",
  "flowtable_list_expr", "flowtable_expr_member", "data_type_atom_expr",
  "data_type_expr", "obj_block_alloc", "counter_block", "quota_block",
  "ct_helper_block", "limit_block", "type_identifier", "hook_spec",
  "prio_spec", "dev_spec", "policy_spec", "chain_policy", "identifier",
  "string", "time_spec", "family_spec", "family_spec_explicit",
  "table_spec", "tableid_spec", "chain_spec", "chainid_spec",
  "chain_identifier", "set_spec", "setid_spec", "set_identifier",
  "flowtable_spec", "flowtable_identifier", "obj_spec", "objid_spec",
  "obj_identifier", "handle_spec", "position_spec", "index_spec",
  "rule_position", "ruleid_spec", "comment_spec", "ruleset_spec", "rule",
  "rule_alloc", "stmt_list", "stmt", "verdict_stmt", "verdict_map_stmt",
  "verdict_map_expr", "verdict_map_list_expr",
  "verdict_map_list_member_expr", "connlimit_stmt", "counter_stmt",
  "counter_stmt_alloc", "counter_args", "counter_arg", "log_stmt",
  "log_stmt_alloc", "log_args", "log_arg", "level_type", "log_flags",
  "log_flags_tcp", "log_flag_tcp", "limit_stmt", "quota_mode",
  "quota_unit", "quota_used", "quota_stmt", "limit_mode", "limit_burst",
  "time_unit", "reject_stmt", "reject_stmt_alloc", "reject_opts",
  "nat_stmt", "nat_stmt_alloc", "primary_stmt_expr", "shift_stmt_expr",
  "and_stmt_expr", "exclusive_or_stmt_expr", "inclusive_or_stmt_expr",
  "basic_stmt_expr", "concat_stmt_expr", "map_stmt_expr_set",
  "map_stmt_expr", "prefix_stmt_expr", "range_stmt_expr", "wildcard_expr",
  "multiton_stmt_expr", "stmt_expr", "nat_stmt_args", "masq_stmt",
  "masq_stmt_alloc", "masq_stmt_args", "redir_stmt", "redir_stmt_alloc",
  "redir_stmt_arg", "dup_stmt", "fwd_key_proto", "fwd_stmt",
  "nf_nat_flags", "nf_nat_flag", "queue_stmt", "queue_stmt_alloc",
  "queue_stmt_args", "queue_stmt_arg", "queue_stmt_flags",
  "queue_stmt_flag", "set_elem_expr_stmt", "set_elem_expr_stmt_alloc",
  "set_stmt", "set_stmt_op", "map_stmt", "meter_stmt",
  "flow_stmt_legacy_alloc", "flow_stmt_opts", "flow_stmt_opt",
  "meter_stmt_alloc", "match_stmt", "variable_expr", "symbol_expr",
  "integer_expr", "primary_expr", "fib_expr", "fib_result", "fib_flag",
  "fib_tuple", "shift_expr", "and_expr", "exclusive_or_expr",
  "inclusive_or_expr", "basic_expr", "concat_expr", "prefix_rhs_expr",
  "range_rhs_expr", "multiton_rhs_expr", "map_expr", "expr", "set_expr",
  "set_list_expr", "set_list_member_expr", "meter_key_expr",
  "meter_key_expr_alloc", "set_elem_expr", "set_elem_expr_alloc",
  "set_elem_options", "set_elem_option", "set_lhs_expr", "set_rhs_expr",
  "initializer_expr", "counter_config", "counter_obj", "quota_config",
  "quota_obj", "ct_obj_type", "ct_l4protoname", "ct_helper_config",
  "ct_obj_alloc", "limit_config", "limit_obj", "relational_expr",
  "list_rhs_expr", "rhs_expr", "shift_rhs_expr", "and_rhs_expr",
  "exclusive_or_rhs_expr", "inclusive_or_rhs_expr", "basic_rhs_expr",
  "concat_rhs_expr", "boolean_keys", "boolean_expr", "keyword_expr",
  "primary_rhs_expr", "relational_op", "verdict_expr", "meta_expr",
  "meta_key", "meta_key_qualified", "meta_key_unqualified", "meta_stmt",
  "socket_expr", "socket_key", "offset_opt", "numgen_type", "numgen_expr",
  "hash_expr", "nf_key_proto", "rt_expr", "rt_key", "ct_expr", "ct_dir",
  "ct_key", "ct_key_dir", "ct_key_proto_field", "ct_key_dir_optional",
  "symbol_stmt_expr", "list_stmt_expr", "ct_stmt", "payload_stmt",
  "payload_expr", "payload_raw_expr", "payload_base_spec", "eth_hdr_expr",
  "eth_hdr_field", "vlan_hdr_expr", "vlan_hdr_field", "arp_hdr_expr",
  "arp_hdr_field", "ip_hdr_expr", "ip_hdr_field", "icmp_hdr_expr",
  "icmp_hdr_field", "ip6_hdr_expr", "ip6_hdr_field", "icmp6_hdr_expr",
  "icmp6_hdr_field", "auth_hdr_expr", "auth_hdr_field", "esp_hdr_expr",
  "esp_hdr_field", "comp_hdr_expr", "comp_hdr_field", "udp_hdr_expr",
  "udp_hdr_field", "udplite_hdr_expr", "udplite_hdr_field", "tcp_hdr_expr",
  "tcp_hdr_field", "tcp_hdr_option_type", "tcp_hdr_option_field",
  "dccp_hdr_expr", "dccp_hdr_field", "sctp_hdr_expr", "sctp_hdr_field",
  "exthdr_expr", "hbh_hdr_expr", "hbh_hdr_field", "rt_hdr_expr",
  "rt_hdr_field", "rt0_hdr_expr", "rt0_hdr_field", "rt2_hdr_expr",
  "rt2_hdr_field", "rt4_hdr_expr", "rt4_hdr_field", "frag_hdr_expr",
  "frag_hdr_field", "dst_hdr_expr", "dst_hdr_field", "mh_hdr_expr",
  "mh_hdr_field", "exthdr_exists_expr", "exthdr_key", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,    61,
     123,   125,   124,    36,    40,    41,    91,    93
};
# endif

#define YYPACT_NINF -1095

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1095)))

#define YYTABLE_NINF -706

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1095,  4683, -1095,   439, -1095, -1095,    28,    70,    70,    70,
     661,   661,   661,   661,   661,   661,   661, -1095, -1095,  1847,
     126,   585,   183,  1601,   197,  4715,   444,   809,   215,  4061,
      91,   139,   173, -1095, -1095, -1095, -1095,    66,   661,   661,
     661, -1095, -1095, -1095,   420, -1095,    70, -1095,    70,    -7,
    3727, -1095,   439, -1095,    60,    67,   439,    79,   142,  3727,
      70, -1095,   -98, -1095,    70, -1095, -1095,   661, -1095,   661,
     661,   661,   661,   661,   661,    74,   661,   661,   661, -1095,
     661, -1095,   661,   661,   661,   661,   661,   661,   661,    85,
     661,   661,   661, -1095,   661, -1095,   661,   661,   661,   661,
     390,   661,   661,   661,   661,   393,   661,   661,   661,   166,
     661,   664,  1396,  1406,   661,   661, -1095,   661,  1456,  1505,
     661, -1095,   661,   661,   661,   661,   661,   369,   661, -1095,
     661, -1095,   646,   277,   419, -1095, -1095, -1095, -1095,   438,
     674,   979,  1350,  1164,   926,   912,   586,   210,   353,   449,
     325,  1630,    34,     4,  1085,   275,   278,   308,   148,   432,
     254,   453,  2141, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095,  1640,   -89,  3934,   186,   427,    70,  4061,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095,   361, -1095, -1095,   182, -1095, -1095,   361, -1095, -1095,
   -1095, -1095,   859,   661,    70,   246,   237,   285, -1095, -1095,
   -1095, -1095,   408,   434,   456, -1095, -1095, -1095,   625, -1095,
   -1095, -1095, -1095, -1095,    70,    70, -1095,   423,    70,  2415,
    2601,   324, -1095,    64,    38, -1095, -1095, -1095, -1095, -1095,
   -1095,   479,   111, -1095,   555, -1095,   284,  3727, -1095, -1095,
   -1095, -1095, -1095,   343, -1095,   198, -1095, -1095, -1095,   311,
   -1095,  2664, -1095,   130, -1095,   134, -1095, -1095, -1095,   518,
   -1095,    90, -1095, -1095,   540, -1095, -1095, -1095,   673,   562,
     563,   291, -1095,   383, -1095,  3195, -1095, -1095, -1095,   544,
   -1095, -1095, -1095,   546, -1095,  3259,  3259, -1095,   302,   305,
   -1095, -1095,   314, -1095, -1095, -1095,   323, -1095,   333,   579,
    3727,    79,   142, -1095,   -98, -1095, -1095,   661,   246,   237,
     285,  3727,   123, -1095, -1095,   128, -1095, -1095, -1095,   160,
   -1095, -1095,   -98, -1095, -1095, -1095,   661,   185, -1095, -1095,
   -1095, -1095, -1095, -1095,   -98, -1095, -1095, -1095, -1095, -1095,
     661, -1095, -1095, -1095, -1095, -1095,   661,   661, -1095, -1095,
   -1095,   604,   661, -1095,   661, -1095,   661, -1095,   661, -1095,
   -1095, -1095, -1095,   661, -1095,   661, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095,   661, -1095,    70, -1095, -1095, -1095, -1095,
     623, -1095, -1095, -1095, -1095, -1095,   640,    18, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,  1967, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,    46, -1095,
   -1095,   368, -1095, -1095, -1095, -1095, -1095, -1095,   378, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095,  1301, -1095, -1095,
   -1095, -1095,   381,   313,   410,   567, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095,   402, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095,   361, -1095, -1095,   618, -1095, -1095,
     447, -1095, -1095, -1095, -1095,   626, -1095, -1095, -1095, -1095,
   -1095,  4061, -1095, -1095,   696,    -6,   683,   692,    14,  1301,
     702,  3517,  3517,   447,  3517,   659,  3517,  3517, -1095, -1095,
     682, -1095,  3259,    19, -1095,   731, -1095, -1095,   698,   703,
     343, -1095,   364,   731,   705,   708,   717,   731,   198, -1095,
      78, -1095,  3517, -1095, -1095,  2827,   438,   674,   979,  1350,
   -1095,   926,    43, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095,   744,   752,   764,   523,   471,   320, -1095, -1095, -1095,
   -1095, -1095,   820,   564,   823, -1095, -1095, -1095,   825, -1095,
   -1095, -1095, -1095, -1095,   832,   834, -1095,   838, -1095, -1095,
   -1095, -1095,   848, -1095,  2990, -1095,   848,  3517, -1095, -1095,
     518, -1095,   853, -1095,    70,   571,    70,    12, -1095,  4284,
    4284,  4284,  4284,  4284,  4061,    42,  3259, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,  4284,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095,   860, -1095,   747,
     847,   855,   587,   140,   863, -1095, -1095, -1095,  3259,  3517,
    3517,   439,   860, -1095,   439, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095,   592,   593,   596, -1095,   599,   603, -1095, -1095,
   -1095, -1095, -1095,   787,   812,   813, -1095, -1095,   815, -1095,
   -1095, -1095, -1095,   661, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095,   816,   277, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
     537, -1095,   819,   828, -1095, -1095, -1095, -1095, -1095, -1095,
     595, -1095, -1095,   829,   833,   635, -1095, -1095, -1095,   608,
     686, -1095, -1095,   837,    15,    90,    36,   924,   731,   846,
    4061,  3517,  3517, -1095,   851,   896,  3517, -1095, -1095,   856,
   -1095,    15,   910, -1095,  3517, -1095,   555,   767,    36, -1095,
     493,   863,   555, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
     830,   136, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095,   861,   862,   887,   864, -1095,  3517,   953,  4426,  4284,
    4426,  4426,  4426,   870,  4426,  4426,     5,  3517,   848,  1695,
    1695,  3517,   564,  3517,   564, -1095, -1095,   532,  4061, -1095,
    4061, -1095, -1095, -1095,   747,   847,   855, -1095,    70,   555,
   -1095, -1095,   671,  4284,  4284,  4284,  4284,  4284,  4284,  4284,
     878,  4284,  4284, -1095, -1095, -1095, -1095, -1095,   455,  1908,
     572,  1649,   515, -1095, -1095, -1095, -1095, -1095,   691, -1095,
   -1095, -1095, -1095, -1095, -1095,   977, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095,   689,   694, -1095, -1095,
   -1095,   635,   135,   899, -1095, -1095,   905,   106, -1095, -1095,
     749, -1095,   907, -1095,    36, -1095, -1095,   713,   924,  3727,
      36, -1095, -1095, -1095,  3517, -1095,   107,   749,  3517,   972,
   -1095,  4220, -1095,    36,  3259, -1095, -1095, -1095, -1095,  1002,
   -1095,   921,   927, -1095,   928, -1095,  3517, -1095, -1095, -1095,
   -1095,   744,   752,   764, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095,   564, -1095,   564,   848, -1095,
      49,  3727, -1095,  3411,    31, -1095, -1095, -1095, -1095, -1095,
     747,   847,   855, -1095, -1095, -1095, -1095,    70,    70,    70,
      70,   930,   802,    70,    70,    70, -1095, -1095, -1095,   439,
     769,   933, -1095, -1095, -1095,   439,   439,   439, -1095,   907,
     907,   738,   736,   939,   155,   527, -1095, -1095, -1095,   439,
     907,   741,   155,   527, -1095, -1095, -1095,   439,   957,   755,
   -1095, -1095, -1095,   808,  2182,   581,  1657,   530, -1095,   963,
   -1095, -1095, -1095,   969, -1095, -1095,   944, -1095,   857,   818,
     973, -1095, -1095, -1095, -1095,  4061,   774,    36, -1095,   857,
     818, -1095, -1095,  3517,   555, -1095,   863, -1095,   136, -1095,
   -1095, -1095, -1095,   848,   848,  4061, -1095,   776,  1063,   555,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,    70,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,  1038, -1095,
   -1095, -1095,   439,   439,   -98, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095,   519, -1095, -1095, -1095, -1095,
     679, -1095, -1095,   439,   -98,   409,   679, -1095,   942,   783,
   -1095, -1095, -1095, -1095, -1095,  1079, -1095,   635,   982,   661,
     439, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,   818,
     986, -1095,    15,  3727, -1095,   818, -1095, -1095, -1095, -1095,
     786, -1095,   883,  3411, -1095,   788,   789,   791,   803, -1095,
     805,   806,   807,  1007, -1095, -1095, -1095,   155, -1095,   527,
   -1095, -1095, -1095,   675, -1095,   109,  1009,   439,   439, -1095,
     983,   439, -1095, -1095,    21, -1095,   811, -1095, -1095,   555,
   -1095, -1095, -1095, -1095,   826, -1095, -1095, -1095,  1082, -1095,
   -1095,   439,   439,   439,   519,  1027, -1095,   439, -1095,    32,
   -1095, -1095, -1095,   263, -1095, -1095, -1095, -1095, -1095, -1095,
    2456,  1398,  1665,  1118, -1095,   886,   286,   241,  1029,   992,
   -1095, -1095, -1095, -1095, -1095, -1095,   103, -1095, -1095, -1095,
     439,   439,   439,   439,   439,  1220,   439, -1095, -1095, -1095,
     439, -1095, -1095, -1095,   439, -1095, -1095, -1095, -1095,   109,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095,   439, -1095, -1095,
   -1095, -1095, -1095
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     1,     0,     4,     5,     0,     0,     0,     0,
     245,   245,   245,   245,   245,   245,   245,   249,   252,   245,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   125,   251,   250,   247,   248,     0,   245,   245,
     245,    14,    13,     3,     0,    17,     0,   246,     0,   269,
       0,    12,     0,   240,     0,     0,     0,    32,    34,     0,
       0,   162,     0,   180,     0,   196,    18,   245,    19,   245,
     245,   245,   245,   245,   245,     0,   245,   245,   245,    20,
     245,    21,   245,   245,   245,   245,   245,   245,   245,     0,
     245,   245,   245,    22,   245,    23,   245,   275,   245,   275,
     275,   245,   245,   275,   275,     0,   245,   275,   275,     0,
     245,   275,   275,   275,   245,   245,    24,   245,   275,   275,
     245,    25,   245,   245,   245,   245,   275,     0,   245,    26,
     245,    27,     0,     0,     0,   475,   241,   242,   243,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,     0,     0,     0,     0,     0,     0,     0,
      31,   473,   472,   476,   477,   140,   487,   481,   621,   482,
     485,   486,   483,   484,   478,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   479,   851,   852,   853,   854,   855,   856,   857,   858,
     480,     0,   137,   138,     0,    28,   121,     0,    29,   123,
     126,    30,   127,   245,     0,    42,     0,   347,    16,    15,
     253,   255,     0,     0,     0,   271,   270,   272,     0,   459,
     460,   614,   615,   616,     0,     0,   619,   464,     0,     0,
       0,   315,   323,     0,   347,   367,   374,   375,   420,   426,
     445,     0,     0,   652,     7,    37,   277,   279,   280,   282,
     303,   285,   286,   313,   289,   321,   290,   291,   292,   368,
     293,     0,   296,   419,   297,   425,   298,   299,   294,   443,
     300,     0,   301,   284,     0,   463,   283,   500,   503,   505,
     507,   509,   510,   518,   520,     0,   519,   470,   302,   621,
     288,   295,   287,   478,     8,     0,     0,    11,     0,     0,
      36,   258,     0,    40,   174,   173,     0,   261,     0,     0,
       0,    48,    50,   162,     0,   180,   196,   245,    56,     0,
     347,     0,     0,    62,    63,     0,    64,    65,    66,     0,
      67,    68,     0,    69,    71,   548,   245,     0,    72,    73,
      77,    78,    74,    75,     0,    80,   276,    81,    82,    83,
     245,    84,    86,   103,   102,    96,   245,   275,   100,    99,
     101,     0,   245,    89,   245,    87,   245,    90,   245,    93,
      95,    92,   108,   245,   106,   245,   109,   111,   112,   113,
     114,   115,   118,   245,   117,     0,   728,   729,   730,   474,
       0,   493,   494,   495,   496,   497,   499,     0,   655,   654,
     732,   733,   734,   731,   739,   736,   737,   738,   735,   741,
     742,   743,   744,   745,   740,   757,   758,   752,   747,   748,
     749,   750,   751,   753,   754,   755,   756,   746,   760,   763,
     762,   761,   764,   765,   766,   759,   775,   776,   768,   769,
     770,   772,   771,   773,   774,   767,   778,   783,   780,   779,
     784,   782,   781,   785,   777,   788,   791,   787,   789,   790,
     786,   794,   793,   792,   796,   797,   798,   795,   802,   803,
     800,   801,   799,   808,   805,   806,   807,   804,   820,   814,
     817,   818,   812,   813,   815,   816,   819,   821,     0,   809,
     845,   843,   844,   842,   850,   847,   848,   849,   846,   865,
     664,   864,   670,   665,   863,   866,   668,   669,     0,   666,
     862,     0,   867,   870,   869,   873,   872,   874,     0,   871,
     861,   860,   859,   882,   879,   877,   878,   880,   881,   876,
     885,   884,   883,   889,   888,   891,   887,   890,   886,   622,
     625,   626,   627,   628,   620,   623,   624,   684,   685,   677,
     678,   676,   686,   687,   703,   680,   689,   682,   683,   688,
     679,   681,   674,   675,   701,   700,   702,     0,   671,   690,
     659,   658,     0,   518,     0,     0,   894,   893,   895,   896,
     897,   892,   471,     0,   120,   139,   122,   128,   129,   131,
     130,   133,   134,   132,   135,   553,   263,     0,   545,    43,
     356,   556,    46,   345,   346,     0,   547,    44,   266,   267,
     268,     0,   617,   618,     0,     0,   622,   620,     0,     0,
     671,     0,     0,   356,     0,     0,     0,     0,   434,   435,
       0,     6,     0,     0,   522,     0,   278,   281,     0,     0,
     314,   317,     0,     0,     0,     0,     0,     0,   322,   324,
       0,   366,     0,   404,   588,     0,   580,   583,   584,   581,
     587,   582,     0,   591,   589,   590,   586,   585,   577,   578,
     386,   389,   391,   393,   395,   396,   401,   408,   405,   406,
     407,   409,   411,   373,   376,   377,   579,   378,   385,   379,
     382,   383,   380,   381,     0,   410,   384,     0,   440,   441,
     442,   418,   423,   438,     0,   424,   429,     0,   452,   453,
     444,   446,   449,   450,     0,     0,     0,     0,   465,     0,
       0,     0,     0,     0,     0,     0,     0,   608,   609,   610,
     611,   612,   613,   580,   583,   584,   581,   601,   582,   602,
     600,   599,   603,   597,   598,   596,   604,   605,   606,     0,
     516,   592,   593,   514,   515,   563,   564,   558,   557,   568,
     570,   572,   574,   575,   562,   594,   595,   565,     0,     0,
       0,     0,   543,   542,     0,   143,   156,   163,   181,   197,
     273,    47,     0,     0,     0,    54,     0,     0,   553,    57,
      60,    58,    61,     0,     0,     0,    70,   553,     0,    79,
      85,    98,    97,   245,   104,    88,    91,    94,   107,   110,
     116,   119,     0,     0,   492,   490,   491,   489,   825,   832,
     822,   824,   823,   827,   828,   829,   830,   831,   826,   833,
     811,   667,     0,     0,   691,   692,   694,   693,   695,   696,
       0,   672,   697,     0,     0,   656,   488,   124,   136,     0,
       0,   354,   355,     0,     0,     0,   454,   456,     0,     0,
       0,     0,     0,   311,     0,   697,     0,   316,   344,     0,
     353,     0,   432,   436,     0,   539,     7,     7,   531,   533,
     575,   538,     7,   521,   274,   319,   320,   318,   337,   336,
       0,     0,   335,   331,   326,   327,   328,   329,   332,   330,
     325,     0,     0,     0,     0,   415,     0,   412,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   417,     0,
       0,     0,     0,     0,   427,   448,   447,     0,     0,   467,
       0,   466,   501,   502,   504,   506,   508,   511,     0,     7,
     304,   517,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   559,   650,   710,     9,    10,     0,     0,
       0,     0,     0,   143,   156,   163,   181,   197,     0,   254,
     256,   259,    76,   264,   105,     0,   498,   836,   835,   834,
     837,   838,   839,   840,   841,   810,     0,     0,   698,   699,
     673,   656,   656,     0,   663,   219,     0,     0,   349,   348,
     350,   457,     0,   537,   455,   534,   653,     0,   530,     0,
     528,   651,   649,   312,     0,   708,     0,   350,     0,     0,
     525,     0,   526,   532,   524,   523,   334,   340,   341,   333,
     339,     0,     0,   372,     0,   416,     0,   387,   376,   385,
     388,   390,   392,   394,   402,   403,   397,   400,   399,   398,
     413,   704,   705,   706,   707,   421,   439,   428,   430,   451,
       0,     0,   306,     0,     0,   307,   607,   561,   566,   567,
     569,   571,   573,   560,   512,   513,   576,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    33,   145,   144,     0,
       0,     0,    35,   158,   157,     0,     0,     0,   171,     0,
       0,     0,     0,     0,     0,     0,    38,   165,   164,     0,
       0,     0,     0,     0,    39,   183,   182,     0,     0,     0,
      41,   199,   198,     0,     0,     0,     0,     0,   219,     0,
     868,   875,   660,     0,   662,   657,     0,   544,     0,   357,
       0,   546,   244,   536,   535,     0,     0,   529,   709,     0,
     357,   352,   433,     0,     7,   575,   540,   541,     0,   369,
     370,   371,   414,   422,   431,     0,   458,     0,     0,     7,
     305,   257,   155,   260,   162,   180,   262,   196,   142,     0,
     265,   210,   210,   210,   146,   238,   239,   237,     0,   159,
     160,   161,     0,     0,     0,   195,   194,   192,   193,   227,
     229,   230,   228,   231,   208,     0,   207,   177,   178,   179,
       0,   176,   172,     0,     0,     0,     0,   191,     0,     0,
      49,    51,    52,    53,    55,     0,   727,   656,     0,     0,
       0,   221,   220,   222,   361,   362,   363,   364,   365,   357,
       0,   555,     0,     0,   468,   357,   343,   437,   527,   338,
       0,   462,     0,   309,   308,     0,     0,     0,     0,   210,
       0,     0,     0,     0,   168,   169,   170,     0,   166,     0,
     167,   184,   190,     0,   189,     0,     0,     0,     0,   661,
       0,     0,    45,   554,     0,   351,     0,   342,   461,     7,
     156,   163,   181,   197,     0,   211,   223,   215,   236,   209,
     175,     0,     0,     0,     0,     0,   233,     0,   206,     0,
     203,   201,    59,     0,   552,   360,   358,   359,   469,   310,
       0,     0,     0,     0,   219,     0,     0,     0,     0,     0,
     186,   188,   187,   185,   234,   200,     7,   202,   550,   549,
       0,     0,     0,     0,     0,     0,     0,   213,   212,   214,
       0,   225,   224,   226,     0,   217,   216,   218,   235,     0,
     205,   204,   551,   147,   148,   149,   150,     0,   151,   154,
     152,   232,   153
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1095, -1095,    -1,  -856,     6, -1095, -1095,  1106, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095,   -22, -1095,   775, -1095,   124,  -344,  -983,
    -352,  -976,  -350,   -24,  -178,  -345,  -974,  -978, -1095,  -351,
    -970, -1095, -1095,  -243,  -170, -1075, -1094, -1095, -1095, -1068,
   -1095, -1095, -1095,  -260, -1095, -1095, -1095,    86,  -601,  -779,
    1058,   -55,  1509, -1095,   549, -1095, -1095,    16, -1095,    23,
     315, -1095,    76,   757, -1016,   798, -1095, -1095,   121,  1065,
     865,   117,     9, -1095, -1095,  -281, -1095, -1095, -1095, -1095,
     -56, -1095, -1095, -1095, -1095,   474, -1095, -1095, -1095,   470,
   -1095, -1095, -1095,   -38, -1095,   894,  -892,   104, -1095,   507,
   -1052,   -15, -1095, -1095, -1095, -1095, -1095,  -714,   228,   232,
     233, -1095,   234, -1095, -1095, -1095, -1095, -1095,  -300, -1095,
     871, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095,  -293,   222, -1095, -1095, -1095,   440, -1095,   224,  -896,
   -1095, -1095,   931, -1095, -1095, -1095, -1095,   435, -1095, -1095,
     -47,   -26,    -9,  1165, -1095, -1095, -1095,   342, -1095, -1095,
   -1095, -1095,  -175,  -174, -1095, -1095,  -656, -1095,  1016,     8,
   -1095,   287,  -897, -1095,  -992, -1095,  -819,  -939, -1095, -1095,
     872,  -155,   854,  -150,   858,  1110, -1095, -1095,  -692,  -146,
     866, -1095,   898,  -308,  -686,  -679,  -673, -1095,  -244,  -659,
   -1095,  -256,   750,  -603, -1095,  -999,    17,   958, -1095,   -32,
   -1095, -1095, -1095,  -947, -1095,    92,   114,  -470,   230,   680,
     337,   960,   964, -1095, -1095,  -449,  -101, -1095, -1095, -1095,
     359, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,  1133,   672,  1134,    43,    44,    45,    68,    79,
      81,    93,    95,   116,   121,   129,   131,   235,   238,   241,
     242,   634,   887,   236,   190,   338,  1129,   998,   339,   999,
     342,  1000,   343,  1250,  1251,   346,  1001,  1149,  1237,   348,
    1002,  1317,  1349,  1350,  1244,  1245,  1300,  1365,  1367,  1176,
    1366,  1246,  1135,  1347,  1369,  1136,  1227,  1220,   191,  1183,
      46,    47,    60,   364,    49,   367,  1212,    61,   371,  1214,
      65,  1217,   245,   379,  1221,   255,   256,   257,    50,   350,
    1043,   387,  1137,   286,   287,   288,   289,   290,   980,  1104,
    1105,   291,   292,   293,   680,   681,   294,   295,   688,   689,
     939,   933,  1069,  1070,   296,   645,  1040,  1181,   297,   893,
    1281,  1279,   298,   299,   691,   300,   301,   710,   711,   712,
     713,   714,   715,   716,  1087,   717,   718,   719,   720,   721,
     722,   723,   302,   303,   741,   304,   305,   745,   306,   670,
     307,   742,   743,   308,   309,   750,   751,   752,   753,   895,
     896,   310,   311,   312,   313,   314,   757,   758,   315,   316,
     192,   791,   725,   317,   196,   857,   436,   437,   318,   319,
     320,   321,   322,   323,   793,   794,   795,   324,   325,   326,
     673,   674,  1049,  1050,   917,   918,  1044,  1045,   919,  1194,
     811,   638,   639,   646,   647,   376,  1380,  1273,   889,   641,
     642,   327,   812,   813,   799,   800,   801,   802,   920,   804,
     726,   727,   806,   807,   808,   328,   729,   584,   585,   198,
     330,   199,   439,  1034,   612,   730,   731,   548,   732,   549,
     733,   607,   608,   881,  1030,   609,   734,   735,   331,   332,
     736,   205,   430,   206,   443,   207,   448,   208,   454,   209,
     467,   210,   475,   211,   485,   212,   494,   213,   500,   214,
     503,   215,   507,   216,   512,   217,   517,   218,   529,   870,
    1025,   219,   533,   220,   538,   221,   222,   562,   223,   550,
     224,   552,   225,   554,   226,   559,   227,   569,   228,   572,
     229,   578,   230,   621
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      41,   824,    51,   193,   825,   827,   677,    42,   823,   239,
     826,   613,   746,   921,   623,   344,   915,   798,   329,  1057,
     194,  1164,   836,  1157,   193,   790,   922,   329,   754,  1165,
      62,    63,  1166,   193,   839,   790,   790,  1167,  1209,  1376,
     252,   194,   386,   249,   386,   386,   197,   756,   386,   386,
     194,   334,   386,   386,  1205,   337,   386,   386,   386,   285,
    1060,  1062,  1197,   386,   386,   978,  1064,   197,   340,   805,
     345,   386,  1100,  1101,   924,   974,   197,  1255,   899,   805,
     805,   803,   934,   975,  1172,  1174,   938,   353,   354,   355,
     976,   803,   803,    54,    55,    56,   136,   137,   138,  1063,
    1265,   370,   372,   373,   903,  1184,  1038,   671,  1222,  1223,
     384,  1208,  1355,   754,  1042,   246,   247,   392,   393,   854,
      52,   200,   398,  1103,  1184,   534,  1178,  1189,  1301,  1302,
     586,  1345,   250,    59,   251,   530,  1008,   880,  1286,   231,
     420,   421,   200,   201,   424,  1012,   341,   989,   535,   536,
     347,   200,   358,   359,   360,   540,   972,   973,   882,   193,
     990,    53,   991,   193,   201,    67,   378,   380,   382,   542,
     833,   543,   542,   201,   610,   834,   194,   537,   531,   532,
     194,   136,   137,   138,   611,   667,   403,   237,  1157,   880,
     410,   411,   284,   412,  1348,   188,   417,  1179,  1190,  1346,
     941,   361,   197,  1299,   737,  1334,   197,   835,   744,   624,
     905,   942,   855,   856,    53,   626,   389,   391,   429,    53,
     394,   395,    80,   668,   399,   400,   943,  1323,   405,   407,
     409,  1187,   838,  1327,  1077,   414,   416,   586,  1344,   669,
      94,  1086,     3,   422,  1039,     4,  1239,     5,  1184,  1356,
    1357,    53,   130,   546,   547,   329,   546,   547,   904,   202,
    1067,   193,   560,  1068,   240,   664,     6,     7,     8,     9,
    1240,  1241,   253,   254,   622,   724,    53,   200,   194,   561,
     202,   200,   643,   644,   900,   755,   243,     3,  1283,   202,
       4,   662,     5,  1329,   357,   284,  1385,  1046,   188,   201,
    1110,  1208,   970,   201,   197,   375,   663,   344,  1111,  1290,
     923,     6,     7,     8,     9,  1112,   792,   675,   329,   635,
    1319,   764,  1210,  1377,   193,   344,   792,   792,   955,   329,
     636,  -347,   979,   796,   501,   193,   944,   344,  1288,   682,
    1206,   194,   386,   796,   796,  1242,  1080,  1360,   502,   335,
     652,   653,   194,  1293,   655,  1361,   336,   766,  1362,   821,
    1232,  1233,   345,  1363,   956,  1243,   203,   197,   570,  -141,
     832,  1253,   790,   232,   233,   234,   431,   432,   197,   200,
     345,  1108,  1109,   188,  1157,   571,   375,   203,   204,   356,
    1325,   764,   345,   738,   739,   740,   203,   738,   739,   740,
     401,   201,  1196,   374,   423,   921,  1378,   765,   915,   333,
    1033,  1379,   841,  1173,  1313,   202,   805,  1307,   333,   202,
     248,   232,   233,   234,     4,   390,     5,   766,   396,   397,
     958,   928,  -155,   828,   683,   684,   685,   686,   687,   850,
      17,    18,   200,     4,   921,     5,   513,   915,   250,   555,
     438,   251,   837,   200,   551,   341,     3,   553,   981,     4,
     615,     5,   929,   636,   201,   625,   790,   433,   434,   514,
     515,   435,   516,  1359,   637,   201,   930,   897,   844,   640,
       6,     7,     8,     9,   504,   643,   644,    33,   556,   557,
     558,   953,  1117,   954,   505,   506,    34,  1118,   648,  1119,
     993,  1120,    35,   805,   805,   805,   805,   805,   790,   654,
     805,   851,   931,   990,   842,   991,     3,   202,    36,     4,
    1400,     5,   203,     4,   649,     5,   203,  1307,   640,   643,
     644,     3,  1394,   805,     4,   563,     5,   440,   441,   442,
       6,     7,     8,     9,   204,   982,   650,  1158,   204,  1159,
     564,   661,   805,   666,   573,     6,     7,     8,     9,   671,
      58,   932,  1158,   565,  1159,   675,   508,   574,   690,   566,
     509,   678,   679,     3,   575,   756,     4,  1390,     5,   761,
     202,   762,     3,   763,   576,     4,   809,     5,   810,   977,
     577,   202,   815,   510,   511,   816,  1121,     6,     7,     8,
       9,   616,  1247,  1248,   817,  1249,     6,     7,     8,     9,
     617,   618,   888,   818,   619,   620,   349,   567,   568,   352,
      69,  1017,    70,   819,   203,   193,   252,    71,    72,    73,
     852,    74,   366,   349,   921,   724,   724,   915,   724,   843,
     724,   724,   194,   232,   233,   234,   333,   388,   853,  1138,
    1139,  1140,  1141,  1142,  1018,   883,  1143,   885,  1138,  1139,
    1140,  1141,  1142,   792,   872,  1143,   724,  1122,   197,   724,
     117,  1098,   419,  1144,   873,   118,   119,   259,   260,   425,
     916,  1123,  1144,     4,   884,     5,  1309,   203,   759,   760,
     120,   891,   892,   805,  1028,  1029,  1124,   886,   203,   404,
     495,  1125,  1019,  1020,  1021,  1022,  1023,  1024,   890,   333,
     496,    17,    18,  1145,    17,    18,   894,   497,   724,   898,
     333,   724,  1145,   498,   499,   901,  1048,   805,   805,   805,
     805,   805,   805,   805,   902,   805,   805,    53,   193,  1107,
     426,   427,   428,   200,   906,  1113,  1126,  1115,  1116,   911,
     792,   792,   792,   792,   792,   194,   914,   792,    33,   948,
     949,    33,   984,   985,   790,   201,  1239,    34,  1186,   950,
      34,   671,  1061,    35,   796,   444,    35,   445,   446,   447,
     792,   197,   951,   724,   724,   747,   748,   749,   925,    36,
    1240,  1241,    36,   926,   897,   935,  1048,    75,   936,   792,
     748,   749,  1203,   790,  1204,   805,  1160,   937,   805,     3,
     996,    76,     4,   997,     5,   952,   796,  1195,  1235,  1236,
    1207,  1264,   136,   137,   138,   957,    77,   738,   739,   740,
    -704,    78,  -705,     6,     7,     8,     9,  1225,  1226,   959,
     429,   960,   969,   961,   122,  1117,   123,   805,   381,   383,
    1118,   124,  1119,   125,  1120,   962,   200,   126,  1093,  1094,
     967,   968,  1296,  1146,   986,  1242,  1298,   983,  1295,  1041,
    1297,   992,  1262,   987,   193,   724,   724,  1009,   201,   988,
     724,   202,  1003,  1004,  1306,  1243,  1005,     3,   724,  1006,
       4,   194,     5,  1007,   127,   627,   128,   628,  1035,   629,
     630,  1341,  1010,  1011,  1312,  1013,  1015,   631,   632,  1026,
    1033,     6,     7,     8,     9,  1036,  1342,   197,  1027,  1031,
     724,  1343,  1078,  1032,  1078,  1078,  1078,  1037,  1078,  1078,
    1088,   724,   764,  1091,  1091,   724,  1047,   724,  1054,   633,
     792,  1053,   193,  1058,   193,     3,  1056,  1073,     4,  1121,
       5,   261,   262,   263,   264,   265,   266,  1066,  1076,   194,
    1084,   194,  1071,  1072,  1089,  1074,  1106,   329,  1114,     6,
       7,     8,     9,   193,   792,   792,   792,   792,   792,   792,
     792,  1168,   792,   792,  1169,   197,  1170,   197,   203,  1175,
     194,  1171,   200,   790,   202,  1177,  1180,  1127,  1182,  1147,
    1155,  1161,  1326,  1185,  1128,  1193,  1148,  1156,  1162,  1198,
     204,  1048,  1199,   486,   201,   487,   197,   329,  1200,  1201,
    1122,  1218,  1219,   193,  1228,   476,   477,  1234,   724,  1238,
    1254,   897,   724,   488,  1123,   489,   490,   805,   491,   478,
     194,   479,   480,   481,  1259,  1268,   492,   493,  1258,  1124,
     724,   728,   792,  1266,  1125,   792,   482,   483,   484,  1267,
     200,  1280,   200,  1282,  1102,  1284,   197,  1291,  1292,   329,
    1303,  1315,   916,  1316,  1320,   193,  1324,  1328,  1330,  1331,
       3,  1332,   201,     4,   201,     5,   449,   450,   451,   452,
     453,   200,   194,  1333,   792,  1335,  1336,  1337,  1338,  1260,
    1348,   203,  1358,  1353,     6,     7,     8,     9,  1274,  1275,
    1276,  1277,  1278,   201,   637,  1368,  1364,  1374,   197,     3,
    1398,  1399,     4,   204,     5,    66,   822,  1163,  1224,  1256,
     202,  1340,   329,  1401,  1229,  1230,  1231,  1339,   193,  1411,
     362,   200,  1215,     6,     7,     8,     9,   820,  1252,   368,
    1158,   676,  1159,  1294,   927,   194,  1257,  1269,   940,   193,
    1289,  1191,  1127,   201,  1147,  1155,  1161,   724,   665,  1128,
     909,  1148,  1156,  1162,  1285,  1271,   194,  1386,  1081,   193,
    1268,   197,  1272,  1082,  1096,  1083,   539,   344,  1085,   651,
     966,  1099,   971,   200,   195,  1016,   194,   540,   202,   541,
     202,   614,   197,  1211,  1213,  1213,  1216,   344,   814,  1065,
    1389,   542,   829,   543,  1321,   201,   544,  1397,   831,   402,
    1393,     3,   197,   797,     4,   830,     5,   657,   871,   202,
     659,  1304,  1305,     0,   660,  1270,     0,   203,     0,     0,
       0,     0,   345,     0,  1308,     6,     7,     8,     9,  1310,
       0,   329,  1311,     0,     0,  1314,   200,   193,     0,   204,
       0,     0,   345,   545,  1271,   468,     0,   469,     0,  1322,
       0,  1272,     0,     0,   194,     0,     0,   200,   201,   202,
       0,     0,     0,     0,   792,   470,     0,   471,   472,   473,
     474,     0,  1269,     0,     0,   546,   547,   200,     0,   201,
     197,     0,     0,     0,     0,   203,     0,   203,     0,     0,
       0,     0,     0,     0,     0,     0,  1351,  1352,     0,   201,
    1354,  1268,     0,     0,     0,     0,     0,   204,   329,   204,
       0,   202,     0,     0,   193,     0,   203,     0,     0,     0,
    1370,  1371,  1372,  1373,     0,     0,  1375,     0,     0,     0,
       0,   194,     0,     0,     0,     0,     0,     0,   333,     0,
    1147,  1155,  1161,     0,  1387,  1391,  1395,  1148,  1156,  1162,
    1318,  1388,  1392,  1396,     0,   200,     0,   197,     0,  1402,
    1403,  1404,  1405,  1406,  1271,  1408,   203,     0,     0,  1409,
       0,  1272,     0,  1410,   202,     0,     0,   201,     0,     3,
     874,   875,     4,     0,     5,     0,  1412,     0,   333,  1384,
       0,   728,   728,   540,   728,   202,   728,   728,     0,     0,
       0,   876,     0,     6,     7,     8,     9,     0,     0,   543,
       0,   406,     0,  1269,     0,   202,     0,     0,   203,     0,
       0,   408,   728,     0,     0,   728,    17,    18,     0,   455,
     456,     0,   200,   457,     0,     0,    17,    18,     0,     0,
     333,     0,     0,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   201,  1138,  1139,  1140,  1141,  1142,
       0,     0,  1143,     0,     0,     0,     0,     0,     0,     0,
       0,   413,     0,    33,   728,     0,     0,   728,     0,  1144,
       0,   203,    34,    33,     0,     0,    17,    18,    35,     0,
      48,  1407,    34,   202,   877,   878,   879,   594,    35,    57,
      48,    48,   203,   333,    36,    64,     0,     0,    48,   604,
     605,   606,   907,   908,    36,   910,     0,   912,   913,  1145,
     415,     0,   203,     0,   204,     0,     0,   244,   244,   244,
       0,     0,     0,    33,     0,    17,    18,     0,     0,   728,
     728,     0,    34,   945,   204,     0,   947,     0,    35,     0,
       0,     0,     0,     0,     0,     0,    48,     0,   351,    48,
       0,     0,     0,    64,    36,   244,   244,   244,     0,    48,
     202,   363,   365,    48,   369,     0,     0,    64,     0,   377,
     377,   377,    33,     0,     0,   385,     0,    48,     0,     0,
       0,    34,     0,     0,     0,   964,     0,    35,   965,   244,
     203,     0,     0,   244,   244,     0,   244,     0,     0,   244,
       0,   418,    48,    36,     0,     0,    82,     0,    83,    48,
      84,     0,   333,    85,    86,    87,     0,    88,     0,     0,
       3,   728,   728,     4,     0,     5,   728,     0,     3,     0,
       0,     4,     0,     5,   728,     0,     3,     0,     0,     4,
       0,     5,     0,     0,     6,     7,     8,     9,     0,     0,
     994,   995,     6,     7,     8,     9,     0,     0,     0,  1382,
       6,     7,     8,     9,     0,     0,   728,   203,  1079,     0,
    1079,  1079,  1079,     0,  1079,  1079,     0,   728,     0,  1092,
    1092,   728,     0,   728,     0,     0,     0,     0,   754,   333,
       0,     0,     0,     0,     0,     0,     0,  1150,     0,  1151,
    1142,     0,     0,  1143,     0,  1150,     0,  1151,  1142,   587,
     588,  1143,     0,  1150,     0,  1151,  1142,     0,     0,  1143,
    1152,   518,   244,     0,   519,   694,     0,     0,  1152,     0,
     589,     0,     0,     0,     0,     0,  1152,   520,     0,     0,
       0,   521,  1051,  1052,   522,   523,     0,  1055,     0,   524,
     525,   526,   527,   528,     0,  1059,   136,   137,   138,     0,
    1153,     0,     0,   773,     0,     0,     0,   774,  1153,     0,
       0,   775,     0,     0,   728,     0,  1153,   776,   728,     0,
       0,   700,     0,    89,     0,     0,     0,  1075,     0,     0,
       0,     0,     0,   778,     0,     0,   728,    90,  1090,     0,
     590,     0,  1095,     0,  1097,     0,     0,     0,     0,     0,
       0,     0,    91,     0,     0,     0,     0,    92,     0,     0,
       0,     0,     0,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   244,     0,   604,   605,
     606,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    10,     0,    11,   244,    12,     0,     0,    13,
      14,    15,     0,    16,     0,     0,     0,    17,    18,   840,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     3,
       0,   244,     4,   845,     5,   846,   703,   847,     0,   704,
     705,     0,   848,     0,   849,  1188,     0,     0,     0,  1192,
       0,   132,     0,     6,     7,     8,     9,   133,   134,     0,
    1154,     0,     0,   728,    33,     0,     0,  1202,  1263,     0,
     258,     0,     0,    34,   706,   707,  1383,     0,     0,    35,
     259,   260,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    36,   261,   262,   263,   264,
     265,   266,     0,     0,     0,     0,     0,     0,   188,  1130,
       0,     0,     0,   267,     0,   268,     0,     0,   135,   136,
     137,   138,     0,     0,     0,     0,   139,     0,     0,  1131,
     140,     0,     0,     0,   141,     0,     0,     0,     0,     0,
     142,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     143,     0,     0,     0,     0,     0,   144,     0,     0,     0,
       0,   145,     0,     0,   146,     0,     0,   147,   148,     0,
       0,   149,     0,     0,   150,     0,   151,     0,     0,    37,
       0,     0,     0,     0,  1287,     0,     0,     0,     0,     0,
       0,     0,     0,    38,     0,     0,     0,     0,     0,   152,
     153,     0,   154,   155,   156,   157,     0,     0,    39,     0,
       0,   158,   159,    40,     0,   160,   161,   269,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   858,     0,
     270,   859,   860,   861,   862,   863,   864,   865,   866,   867,
     868,   869,     0,     0,   271,     0,     0,     0,     0,     0,
       0,     0,     0,   272,     0,     0,     0,     0,     0,   273,
       0,     0,     0,     0,   274,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   275,     0,     0,   276,   277,   278,
     279,     0,     0,     0,   280,     0,     0,     0,   281,   282,
     184,     0,     0,     3,   185,   186,     4,     0,     5,     0,
       0,     0,     0,   283,     0,     0,   187,     0,   284,  1132,
       0,   188,   189,     0,     0,   132,     0,     6,     7,     8,
       9,   133,   134,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   258,     0,     0,     0,     0,     0,
       0,     0,   579,     0,   259,   260,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     261,   262,   263,   264,   265,   266,     0,     0,   580,     0,
       0,   581,     0,  1130,     0,     0,     0,   267,     0,   268,
     582,     0,   135,   136,   137,   138,     0,     0,     0,     0,
     139,     0,     0,  1131,   140,     0,     0,     0,   141,     0,
       0,     0,     0,     0,   142,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,     0,     0,     0,     0,     0,
     144,     0,     0,     0,     0,   145,     0,     0,   146,     0,
       0,   147,   148,     0,     0,   149,     0,     0,   150,     0,
     151,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,     0,  1014,   152,   153,     0,   154,   155,   156,   157,
       0,     0,     0,     0,     0,   158,   159,     0,     0,   160,
     161,   269,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,   270,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   583,     0,     0,     0,   271,     0,
       0,     0,     0,     0,     0,     0,     0,   272,     0,     0,
       0,     0,     0,   273,     0,     0,     0,     0,   274,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   275,     0,
       0,   276,   277,   278,   279,     0,     0,     0,   280,     0,
       0,     0,   281,   282,   184,     0,     0,     3,   185,   186,
       4,     0,     5,     0,     0,     0,     0,   283,     0,     0,
     187,     0,   284,  1261,     0,   188,   189,     0,     0,   132,
       0,     6,     7,     8,     9,   133,   134,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   258,     0,
       0,     0,     0,     0,     0,     0,   656,     0,   259,   260,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   261,   262,   263,   264,   265,   266,
       0,     0,   580,     0,     0,   581,     0,  1130,     0,     0,
       0,   267,     0,   268,   582,     0,   135,   136,   137,   138,
       0,     0,     0,     0,   139,     0,     0,  1131,   140,     0,
       0,     0,   141,     0,     0,     0,     0,     0,   142,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,     0,
       0,     0,     0,     0,   144,     0,     0,     0,     0,   145,
       0,     0,   146,     0,     0,   147,   148,     0,     0,   149,
       0,     0,   150,     0,   151,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,     0,     0,   152,   153,     0,
     154,   155,   156,   157,     0,     0,     0,     0,     0,   158,
     159,     0,     0,   160,   161,   269,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,   270,   692,
       0,     0,     0,     0,     0,     0,     0,     0,   583,     0,
       0,     0,   271,     0,     0,   693,     0,   132,     0,     0,
       0,   272,     0,     0,     0,     0,     0,   273,     0,     0,
     587,   588,   274,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   275,     0,     0,   276,   277,   278,   279,     0,
       0,   589,   280,     0,   694,     0,   281,   282,   184,     0,
       0,     0,   185,   186,     0,     0,     0,     0,   695,     0,
       0,   283,     0,     0,   187,     0,   284,  1381,     0,   188,
     189,     0,     0,     0,   135,   136,   137,   138,     0,     0,
       0,     0,   696,     0,     0,     0,   697,   658,     0,     0,
     698,     0,     0,     0,     0,     0,   699,     0,     0,     0,
     700,     0,     0,     0,     0,     0,   143,     0,     0,     0,
       0,   590,   701,     0,     0,     0,     0,   145,     0,     0,
     146,     0,     0,   147,   148,     0,     0,   149,     0,     0,
     150,     0,   151,     0,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,     0,     0,   604,
     605,   606,   946,     0,     0,   152,   153,     0,   702,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   693,     0,
     132,     0,     0,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,   183,     0,     0,     0,
       0,     0,     0,     0,     0,   703,     0,   694,   704,   705,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   135,   136,   137,
     138,     0,     0,   706,   707,   696,     0,     0,     0,   697,
       0,     0,     0,   698,     0,     0,   184,     0,     0,   699,
     185,   186,     0,   700,     0,     0,     0,     0,     0,   143,
     708,   709,     0,     0,     0,   701,     0,   188,     0,     0,
     145,     0,     0,   146,     0,     0,   147,   148,     0,     0,
     149,     0,     0,   150,     0,   151,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   963,     0,     0,   152,   153,
       0,   702,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   693,     0,   132,     0,     0,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,   183,
       0,     0,     0,     0,     0,     0,     0,     0,   703,     0,
     694,   704,   705,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     135,   136,   137,   138,     0,     0,   706,   707,   696,     0,
       0,     0,   697,     0,     0,     0,   698,     0,     0,   184,
       0,     0,   699,   185,   186,     0,   700,     0,     0,     0,
       0,     0,   143,   708,   709,     0,     0,     0,   701,     0,
     188,     0,     0,   145,     0,     0,   146,     0,     0,   147,
     148,     0,     0,   149,     0,     0,   150,     0,   151,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   152,   153,     0,   702,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,   183,     0,   767,   768,   769,   770,   771,   772,
       0,   703,     0,     0,   704,   705,   693,     0,   754,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   706,
     707,     0,     0,     0,     0,   694,     0,     0,     0,     0,
       0,     0,   184,     0,     0,     0,   185,   186,     0,     0,
       0,     0,     0,     0,     0,     0,   708,   709,     0,     0,
     693,     0,   754,   188,     0,   135,   136,   137,   138,     0,
       0,     0,     0,   773,     0,     0,     0,   774,     0,     0,
       0,   775,     0,     0,     0,     0,     0,   776,     0,     0,
       0,   700,     0,     0,     0,     0,     0,   777,     0,   694,
       0,     0,     0,   778,     0,     0,     0,     0,   779,     0,
       0,   780,     0,     0,   781,   782,     0,     0,   783,     0,
       0,   784,     0,   785,     0,     0,     0,     0,     0,   135,
     136,   137,   138,     0,     0,     0,     0,   773,     0,     0,
       0,   774,     0,     0,     0,   775,   786,   787,     0,     0,
       0,   776,     0,     0,     0,   700,     0,     0,     0,     0,
       0,   777,     0,     0,     0,     0,     0,   778,     0,     0,
       0,     0,   779,     0,     0,   780,     0,     0,   781,   782,
       0,     0,   783,     0,     0,   784,     0,   785,     0,     0,
       0,     0,     0,     0,     0,     0,   703,     0,     0,   704,
     705,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     786,   787,   693,     0,   754,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   706,   707,     0,   788,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   694,     0,     0,     0,     0,     0,     0,     0,     0,
     703,   708,   709,   704,   705,   284,     0,     0,   188,   789,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   135,   136,   137,   138,     0,     0,     0,     0,   773,
       0,     0,     0,   774,     0,     0,     0,   775,   706,   707,
       0,   788,     0,   776,     0,     0,     0,   700,     0,     0,
       0,     0,     0,   777,     0,     0,     0,     0,   693,   778,
     132,     0,     0,     0,   779,   708,   709,   780,     0,   284,
     781,   782,   188,   789,   783,     0,     0,   784,     0,   785,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   694,     0,     0,
       0,     0,   786,   787,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   135,   136,   137,
     138,     0,     0,     0,     0,   696,     0,     0,     0,   697,
       0,     0,     0,   698,     0,     0,     0,     0,     0,   699,
       0,     0,   703,   700,     0,   704,   705,     0,     0,   143,
       0,     0,     0,     0,     0,   701,     0,     0,     0,     0,
     145,     0,     0,   146,     0,     0,   147,   148,     0,     0,
     149,     0,     0,   150,     0,   151,     0,     0,     0,     0,
     706,   707,     0,   788,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   152,   153,
       0,   702,     0,     0,     0,     0,     0,   708,   709,     0,
       0,     0,     0,     0,   188,   789,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,   183,
       0,     0,     0,     0,     0,     0,     0,     0,   703,     0,
       0,   704,   705,     0,     0,     0,     0,     0,     0,     0,
     132,     0,     0,     0,     0,     0,   133,   134,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   258,
       0,     0,     0,     0,     0,     0,   706,   707,     0,   259,
     260,     0,     0,     0,     0,     0,     0,     0,     0,   184,
       0,     0,     0,   185,   186,   261,   262,   263,   264,   265,
     266,     0,     0,   708,   709,     0,     0,     0,     0,     0,
     188,     0,   267,     0,   268,     0,     0,   135,   136,   137,
     138,     0,     0,     0,     0,   139,     0,     0,     0,   140,
       0,     0,     0,   141,     0,     0,     0,     0,     0,   142,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   143,
       0,     0,     0,     0,     0,   144,     0,     0,     0,     0,
     145,     0,     0,   146,     0,     0,   147,   148,     0,     0,
     149,     0,     0,   150,     0,   151,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   152,   153,
       0,   154,   155,   156,   157,     0,     0,     0,     0,     0,
     158,   159,     0,     0,   160,   161,   269,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,   270,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   271,     0,     0,     0,   132,     0,     0,
       0,     0,   272,   133,   134,     0,     0,     0,   273,     0,
       0,     0,     0,   274,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   275,     0,     0,   276,   277,   278,   279,
       0,     0,     0,   280,     0,     0,     0,   281,   282,   184,
       0,     0,     0,   185,   186,     0,     0,     0,     0,     0,
       0,     0,   283,     0,     0,   187,     0,   284,     0,     0,
     188,   189,     0,     0,   135,   136,   137,   138,     0,     0,
       0,     0,   139,     0,     0,     0,   140,     0,     0,     0,
     141,     0,     0,     0,     0,     0,   142,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,     0,     0,     0,
       0,     0,   144,     0,     0,     0,     0,   145,     0,     0,
     146,     0,     0,   147,   148,     0,     0,   149,     0,     0,
     150,     0,   151,     0,   132,     0,     0,     0,     0,     0,
     133,   134,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   152,   153,     0,   154,   155,
     156,   157,     0,     0,     0,     0,     0,   158,   159,     0,
       0,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,   183,     0,     0,     0,
       0,   135,   136,   137,   138,     0,     0,     0,     0,   139,
       0,     0,     0,   140,     0,     0,     0,   141,     0,     0,
       0,     0,     0,   142,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,     0,     0,     0,     0,     0,   144,
       0,     0,     0,     0,   145,     0,     0,   146,     0,     0,
     147,   148,     0,     0,   149,     0,   184,   150,     0,   151,
     185,   186,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   187,     0,   284,     0,     0,   188,   189,     0,
       0,     0,   152,   153,     0,   154,   155,   156,   157,     0,
       0,     0,     0,   754,   158,   159,     0,     0,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,     0,     0,   183,     0,     0,     0,     0,     0,     0,
     694,     0,     0,     0,     0,     0,     0,     0,   261,   262,
     263,   264,   265,   266,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   754,     0,     0,
     135,   136,   137,   138,     0,     0,     0,     0,   773,     0,
       0,     0,   774,     0,     0,     0,   775,     0,     0,     0,
       0,     0,   776,   184,     0,     0,   700,   185,   186,     0,
       0,     0,   777,     0,   694,     0,     0,     0,   778,   187,
       0,     0,     0,   779,   188,   189,   780,     0,     0,   781,
     782,     0,     0,   783,     0,     0,   784,     0,   785,     0,
       0,     0,     0,     0,   135,   136,   137,   138,     0,     0,
       0,     0,   773,     0,     0,     0,   774,     0,     0,     0,
     775,   786,   787,     0,     0,     0,   776,     0,     0,     0,
     700,     0,     0,     0,     0,     0,   777,     0,     0,     0,
       0,     0,   778,     0,     0,     0,     0,   779,     0,     0,
     780,     0,     0,   781,   782,     0,     0,   783,     0,     0,
     784,     0,   785,     0,     0,     0,     0,     0,     0,     0,
       0,   703,     0,     0,   704,   705,     0,     0,     0,   132,
       0,     0,     0,     0,     0,   786,   787,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   706,
     707,     0,   788,     0,     0,     0,   694,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   703,   708,   709,   704,   705,
       0,     0,     0,   188,   789,     0,   135,   136,   137,   138,
       0,     0,     0,     0,   696,     0,     0,     0,   697,     0,
       0,     0,   698,     0,     0,     0,     0,     0,   699,     0,
       0,     0,   700,   706,   707,     0,   788,     0,   143,     0,
       0,     0,     0,     0,   701,     0,     0,     0,     0,   145,
       0,     0,   146,     0,     0,   147,   148,     0,     0,   149,
     708,   709,   150,     0,   151,     0,     0,   188,   789,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   152,   153,     0,
     702,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,   183,     0,
       0,     0,     0,     0,     0,     0,     0,   703,     0,     0,
     704,   705,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,     3,   706,   707,     4,     0,     5,
       0,     0,     0,     0,     0,     0,     0,     0,   184,     0,
       0,     0,   185,   186,     0,     0,     0,     0,     6,     7,
       8,     9,   708,   709,     0,     0,     0,     0,    10,   188,
      11,     0,    12,     0,     0,    13,    14,    15,     0,    16,
       0,     0,     0,    17,    18,    19,     0,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      96,    97,    98,    99,     0,     0,   100,   101,     0,   102,
     103,     0,     0,   104,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -245,     0,     0,     0,     0,     0,
      33,     0,     0,     0,     0,     0,     0,     0,     0,    34,
       0,     0,     0,     0,     0,    35,     0,     0,     0,     0,
     105,     0,   106,   107,   108,     0,     0,     0,     0,     0,
       0,    36,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    37,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    38,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,   109,     0,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   110,     0,     0,     0,     0,   111,   112,   113,     0,
       0,     0,     0,     0,     0,     0,   114,     0,     0,     0,
       0,   115
};

static const yytype_int16 yycheck[] =
{
       1,   353,     3,    29,   354,   356,   287,     1,   352,    31,
     355,   185,   305,   672,   189,    62,   672,   325,    50,   911,
      29,  1004,   372,  1001,    50,   325,     7,    59,    23,  1005,
      14,    15,  1006,    59,   384,   335,   336,  1007,     7,     7,
      47,    50,    97,    44,    99,   100,    29,    35,   103,   104,
      59,    52,   107,   108,     5,    56,   111,   112,   113,    50,
     916,   917,  1061,   118,   119,    23,   922,    50,    59,   325,
      62,   126,   968,   970,   675,   761,    59,  1152,    84,   335,
     336,   325,   683,   762,  1031,  1032,   687,    71,    72,    73,
     763,   335,   336,     7,     8,     9,    91,    92,    93,   918,
    1168,    85,    86,    87,    90,  1044,    91,     4,  1124,  1125,
      94,  1103,    91,    23,    78,    39,    40,   101,   102,   101,
      92,    29,   106,   979,  1063,   121,    20,    20,  1222,  1223,
     162,    22,    46,    12,    48,   101,   828,   607,  1190,    48,
     124,   125,    50,    29,   128,   837,    60,     7,   144,   145,
      64,    59,    76,    77,    78,   112,   759,   760,   607,   185,
      20,    91,    22,   189,    50,    39,    90,    91,    92,   126,
      47,   128,   126,    59,   263,    47,   185,   173,   144,   145,
     189,    91,    92,    93,   273,    74,   110,    48,  1166,   659,
     114,   115,   290,   117,    91,   293,   120,    91,    91,    90,
     122,    80,   185,  1219,    74,  1299,   189,    47,    74,   231,
     659,   133,   194,   195,    91,   237,    99,   100,   132,    91,
     103,   104,    39,   112,   107,   108,   148,  1279,   111,   112,
     113,  1050,    47,  1285,   948,   118,   119,   269,  1313,   128,
      43,   955,     1,   126,   229,     4,    91,     6,  1187,   228,
     229,    91,    37,   210,   211,   287,   210,   211,   244,    29,
     124,   287,   114,   127,    91,   227,    25,    26,    27,    28,
     115,   116,   279,   280,   188,   301,    91,   185,   287,   131,
      50,   189,   244,   245,   290,   311,   220,     1,  1185,    59,
       4,   227,     6,  1292,   220,   290,  1364,   898,   293,   185,
     986,  1293,   290,   189,   287,   220,   242,   354,   987,  1205,
     291,    25,    26,    27,    28,   988,   325,   281,   350,   243,
    1267,     8,   291,   291,   350,   372,   335,   336,     8,   361,
     244,    90,   290,   325,   124,   361,   258,   384,  1194,   141,
     291,   350,   397,   335,   336,   190,   949,  1330,   138,   289,
     264,   265,   361,  1209,   268,  1331,   289,    44,  1332,   350,
    1139,  1140,   354,  1333,    44,   210,    29,   350,   114,   290,
     361,  1150,   672,   282,   283,   284,    99,   100,   361,   287,
     372,   984,   985,   293,  1362,   131,   220,    50,    29,    74,
    1282,     8,   384,   263,   264,   265,    59,   263,   264,   265,
     234,   287,  1061,    88,    35,  1064,   143,    24,  1064,    50,
     275,   148,   396,   278,     5,   185,   672,     8,    59,   189,
       0,   282,   283,   284,     4,    35,     6,    44,    35,    36,
     723,    67,   290,   357,   236,   237,   238,   239,   240,   423,
      50,    51,   350,     4,  1103,     6,   121,  1103,   362,   141,
      31,   365,   376,   361,   179,   369,     1,   179,   766,     4,
     274,     6,    98,   377,   350,   283,   766,   190,   191,   144,
     145,   194,   147,  1329,   228,   361,   112,   651,   402,   242,
      25,    26,    27,    28,   131,   244,   245,    97,   180,   181,
     182,    20,    37,    22,   141,   142,   106,    42,    90,    44,
     808,    46,   112,   759,   760,   761,   762,   763,   808,    86,
     766,   425,   148,    20,   397,    22,     1,   287,   128,     4,
    1376,     6,   185,     4,    90,     6,   189,     8,   242,   244,
     245,     1,   291,   789,     4,   103,     6,    99,   100,   101,
      25,    26,    27,    28,   185,   789,    90,    32,   189,    34,
     118,   227,   808,    74,   101,    25,    26,    27,    28,     4,
      11,   197,    32,   131,    34,   281,   117,   114,   257,   137,
     121,   228,   229,     1,   121,    35,     4,   291,     6,    17,
     350,    18,     1,   292,   131,     4,    42,     6,    42,   764,
     137,   361,   290,   144,   145,   290,   141,    25,    26,    27,
      28,   174,    75,    76,   290,    78,    25,    26,    27,    28,
     183,   184,   634,   290,   187,   188,    67,   185,   186,    70,
      35,    84,    37,   290,   287,   651,    47,    42,    43,    44,
       7,    46,    83,    84,  1293,   661,   662,  1293,   664,    35,
     666,   667,   651,   282,   283,   284,   287,    98,     8,    77,
      78,    79,    80,    81,   117,   274,    84,    90,    77,    78,
      79,    80,    81,   672,   296,    84,   692,   212,   651,   695,
     226,   964,   123,   101,   296,   231,   232,    52,    53,   130,
     672,   226,   101,     4,   274,     6,     7,   350,    15,    16,
     246,   244,   245,   949,    99,   100,   241,   295,   361,    35,
     114,   246,   165,   166,   167,   168,   169,   170,    90,   350,
     124,    50,    51,   141,    50,    51,    90,   131,   744,    23,
     361,   747,   141,   137,   138,    42,   900,   983,   984,   985,
     986,   987,   988,   989,    42,   991,   992,    91,   764,   983,
      94,    95,    96,   651,    42,   989,   291,   991,   992,    90,
     759,   760,   761,   762,   763,   764,    74,   766,    97,    15,
      16,    97,    15,    16,  1064,   651,    91,   106,  1049,    17,
     106,     4,     5,   112,   766,   101,   112,   103,   104,   105,
     789,   764,    18,   809,   810,   267,   268,   269,    90,   128,
     115,   116,   128,    90,   968,    90,   970,   212,    90,   808,
     268,   269,  1095,  1103,  1097,  1061,   291,    90,  1064,     1,
     811,   226,     4,   814,     6,   292,   808,  1061,    82,    83,
    1101,   291,    91,    92,    93,     5,   241,   263,   264,   265,
       7,   246,     7,    25,    26,    27,    28,    68,    69,     7,
     754,     7,   756,     5,    35,    37,    37,  1103,    91,    92,
      42,    42,    44,    44,    46,     7,   764,    48,   959,   960,
       7,   290,  1214,   291,    17,   190,  1217,     7,  1212,   895,
    1215,     8,   291,    18,   900,   901,   902,    90,   764,   292,
     906,   651,   290,   290,  1234,   210,   290,     1,   914,   290,
       4,   900,     6,   290,    85,    36,    87,    38,   290,    40,
      41,   226,    90,    90,  1254,    90,    90,    48,    49,    90,
     275,    25,    26,    27,    28,   229,   241,   900,    90,    90,
     946,   246,   948,    90,   950,   951,   952,    90,   954,   955,
     956,   957,     8,   959,   960,   961,    90,   963,    42,    80,
     949,    90,   968,    33,   970,     1,    90,    60,     4,   141,
       6,    68,    69,    70,    71,    72,    73,   127,     5,   968,
      90,   970,   101,   101,   956,   101,   295,   999,    90,    25,
      26,    27,    28,   999,   983,   984,   985,   986,   987,   988,
     989,   290,   991,   992,     7,   968,   297,   970,   651,    90,
     999,   297,   900,  1293,   764,    90,   247,   998,    91,  1000,
    1001,  1002,  1283,   290,   998,    33,  1000,  1001,  1002,     7,
     651,  1185,    91,   101,   900,   103,   999,  1049,    91,    91,
     212,    91,   220,  1049,    91,    99,   100,   289,  1054,    90,
     289,  1205,  1058,   121,   226,   123,   124,  1293,   126,   113,
    1049,   115,   116,   117,   289,   101,   134,   135,    91,   241,
    1076,   301,  1061,    90,   246,  1064,   130,   131,   132,    90,
     968,   243,   970,    90,   978,   291,  1049,   291,     5,  1101,
      32,   129,  1064,   290,    92,  1101,    90,   291,   290,   290,
       1,   290,   968,     4,   970,     6,   107,   108,   109,   110,
     111,   999,  1101,   290,  1103,   290,   290,   290,    91,   291,
      91,   764,   291,   120,    25,    26,    27,    28,   251,   252,
     253,   254,   255,   999,   228,    33,   290,    90,  1101,     1,
      91,   129,     4,   764,     6,    19,   351,  1003,  1129,  1153,
     900,  1309,  1164,  1376,  1135,  1136,  1137,  1307,  1164,  1399,
      82,  1049,  1119,    25,    26,    27,    28,   349,  1149,    84,
      32,   286,    34,  1209,   680,  1164,  1157,   213,   688,  1185,
    1198,  1057,  1163,  1049,  1165,  1166,  1167,  1193,   274,  1163,
     663,  1165,  1166,  1167,  1189,  1176,  1185,   291,   950,  1205,
     101,  1164,  1176,   951,   962,   952,   101,  1234,   954,   258,
     750,   967,   757,  1101,    29,   853,  1205,   112,   968,   114,
     970,   185,  1185,  1117,  1118,  1119,  1120,  1254,   336,   922,
    1365,   126,   358,   128,  1269,  1101,   131,  1367,   360,   109,
    1366,     1,  1205,   325,     4,   359,     6,   269,   548,   999,
     270,  1232,  1233,    -1,   270,   291,    -1,   900,    -1,    -1,
      -1,    -1,  1234,    -1,  1245,    25,    26,    27,    28,  1250,
      -1,  1283,  1253,    -1,    -1,  1256,  1164,  1283,    -1,   900,
      -1,    -1,  1254,   178,  1265,   101,    -1,   103,    -1,  1270,
      -1,  1265,    -1,    -1,  1283,    -1,    -1,  1185,  1164,  1049,
      -1,    -1,    -1,    -1,  1293,   121,    -1,   123,   124,   125,
     126,    -1,   213,    -1,    -1,   210,   211,  1205,    -1,  1185,
    1283,    -1,    -1,    -1,    -1,   968,    -1,   970,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1317,  1318,    -1,  1205,
    1321,   101,    -1,    -1,    -1,    -1,    -1,   968,  1360,   970,
      -1,  1101,    -1,    -1,  1360,    -1,   999,    -1,    -1,    -1,
    1341,  1342,  1343,  1344,    -1,    -1,  1347,    -1,    -1,    -1,
      -1,  1360,    -1,    -1,    -1,    -1,    -1,    -1,   999,    -1,
    1361,  1362,  1363,    -1,  1365,  1366,  1367,  1361,  1362,  1363,
     291,  1365,  1366,  1367,    -1,  1283,    -1,  1360,    -1,  1380,
    1381,  1382,  1383,  1384,  1385,  1386,  1049,    -1,    -1,  1390,
      -1,  1385,    -1,  1394,  1164,    -1,    -1,  1283,    -1,     1,
      99,   100,     4,    -1,     6,    -1,  1407,    -1,  1049,   291,
      -1,   661,   662,   112,   664,  1185,   666,   667,    -1,    -1,
      -1,   120,    -1,    25,    26,    27,    28,    -1,    -1,   128,
      -1,    35,    -1,   213,    -1,  1205,    -1,    -1,  1101,    -1,
      -1,    35,   692,    -1,    -1,   695,    50,    51,    -1,    99,
     100,    -1,  1360,   103,    -1,    -1,    50,    51,    -1,    -1,
    1101,    -1,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,    -1,  1360,    77,    78,    79,    80,    81,
      -1,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    97,   744,    -1,    -1,   747,    -1,   101,
      -1,  1164,   106,    97,    -1,    -1,    50,    51,   112,    -1,
       1,   291,   106,  1283,   213,   214,   215,   216,   112,    10,
      11,    12,  1185,  1164,   128,    16,    -1,    -1,    19,   228,
     229,   230,   661,   662,   128,   664,    -1,   666,   667,   141,
      35,    -1,  1205,    -1,  1185,    -1,    -1,    38,    39,    40,
      -1,    -1,    -1,    97,    -1,    50,    51,    -1,    -1,   809,
     810,    -1,   106,   692,  1205,    -1,   695,    -1,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    69,    70,
      -1,    -1,    -1,    74,   128,    76,    77,    78,    -1,    80,
    1360,    82,    83,    84,    85,    -1,    -1,    88,    -1,    90,
      91,    92,    97,    -1,    -1,    96,    -1,    98,    -1,    -1,
      -1,   106,    -1,    -1,    -1,   744,    -1,   112,   747,   110,
    1283,    -1,    -1,   114,   115,    -1,   117,    -1,    -1,   120,
      -1,   122,   123,   128,    -1,    -1,    35,    -1,    37,   130,
      39,    -1,  1283,    42,    43,    44,    -1,    46,    -1,    -1,
       1,   901,   902,     4,    -1,     6,   906,    -1,     1,    -1,
      -1,     4,    -1,     6,   914,    -1,     1,    -1,    -1,     4,
      -1,     6,    -1,    -1,    25,    26,    27,    28,    -1,    -1,
     809,   810,    25,    26,    27,    28,    -1,    -1,    -1,   291,
      25,    26,    27,    28,    -1,    -1,   946,  1360,   948,    -1,
     950,   951,   952,    -1,   954,   955,    -1,   957,    -1,   959,
     960,   961,    -1,   963,    -1,    -1,    -1,    -1,    23,  1360,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    80,
      81,    -1,    -1,    84,    -1,    78,    -1,    80,    81,    99,
     100,    84,    -1,    78,    -1,    80,    81,    -1,    -1,    84,
     101,   121,   243,    -1,   124,    60,    -1,    -1,   101,    -1,
     120,    -1,    -1,    -1,    -1,    -1,   101,   137,    -1,    -1,
      -1,   141,   901,   902,   144,   145,    -1,   906,    -1,   149,
     150,   151,   152,   153,    -1,   914,    91,    92,    93,    -1,
     141,    -1,    -1,    98,    -1,    -1,    -1,   102,   141,    -1,
      -1,   106,    -1,    -1,  1054,    -1,   141,   112,  1058,    -1,
      -1,   116,    -1,   212,    -1,    -1,    -1,   946,    -1,    -1,
      -1,    -1,    -1,   128,    -1,    -1,  1076,   226,   957,    -1,
     190,    -1,   961,    -1,   963,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,   246,    -1,    -1,
      -1,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   357,    -1,   228,   229,
     230,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    37,   376,    39,    -1,    -1,    42,
      43,    44,    -1,    46,    -1,    -1,    -1,    50,    51,   390,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,
      -1,   402,     4,   404,     6,   406,   221,   408,    -1,   224,
     225,    -1,   413,    -1,   415,  1054,    -1,    -1,    -1,  1058,
      -1,    23,    -1,    25,    26,    27,    28,    29,    30,    -1,
     291,    -1,    -1,  1193,    97,    -1,    -1,  1076,   291,    -1,
      42,    -1,    -1,   106,   259,   260,   291,    -1,    -1,   112,
      52,    53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   128,    68,    69,    70,    71,
      72,    73,    -1,    -1,    -1,    -1,    -1,    -1,   293,    81,
      -1,    -1,    -1,    85,    -1,    87,    -1,    -1,    90,    91,
      92,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,    -1,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     122,    -1,    -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,
      -1,   133,    -1,    -1,   136,    -1,    -1,   139,   140,    -1,
      -1,   143,    -1,    -1,   146,    -1,   148,    -1,    -1,   212,
      -1,    -1,    -1,    -1,  1193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   226,    -1,    -1,    -1,    -1,    -1,   171,
     172,    -1,   174,   175,   176,   177,    -1,    -1,   241,    -1,
      -1,   183,   184,   246,    -1,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   151,    -1,
     212,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,    -1,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,   241,
      -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   256,    -1,    -1,   259,   260,   261,
     262,    -1,    -1,    -1,   266,    -1,    -1,    -1,   270,   271,
     272,    -1,    -1,     1,   276,   277,     4,    -1,     6,    -1,
      -1,    -1,    -1,   285,    -1,    -1,   288,    -1,   290,   291,
      -1,   293,   294,    -1,    -1,    23,    -1,    25,    26,    27,
      28,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    -1,    52,    53,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      68,    69,    70,    71,    72,    73,    -1,    -1,   117,    -1,
      -1,   120,    -1,    81,    -1,    -1,    -1,    85,    -1,    87,
     129,    -1,    90,    91,    92,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,    -1,
     128,    -1,    -1,    -1,    -1,   133,    -1,    -1,   136,    -1,
      -1,   139,   140,    -1,    -1,   143,    -1,    -1,   146,    -1,
     148,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   843,   171,   172,    -1,   174,   175,   176,   177,
      -1,    -1,    -1,    -1,    -1,   183,   184,    -1,    -1,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,    -1,   212,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   263,    -1,    -1,    -1,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,
      -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,    -1,
      -1,   259,   260,   261,   262,    -1,    -1,    -1,   266,    -1,
      -1,    -1,   270,   271,   272,    -1,    -1,     1,   276,   277,
       4,    -1,     6,    -1,    -1,    -1,    -1,   285,    -1,    -1,
     288,    -1,   290,   291,    -1,   293,   294,    -1,    -1,    23,
      -1,    25,    26,    27,    28,    29,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    -1,    52,    53,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    68,    69,    70,    71,    72,    73,
      -1,    -1,   117,    -1,    -1,   120,    -1,    81,    -1,    -1,
      -1,    85,    -1,    87,   129,    -1,    90,    91,    92,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,    -1,    -1,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   122,    -1,
      -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,    -1,   133,
      -1,    -1,   136,    -1,    -1,   139,   140,    -1,    -1,   143,
      -1,    -1,   146,    -1,   148,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,    -1,   171,   172,    -1,
     174,   175,   176,   177,    -1,    -1,    -1,    -1,    -1,   183,
     184,    -1,    -1,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,    -1,   212,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   263,    -1,
      -1,    -1,   226,    -1,    -1,    21,    -1,    23,    -1,    -1,
      -1,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,
      99,   100,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   256,    -1,    -1,   259,   260,   261,   262,    -1,
      -1,   120,   266,    -1,    60,    -1,   270,   271,   272,    -1,
      -1,    -1,   276,   277,    -1,    -1,    -1,    -1,    74,    -1,
      -1,   285,    -1,    -1,   288,    -1,   290,   291,    -1,   293,
     294,    -1,    -1,    -1,    90,    91,    92,    93,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,   102,   166,    -1,    -1,
     106,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,
     116,    -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,
      -1,   190,   128,    -1,    -1,    -1,    -1,   133,    -1,    -1,
     136,    -1,    -1,   139,   140,    -1,    -1,   143,    -1,    -1,
     146,    -1,   148,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,    -1,   228,
     229,   230,     5,    -1,    -1,   171,   172,    -1,   174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,    -1,
      23,    -1,    -1,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,    -1,   212,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,    -1,    60,   224,   225,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,
      93,    -1,    -1,   259,   260,    98,    -1,    -1,    -1,   102,
      -1,    -1,    -1,   106,    -1,    -1,   272,    -1,    -1,   112,
     276,   277,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,
     286,   287,    -1,    -1,    -1,   128,    -1,   293,    -1,    -1,
     133,    -1,    -1,   136,    -1,    -1,   139,   140,    -1,    -1,
     143,    -1,    -1,   146,    -1,   148,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     5,    -1,    -1,   171,   172,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    21,    -1,    23,    -1,    -1,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,    -1,   212,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,    -1,
      60,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    92,    93,    -1,    -1,   259,   260,    98,    -1,
      -1,    -1,   102,    -1,    -1,    -1,   106,    -1,    -1,   272,
      -1,    -1,   112,   276,   277,    -1,   116,    -1,    -1,    -1,
      -1,    -1,   122,   286,   287,    -1,    -1,    -1,   128,    -1,
     293,    -1,    -1,   133,    -1,    -1,   136,    -1,    -1,   139,
     140,    -1,    -1,   143,    -1,    -1,   146,    -1,   148,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   171,   172,    -1,   174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,    -1,   212,    -1,     9,    10,    11,    12,    13,    14,
      -1,   221,    -1,    -1,   224,   225,    21,    -1,    23,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   259,
     260,    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,
      -1,    -1,   272,    -1,    -1,    -1,   276,   277,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   286,   287,    -1,    -1,
      21,    -1,    23,   293,    -1,    90,    91,    92,    93,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,   102,    -1,    -1,
      -1,   106,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,
      -1,   116,    -1,    -1,    -1,    -1,    -1,   122,    -1,    60,
      -1,    -1,    -1,   128,    -1,    -1,    -1,    -1,   133,    -1,
      -1,   136,    -1,    -1,   139,   140,    -1,    -1,   143,    -1,
      -1,   146,    -1,   148,    -1,    -1,    -1,    -1,    -1,    90,
      91,    92,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,   102,    -1,    -1,    -1,   106,   171,   172,    -1,    -1,
      -1,   112,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,
      -1,   122,    -1,    -1,    -1,    -1,    -1,   128,    -1,    -1,
      -1,    -1,   133,    -1,    -1,   136,    -1,    -1,   139,   140,
      -1,    -1,   143,    -1,    -1,   146,    -1,   148,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,   224,
     225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     171,   172,    21,    -1,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   259,   260,    -1,   262,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    60,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     221,   286,   287,   224,   225,   290,    -1,    -1,   293,   294,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    91,    92,    93,    -1,    -1,    -1,    -1,    98,
      -1,    -1,    -1,   102,    -1,    -1,    -1,   106,   259,   260,
      -1,   262,    -1,   112,    -1,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,    21,   128,
      23,    -1,    -1,    -1,   133,   286,   287,   136,    -1,   290,
     139,   140,   293,   294,   143,    -1,    -1,   146,    -1,   148,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    -1,    -1,
      -1,    -1,   171,   172,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,
      93,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,
      -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,    -1,   112,
      -1,    -1,   221,   116,    -1,   224,   225,    -1,    -1,   122,
      -1,    -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,    -1,
     133,    -1,    -1,   136,    -1,    -1,   139,   140,    -1,    -1,
     143,    -1,    -1,   146,    -1,   148,    -1,    -1,    -1,    -1,
     259,   260,    -1,   262,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,   172,
      -1,   174,    -1,    -1,    -1,    -1,    -1,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,   294,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,    -1,   212,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,    -1,
      -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    -1,    -1,    -1,    -1,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,   259,   260,    -1,    52,
      53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   272,
      -1,    -1,    -1,   276,   277,    68,    69,    70,    71,    72,
      73,    -1,    -1,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,    85,    -1,    87,    -1,    -1,    90,    91,    92,
      93,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,
      -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,    -1,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   122,
      -1,    -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,    -1,
     133,    -1,    -1,   136,    -1,    -1,   139,   140,    -1,    -1,
     143,    -1,    -1,   146,    -1,   148,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,   172,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,    -1,
     183,   184,    -1,    -1,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,    -1,   212,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   226,    -1,    -1,    -1,    23,    -1,    -1,
      -1,    -1,   235,    29,    30,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   256,    -1,    -1,   259,   260,   261,   262,
      -1,    -1,    -1,   266,    -1,    -1,    -1,   270,   271,   272,
      -1,    -1,    -1,   276,   277,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,    -1,    -1,   288,    -1,   290,    -1,    -1,
     293,   294,    -1,    -1,    90,    91,    92,    93,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,
      -1,    -1,   128,    -1,    -1,    -1,    -1,   133,    -1,    -1,
     136,    -1,    -1,   139,   140,    -1,    -1,   143,    -1,    -1,
     146,    -1,   148,    -1,    23,    -1,    -1,    -1,    -1,    -1,
      29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   171,   172,    -1,   174,   175,
     176,   177,    -1,    -1,    -1,    -1,    -1,   183,   184,    -1,
      -1,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,    -1,   212,    -1,    -1,    -1,
      -1,    90,    91,    92,    93,    -1,    -1,    -1,    -1,    98,
      -1,    -1,    -1,   102,    -1,    -1,    -1,   106,    -1,    -1,
      -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,    -1,   128,
      -1,    -1,    -1,    -1,   133,    -1,    -1,   136,    -1,    -1,
     139,   140,    -1,    -1,   143,    -1,   272,   146,    -1,   148,
     276,   277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,    -1,   290,    -1,    -1,   293,   294,    -1,
      -1,    -1,   171,   172,    -1,   174,   175,   176,   177,    -1,
      -1,    -1,    -1,    23,   183,   184,    -1,    -1,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,    -1,   212,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    69,
      70,    71,    72,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,
      90,    91,    92,    93,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
      -1,    -1,   112,   272,    -1,    -1,   116,   276,   277,    -1,
      -1,    -1,   122,    -1,    60,    -1,    -1,    -1,   128,   288,
      -1,    -1,    -1,   133,   293,   294,   136,    -1,    -1,   139,
     140,    -1,    -1,   143,    -1,    -1,   146,    -1,   148,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,   102,    -1,    -1,    -1,
     106,   171,   172,    -1,    -1,    -1,   112,    -1,    -1,    -1,
     116,    -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,
      -1,    -1,   128,    -1,    -1,    -1,    -1,   133,    -1,    -1,
     136,    -1,    -1,   139,   140,    -1,    -1,   143,    -1,    -1,
     146,    -1,   148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   221,    -1,    -1,   224,   225,    -1,    -1,    -1,    23,
      -1,    -1,    -1,    -1,    -1,   171,   172,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   259,
     260,    -1,   262,    -1,    -1,    -1,    60,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,   286,   287,   224,   225,
      -1,    -1,    -1,   293,   294,    -1,    90,    91,    92,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,    -1,    -1,   112,    -1,
      -1,    -1,   116,   259,   260,    -1,   262,    -1,   122,    -1,
      -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,    -1,   133,
      -1,    -1,   136,    -1,    -1,   139,   140,    -1,    -1,   143,
     286,   287,   146,    -1,   148,    -1,    -1,   293,   294,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,   172,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,    -1,   212,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,
     224,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     0,     1,   259,   260,     4,    -1,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,
      -1,    -1,   276,   277,    -1,    -1,    -1,    -1,    25,    26,
      27,    28,   286,   287,    -1,    -1,    -1,    -1,    35,   293,
      37,    -1,    39,    -1,    -1,    42,    43,    44,    -1,    46,
      -1,    -1,    -1,    50,    51,    52,    -1,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      35,    36,    37,    38,    -1,    -1,    41,    42,    -1,    44,
      45,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,    -1,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   106,
      -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,
      85,    -1,    87,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,   128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   226,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,   212,    -1,   246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   226,    -1,    -1,    -1,    -1,   231,   232,   233,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,   246
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   299,     0,     1,     4,     6,    25,    26,    27,    28,
      35,    37,    39,    42,    43,    44,    46,    50,    51,    52,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    97,   106,   112,   128,   212,   226,   241,
     246,   300,   302,   303,   304,   305,   358,   359,   360,   362,
     376,   300,    92,    91,   355,   355,   355,   360,   362,   376,
     360,   365,   365,   365,   360,   368,   305,    39,   306,    35,
      37,    42,    43,    44,    46,   212,   226,   241,   246,   307,
      39,   308,    35,    37,    39,    42,    43,    44,    46,   212,
     226,   241,   246,   309,    43,   310,    35,    36,    37,    38,
      41,    42,    44,    45,    48,    85,    87,    88,    89,   212,
     226,   231,   232,   233,   241,   246,   311,   226,   231,   232,
     246,   312,    35,    37,    42,    44,    48,    85,    87,   313,
      37,   314,    23,    29,    30,    90,    91,    92,    93,    98,
     102,   106,   112,   122,   128,   133,   136,   139,   140,   143,
     146,   148,   171,   172,   174,   175,   176,   177,   183,   184,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   212,   272,   276,   277,   288,   293,   294,
     322,   356,   458,   459,   460,   461,   462,   514,   517,   519,
     523,   524,   526,   528,   538,   539,   541,   543,   545,   547,
     549,   551,   553,   555,   557,   559,   561,   563,   565,   569,
     571,   573,   574,   576,   578,   580,   582,   584,   586,   588,
     590,    48,   282,   283,   284,   315,   321,    48,   316,   321,
      91,   317,   318,   220,   360,   370,   370,   370,     0,   300,
     355,   355,    47,   279,   280,   373,   374,   375,    42,    52,
      53,    68,    69,    70,    71,    72,    73,    85,    87,   189,
     212,   226,   235,   241,   246,   256,   259,   260,   261,   262,
     266,   270,   271,   285,   290,   380,   381,   382,   383,   384,
     385,   389,   390,   391,   394,   395,   402,   406,   410,   411,
     413,   414,   430,   431,   433,   434,   436,   438,   441,   442,
     449,   450,   451,   452,   453,   456,   457,   461,   466,   467,
     468,   469,   470,   471,   475,   476,   477,   499,   513,   517,
     518,   536,   537,   538,   300,   289,   289,   300,   323,   326,
     380,   355,   328,   330,   458,   477,   333,   355,   337,   362,
     377,   360,   362,   365,   365,   365,   368,   220,   370,   370,
     370,   376,   358,   360,   361,   360,   362,   363,   377,   360,
     365,   366,   365,   365,   368,   220,   493,   360,   370,   371,
     370,   371,   370,   371,   365,   360,   359,   379,   362,   379,
      35,   379,   365,   365,   379,   379,    35,    36,   365,   379,
     379,   234,   493,   370,    35,   379,    35,   379,    35,   379,
     370,   370,   370,    35,   379,    35,   379,   370,   360,   362,
     365,   365,   379,    35,   365,   362,    94,    95,    96,   355,
     540,    99,   100,   190,   191,   194,   464,   465,    31,   520,
      99,   100,   101,   542,   101,   103,   104,   105,   544,   107,
     108,   109,   110,   111,   546,    99,   100,   103,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   548,   101,   103,
     121,   123,   124,   125,   126,   550,    99,   100,   113,   115,
     116,   117,   130,   131,   132,   552,   101,   103,   121,   123,
     124,   126,   134,   135,   554,   114,   124,   131,   137,   138,
     556,   124,   138,   558,   131,   141,   142,   560,   117,   121,
     144,   145,   562,   121,   144,   145,   147,   564,   121,   124,
     137,   141,   144,   145,   149,   150,   151,   152,   153,   566,
     101,   144,   145,   570,   121,   144,   145,   173,   572,   101,
     112,   114,   126,   128,   131,   178,   210,   211,   525,   527,
     577,   179,   579,   179,   581,   141,   180,   181,   182,   583,
     114,   131,   575,   103,   118,   131,   137,   185,   186,   585,
     114,   131,   587,   101,   114,   121,   131,   137,   589,    91,
     117,   120,   129,   263,   515,   516,   517,    99,   100,   120,
     190,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   228,   229,   230,   529,   530,   533,
     263,   273,   522,   471,   476,   274,   174,   183,   184,   187,
     188,   591,   355,   470,   321,   283,   321,    36,    38,    40,
      41,    48,    49,    80,   319,   370,   355,   228,   489,   490,
     242,   497,   498,   244,   245,   403,   491,   492,    90,    90,
      90,   450,   355,   355,    86,   355,    91,   515,   166,   529,
     530,   227,   227,   242,   227,   403,    74,    74,   112,   128,
     437,     4,   301,   478,   479,   281,   378,   383,   228,   229,
     392,   393,   141,   236,   237,   238,   239,   240,   396,   397,
     257,   412,     5,    21,    60,    74,    98,   102,   106,   112,
     116,   128,   174,   221,   224,   225,   259,   260,   286,   287,
     415,   416,   417,   418,   419,   420,   421,   423,   424,   425,
     426,   427,   428,   429,   459,   460,   508,   509,   510,   514,
     523,   524,   526,   528,   534,   535,   538,    74,   263,   264,
     265,   432,   439,   440,    74,   435,   439,   267,   268,   269,
     443,   444,   445,   446,    23,   459,    35,   454,   455,    15,
      16,    17,    18,   292,     8,    24,    44,     9,    10,    11,
      12,    13,    14,    98,   102,   106,   112,   122,   128,   133,
     136,   139,   140,   143,   146,   148,   171,   172,   262,   294,
     426,   459,   460,   472,   473,   474,   477,   500,   501,   502,
     503,   504,   505,   506,   507,   509,   510,   511,   512,    42,
      42,   488,   500,   501,   488,   290,   290,   290,   290,   290,
     373,   380,   323,   326,   328,   330,   333,   337,   370,   490,
     498,   492,   380,    47,    47,    47,   330,   370,    47,   330,
     360,   365,   379,    35,   370,   360,   360,   360,   360,   360,
     365,   355,     7,     8,   101,   194,   195,   463,   151,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     567,   527,   296,   296,    99,   100,   120,   213,   214,   215,
     525,   531,   533,   274,   274,    90,   295,   320,   321,   496,
      90,   244,   245,   407,    90,   447,   448,   471,    23,    84,
     290,    42,    42,    90,   244,   533,    42,   428,   428,   407,
     428,    90,   428,   428,    74,   474,   477,   482,   483,   486,
     506,   507,     7,   291,   356,    90,    90,   393,    67,    98,
     112,   148,   197,   399,   356,    90,    90,    90,   356,   398,
     397,   122,   133,   148,   258,   428,     5,   428,    15,    16,
      17,    18,   292,    20,    22,     8,    44,     5,   439,     7,
       7,     5,     7,     5,   428,   428,   444,     7,   290,   355,
     290,   455,   511,   511,   502,   503,   504,   470,    23,   290,
     386,   501,   506,     7,    15,    16,    17,    18,   292,     7,
      20,    22,     8,   501,   428,   428,   300,   300,   325,   327,
     329,   334,   338,   290,   290,   290,   290,   290,   496,    90,
      90,    90,   496,    90,   360,    90,   465,    84,   117,   165,
     166,   167,   168,   169,   170,   568,    90,    90,    99,   100,
     532,    90,    90,   275,   521,   290,   229,    90,    91,   229,
     404,   459,    78,   378,   484,   485,   356,    90,   471,   480,
     481,   428,   428,    90,    42,   428,    90,   404,    33,   428,
     301,     5,   301,   484,   301,   479,   127,   124,   127,   400,
     401,   101,   101,    60,   101,   428,     5,   415,   459,   510,
     511,   416,   417,   418,    90,   420,   415,   422,   459,   477,
     428,   459,   510,   534,   534,   428,   440,   428,   439,   446,
     447,   480,   355,   301,   387,   388,   295,   506,   511,   511,
     502,   503,   504,   506,    90,   506,   506,    37,    42,    44,
      46,   141,   212,   226,   241,   246,   291,   300,   302,   324,
      81,   101,   291,   300,   302,   350,   353,   380,    77,    78,
      79,    80,    81,    84,   101,   141,   291,   300,   302,   335,
      78,    80,   101,   141,   291,   300,   302,   335,    32,    34,
     291,   300,   302,   325,   327,   329,   334,   338,   290,     7,
     297,   297,   521,   278,   521,    90,   347,    90,    20,    91,
     247,   405,    91,   357,   485,   290,   383,   484,   428,    20,
      91,   405,   428,    33,   487,   506,   507,   513,     7,    91,
      91,    91,   428,   439,   439,     5,   291,   383,   482,     7,
     291,   355,   364,   355,   367,   367,   355,   369,    91,   220,
     355,   372,   372,   372,   300,    68,    69,   354,    91,   300,
     300,   300,   357,   357,   289,    82,    83,   336,    90,    91,
     115,   116,   190,   210,   342,   343,   349,    75,    76,    78,
     331,   332,   300,   357,   289,   343,   331,   300,    91,   289,
     291,   291,   291,   291,   291,   347,    90,    90,   101,   213,
     291,   300,   302,   495,   251,   252,   253,   254,   255,   409,
     243,   408,    90,   480,   291,   409,   408,   428,   301,   401,
     447,   291,     5,   301,   388,   326,   328,   333,   337,   372,
     344,   344,   344,    32,   300,   300,   330,     8,   300,     7,
     300,   300,   330,     5,   300,   129,   290,   339,   291,   521,
      92,   359,   300,   408,    90,   404,   383,   408,   291,   513,
     290,   290,   290,   290,   344,   290,   290,   290,    91,   342,
     332,   226,   241,   246,   343,    22,    90,   351,    91,   340,
     341,   300,   300,   120,   300,    91,   228,   229,   291,   301,
     327,   329,   334,   338,   290,   345,   348,   346,    33,   352,
     300,   300,   300,   300,    90,   300,     7,   291,   143,   148,
     494,   291,   291,   291,   291,   347,   291,   300,   302,   489,
     291,   300,   302,   497,   291,   300,   302,   491,    91,   129,
     301,   341,   300,   300,   300,   300,   300,   291,   300,   300,
     300,   351,   300
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   298,   299,   299,   300,   300,   301,   301,   302,   302,
     302,   302,   302,   303,   303,   303,   303,   304,   304,   304,
     304,   304,   304,   304,   304,   304,   304,   304,   304,   304,
     304,   304,   305,   305,   305,   305,   305,   305,   305,   305,
     305,   305,   305,   305,   305,   305,   305,   306,   307,   307,
     307,   307,   307,   307,   307,   307,   307,   307,   307,   307,
     307,   308,   309,   309,   309,   309,   309,   309,   309,   309,
     309,   309,   309,   309,   309,   309,   309,   309,   309,   310,
     311,   311,   311,   311,   311,   311,   311,   311,   311,   311,
     311,   311,   311,   311,   311,   311,   311,   311,   311,   311,
     311,   311,   311,   311,   311,   311,   312,   312,   312,   312,
     312,   312,   313,   313,   313,   313,   313,   313,   313,   314,
     315,   315,   316,   316,   317,   318,   318,   319,   319,   319,
     319,   319,   319,   319,   319,   320,   320,   321,   321,   321,
     322,   323,   324,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   326,   327,   327,   327,   327,
     327,   327,   328,   329,   329,   329,   329,   329,   329,   329,
     329,   329,   329,   330,   330,   331,   331,   332,   332,   332,
     333,   334,   334,   334,   334,   334,   334,   334,   334,   334,
     334,   334,   335,   335,   336,   336,   337,   338,   338,   338,
     338,   338,   339,   340,   340,   340,   341,   342,   343,   343,
     344,   345,   345,   345,   345,   346,   346,   346,   346,   347,
     347,   347,   347,   348,   348,   348,   348,   349,   349,   349,
     349,   349,   350,   351,   351,   352,   352,   353,   354,   354,
     355,   356,   356,   356,   357,   358,   358,   359,   359,   359,
     359,   359,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     376,   376,   376,   377,   378,   379,   379,   380,   380,   381,
     382,   382,   383,   383,   383,   383,   383,   383,   383,   383,
     383,   383,   383,   383,   383,   383,   383,   383,   383,   383,
     383,   383,   384,   384,   385,   386,   386,   387,   387,   387,
     388,   389,   389,   390,   390,   391,   391,   392,   392,   393,
     393,   394,   394,   395,   396,   396,   397,   397,   397,   397,
     397,   397,   398,   399,   399,   399,   399,   399,   400,   400,
     401,   401,   402,   402,   402,   403,   403,   403,   404,   404,
     405,   405,   406,   406,   407,   407,   407,   408,   408,   408,
     408,   409,   409,   409,   409,   409,   410,   411,   412,   412,
     412,   412,   412,   413,   414,   414,   415,   415,   415,   415,
     415,   415,   415,   415,   415,   415,   416,   416,   416,   417,
     417,   418,   418,   419,   419,   420,   421,   421,   422,   422,
     423,   423,   424,   425,   426,   427,   427,   427,   428,   428,
     428,   429,   429,   429,   429,   429,   429,   429,   430,   430,
     431,   432,   432,   432,   433,   433,   434,   435,   435,   435,
     435,   435,   436,   436,   437,   437,   438,   438,   439,   439,
     440,   440,   440,   441,   441,   442,   443,   443,   444,   444,
     445,   445,   446,   446,   447,   447,   448,   449,   449,   450,
     450,   451,   452,   452,   453,   454,   454,   455,   456,   456,
     457,   458,   459,   459,   459,   460,   461,   461,   461,   461,
     461,   461,   461,   461,   461,   461,   461,   461,   461,   462,
     463,   463,   463,   464,   464,   464,   464,   464,   465,   465,
     466,   466,   466,   467,   467,   468,   468,   469,   469,   470,
     471,   471,   472,   473,   474,   474,   474,   475,   476,   476,
     476,   477,   478,   478,   478,   479,   479,   479,   480,   480,
     481,   482,   482,   483,   484,   484,   485,   485,   486,   486,
     487,   487,   488,   488,   489,   490,   491,   492,   493,   494,
     494,   495,   495,   496,   497,   497,   498,   499,   499,   499,
     500,   500,   501,   501,   501,   502,   502,   502,   503,   503,
     504,   504,   505,   505,   506,   507,   507,   508,   508,   509,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   512,   512,
     512,   512,   512,   512,   513,   513,   513,   513,   513,   513,
     514,   514,   514,   515,   515,   516,   516,   516,   516,   517,
     517,   517,   517,   517,   517,   517,   517,   517,   517,   517,
     517,   517,   517,   517,   517,   517,   517,   517,   517,   518,
     518,   518,   518,   518,   519,   520,   521,   521,   522,   522,
     523,   524,   524,   524,   525,   525,   526,   526,   527,   527,
     527,   528,   528,   528,   529,   529,   530,   530,   530,   530,
     530,   530,   530,   530,   530,   530,   530,   530,   530,   530,
     530,   531,   531,   531,   531,   531,   531,   531,   532,   532,
     533,   533,   533,   533,   534,   534,   535,   535,   536,   536,
     537,   538,   538,   538,   538,   538,   538,   538,   538,   538,
     538,   538,   538,   538,   538,   538,   538,   539,   540,   540,
     540,   541,   542,   542,   542,   543,   544,   544,   544,   544,
     545,   546,   546,   546,   546,   546,   547,   548,   548,   548,
     548,   548,   548,   548,   548,   548,   548,   548,   548,   549,
     550,   550,   550,   550,   550,   550,   550,   551,   552,   552,
     552,   552,   552,   552,   552,   552,   552,   553,   554,   554,
     554,   554,   554,   554,   554,   554,   555,   556,   556,   556,
     556,   556,   557,   558,   558,   559,   560,   560,   560,   561,
     562,   562,   562,   562,   563,   564,   564,   564,   564,   565,
     565,   565,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   567,   567,   567,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   568,   568,   568,   568,   568,   568,
     568,   568,   569,   570,   570,   570,   571,   572,   572,   572,
     572,   573,   573,   573,   573,   573,   573,   573,   573,   574,
     575,   575,   576,   577,   577,   577,   577,   578,   579,   580,
     581,   582,   583,   583,   583,   583,   584,   585,   585,   585,
     585,   585,   585,   586,   587,   587,   588,   589,   589,   589,
     589,   589,   590,   591,   591,   591,   591,   591
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     0,     3,     5,
       5,     3,     2,     1,     1,     2,     2,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     6,     2,     6,     3,     2,     6,     6,
       3,     6,     2,     3,     3,     8,     3,     3,     2,     6,
       2,     6,     6,     6,     3,     6,     2,     3,     3,     8,
       3,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     2,     2,     2,     2,     2,     4,     2,     2,     3,
       2,     2,     2,     2,     2,     3,     2,     2,     3,     2,
       2,     3,     2,     2,     3,     2,     2,     3,     3,     2,
       2,     2,     2,     2,     3,     4,     2,     3,     2,     2,
       3,     2,     2,     2,     2,     2,     3,     2,     2,     3,
       2,     1,     2,     1,     3,     0,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     1,     2,
       1,     0,     2,     0,     2,     2,     3,     8,     8,     8,
       8,     8,     8,     9,     8,     0,     0,     2,     2,     3,
       3,     3,     0,     0,     2,     2,     4,     4,     4,     4,
       4,     2,     3,     1,     1,     3,     1,     1,     1,     1,
       0,     0,     2,     2,     4,     6,     6,     6,     6,     4,
       4,     3,     2,     2,     1,     1,     0,     0,     2,     2,
       6,     5,     3,     1,     3,     3,     1,     1,     1,     3,
       0,     0,     2,     2,     2,     0,     2,     2,     2,     0,
       2,     2,     2,     0,     2,     2,     2,     1,     1,     1,
       1,     1,     7,     1,     2,     2,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     2,     3,     1,     2,     3,
       1,     2,     1,     2,     3,     1,     2,     2,     2,     1,
       2,     2,     2,     2,     2,     0,     1,     1,     2,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     2,     1,     3,     3,
       5,     3,     4,     1,     2,     1,     3,     1,     2,     2,
       2,     1,     2,     1,     1,     2,     2,     2,     2,     2,
       2,     2,     1,     2,     2,     1,     1,     1,     3,     1,
       1,     1,     7,     6,     3,     1,     1,     0,     1,     1,
       0,     3,     5,     3,     1,     1,     0,     0,     3,     3,
       3,     1,     1,     1,     1,     1,     2,     1,     0,     4,
       4,     4,     3,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     1,
       3,     1,     3,     1,     3,     1,     1,     3,     1,     1,
       3,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     4,     2,     3,     2,     2,     1,
       1,     3,     4,     1,     2,     1,     1,     2,     3,     1,
       3,     4,     3,     5,     1,     1,     3,     6,     1,     3,
       1,     1,     1,     1,     2,     1,     1,     2,     2,     1,
       1,     3,     1,     1,     1,     2,     1,     4,     5,     1,
       1,     7,     6,     1,     1,     1,     2,     2,     6,     8,
       1,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     3,     3,     1,     3,     1,     3,     1,     3,     1,
       1,     3,     3,     3,     1,     1,     1,     3,     1,     1,
       1,     3,     1,     3,     3,     3,     3,     5,     1,     2,
       1,     1,     2,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     4,     1,     4,     1,     1,     1,
       1,     5,     3,     0,     6,     5,     1,     2,     2,     3,
       3,     3,     1,     1,     1,     1,     3,     3,     1,     3,
       1,     3,     1,     3,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       2,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       3,     4,     1,     4,     2,     1,     0,     2,     1,     1,
       5,     7,     5,     4,     1,     1,     2,     3,     1,     1,
       1,     2,     3,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     4,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     6,     1,     1,
       1,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     2,     1,     1,     2,     1,     1,     1,     2,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     2,
       4,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     2,     1,     1,     1,     1,     2,     4,     2,
       1,     2,     1,     1,     1,     4,     2,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     2,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, nft, scanner, state, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, nft, scanner, state); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (nft);
  YYUSE (scanner);
  YYUSE (state);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, nft, scanner, state);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , nft, scanner, state);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, nft, scanner, state); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (nft);
  YYUSE (scanner);
  YYUSE (state);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yytype)
    {
          case 91: /* "string"  */
#line 263 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 3663 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 92: /* "quoted string"  */
#line 263 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 3669 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 93: /* "string with a trailing asterisk"  */
#line 263 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 3675 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 303: /* line  */
#line 511 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3681 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 304: /* base_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3687 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 305: /* add_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3693 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 306: /* replace_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3699 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 307: /* create_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3705 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 308: /* insert_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3711 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 309: /* delete_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3717 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 310: /* get_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3723 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 311: /* list_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3729 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 312: /* reset_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3735 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 313: /* flush_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3741 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 314: /* rename_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3747 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 315: /* import_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3753 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 316: /* export_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3759 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 317: /* monitor_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3765 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 318: /* monitor_event  */
#line 717 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 3771 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 322: /* describe_cmd  */
#line 514 "parser_bison.y" /* yacc.c:1257  */
      { cmd_free(((*yyvaluep).cmd)); }
#line 3777 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 323: /* table_block_alloc  */
#line 526 "parser_bison.y" /* yacc.c:1257  */
      { close_scope(state); table_free(((*yyvaluep).table)); }
#line 3783 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 326: /* chain_block_alloc  */
#line 528 "parser_bison.y" /* yacc.c:1257  */
      { close_scope(state); chain_free(((*yyvaluep).chain)); }
#line 3789 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 328: /* set_block_alloc  */
#line 537 "parser_bison.y" /* yacc.c:1257  */
      { set_free(((*yyvaluep).set)); }
#line 3795 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 330: /* set_block_expr  */
#line 628 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 3801 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 333: /* map_block_alloc  */
#line 540 "parser_bison.y" /* yacc.c:1257  */
      { set_free(((*yyvaluep).set)); }
#line 3807 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 337: /* flowtable_block_alloc  */
#line 543 "parser_bison.y" /* yacc.c:1257  */
      { flowtable_free(((*yyvaluep).flowtable)); }
#line 3813 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 339: /* flowtable_expr  */
#line 628 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 3819 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 340: /* flowtable_list_expr  */
#line 628 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 3825 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 341: /* flowtable_expr_member  */
#line 628 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 3831 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 342: /* data_type_atom_expr  */
#line 508 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 3837 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 343: /* data_type_expr  */
#line 508 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 3843 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 344: /* obj_block_alloc  */
#line 546 "parser_bison.y" /* yacc.c:1257  */
      { obj_free(((*yyvaluep).obj)); }
#line 3849 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 349: /* type_identifier  */
#line 503 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 3855 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 352: /* dev_spec  */
#line 523 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 3861 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 355: /* identifier  */
#line 503 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 3867 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 356: /* string  */
#line 503 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 3873 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 360: /* table_spec  */
#line 517 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3879 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 361: /* tableid_spec  */
#line 517 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3885 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 362: /* chain_spec  */
#line 517 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3891 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 363: /* chainid_spec  */
#line 517 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3897 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 364: /* chain_identifier  */
#line 517 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3903 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 365: /* set_spec  */
#line 519 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3909 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 366: /* setid_spec  */
#line 519 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3915 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 367: /* set_identifier  */
#line 519 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3921 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 368: /* flowtable_spec  */
#line 517 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3927 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 370: /* obj_spec  */
#line 519 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3933 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 371: /* objid_spec  */
#line 519 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3939 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 372: /* obj_identifier  */
#line 519 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3945 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 373: /* handle_spec  */
#line 517 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3951 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 374: /* position_spec  */
#line 517 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3957 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 375: /* index_spec  */
#line 517 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3963 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 376: /* rule_position  */
#line 517 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3969 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 377: /* ruleid_spec  */
#line 517 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3975 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 378: /* comment_spec  */
#line 503 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 3981 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 379: /* ruleset_spec  */
#line 517 "parser_bison.y" /* yacc.c:1257  */
      { handle_free(&((*yyvaluep).handle)); }
#line 3987 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 380: /* rule  */
#line 530 "parser_bison.y" /* yacc.c:1257  */
      { rule_free(((*yyvaluep).rule)); }
#line 3993 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 382: /* stmt_list  */
#line 549 "parser_bison.y" /* yacc.c:1257  */
      { stmt_list_free(((*yyvaluep).list)); xfree(((*yyvaluep).list)); }
#line 3999 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 383: /* stmt  */
#line 551 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4005 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 384: /* verdict_stmt  */
#line 551 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4011 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 385: /* verdict_map_stmt  */
#line 622 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4017 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 386: /* verdict_map_expr  */
#line 625 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4023 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 387: /* verdict_map_list_expr  */
#line 625 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4029 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 388: /* verdict_map_list_member_expr  */
#line 625 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4035 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 389: /* connlimit_stmt  */
#line 564 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4041 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 390: /* counter_stmt  */
#line 553 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4047 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 391: /* counter_stmt_alloc  */
#line 553 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4053 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 394: /* log_stmt  */
#line 561 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4059 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 395: /* log_stmt_alloc  */
#line 561 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4065 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 402: /* limit_stmt  */
#line 564 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4071 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 404: /* quota_unit  */
#line 523 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).string)); }
#line 4077 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 406: /* quota_stmt  */
#line 564 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4083 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 410: /* reject_stmt  */
#line 567 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4089 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 411: /* reject_stmt_alloc  */
#line 567 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4095 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 413: /* nat_stmt  */
#line 569 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4101 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 414: /* nat_stmt_alloc  */
#line 569 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4107 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 415: /* primary_stmt_expr  */
#line 609 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4113 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 416: /* shift_stmt_expr  */
#line 611 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4119 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 417: /* and_stmt_expr  */
#line 613 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4125 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 418: /* exclusive_or_stmt_expr  */
#line 613 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4131 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 419: /* inclusive_or_stmt_expr  */
#line 613 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4137 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 420: /* basic_stmt_expr  */
#line 609 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4143 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 421: /* concat_stmt_expr  */
#line 601 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4149 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 422: /* map_stmt_expr_set  */
#line 601 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4155 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 423: /* map_stmt_expr  */
#line 601 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4161 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 424: /* prefix_stmt_expr  */
#line 606 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4167 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 425: /* range_stmt_expr  */
#line 606 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4173 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 426: /* wildcard_expr  */
#line 606 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4179 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 427: /* multiton_stmt_expr  */
#line 604 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4185 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 428: /* stmt_expr  */
#line 601 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4191 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 430: /* masq_stmt  */
#line 569 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4197 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 431: /* masq_stmt_alloc  */
#line 569 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4203 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 433: /* redir_stmt  */
#line 569 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4209 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 434: /* redir_stmt_alloc  */
#line 569 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4215 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 436: /* dup_stmt  */
#line 575 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4221 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 438: /* fwd_stmt  */
#line 577 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4227 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 441: /* queue_stmt  */
#line 572 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4233 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 442: /* queue_stmt_alloc  */
#line 572 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4239 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 447: /* set_elem_expr_stmt  */
#line 632 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4245 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 448: /* set_elem_expr_stmt_alloc  */
#line 632 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4251 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 449: /* set_stmt  */
#line 579 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4257 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 451: /* map_stmt  */
#line 582 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4263 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 452: /* meter_stmt  */
#line 584 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4269 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 453: /* flow_stmt_legacy_alloc  */
#line 584 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4275 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 456: /* meter_stmt_alloc  */
#line 584 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4281 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 457: /* match_stmt  */
#line 551 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4287 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 458: /* variable_expr  */
#line 587 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4293 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 459: /* symbol_expr  */
#line 587 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4299 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 460: /* integer_expr  */
#line 587 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4305 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 461: /* primary_expr  */
#line 589 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4311 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 462: /* fib_expr  */
#line 712 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4317 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 466: /* shift_expr  */
#line 589 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4323 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 467: /* and_expr  */
#line 589 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4329 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 468: /* exclusive_or_expr  */
#line 591 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4335 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 469: /* inclusive_or_expr  */
#line 591 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4341 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 470: /* basic_expr  */
#line 593 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4347 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 471: /* concat_expr  */
#line 616 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4353 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 472: /* prefix_rhs_expr  */
#line 598 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4359 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 473: /* range_rhs_expr  */
#line 598 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4365 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 474: /* multiton_rhs_expr  */
#line 596 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4371 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 475: /* map_expr  */
#line 619 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4377 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 476: /* expr  */
#line 638 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4383 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 477: /* set_expr  */
#line 628 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4389 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 478: /* set_list_expr  */
#line 628 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4395 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 479: /* set_list_member_expr  */
#line 628 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4401 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 480: /* meter_key_expr  */
#line 635 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4407 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 481: /* meter_key_expr_alloc  */
#line 635 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4413 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 482: /* set_elem_expr  */
#line 630 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4419 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 483: /* set_elem_expr_alloc  */
#line 630 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4425 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 486: /* set_lhs_expr  */
#line 630 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4431 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 487: /* set_rhs_expr  */
#line 630 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4437 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 488: /* initializer_expr  */
#line 638 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4443 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 489: /* counter_config  */
#line 721 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).counter)); }
#line 4449 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 490: /* counter_obj  */
#line 648 "parser_bison.y" /* yacc.c:1257  */
      { obj_free(((*yyvaluep).obj)); }
#line 4455 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 491: /* quota_config  */
#line 723 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).quota)); }
#line 4461 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 492: /* quota_obj  */
#line 648 "parser_bison.y" /* yacc.c:1257  */
      { obj_free(((*yyvaluep).obj)); }
#line 4467 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 496: /* ct_obj_alloc  */
#line 648 "parser_bison.y" /* yacc.c:1257  */
      { obj_free(((*yyvaluep).obj)); }
#line 4473 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 497: /* limit_config  */
#line 725 "parser_bison.y" /* yacc.c:1257  */
      { xfree(((*yyvaluep).limit)); }
#line 4479 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 498: /* limit_obj  */
#line 648 "parser_bison.y" /* yacc.c:1257  */
      { obj_free(((*yyvaluep).obj)); }
#line 4485 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 499: /* relational_expr  */
#line 651 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4491 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 500: /* list_rhs_expr  */
#line 643 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4497 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 501: /* rhs_expr  */
#line 641 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4503 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 502: /* shift_rhs_expr  */
#line 643 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4509 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 503: /* and_rhs_expr  */
#line 645 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4515 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 504: /* exclusive_or_rhs_expr  */
#line 645 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4521 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 505: /* inclusive_or_rhs_expr  */
#line 645 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4527 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 506: /* basic_rhs_expr  */
#line 641 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4533 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 507: /* concat_rhs_expr  */
#line 641 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4539 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 509: /* boolean_expr  */
#line 733 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4545 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 510: /* keyword_expr  */
#line 638 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4551 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 511: /* primary_rhs_expr  */
#line 643 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4557 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 513: /* verdict_expr  */
#line 587 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4563 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 514: /* meta_expr  */
#line 692 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4569 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 518: /* meta_stmt  */
#line 559 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4575 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 519: /* socket_expr  */
#line 696 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4581 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 523: /* numgen_expr  */
#line 664 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4587 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 524: /* hash_expr  */
#line 664 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4593 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 526: /* rt_expr  */
#line 702 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4599 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 528: /* ct_expr  */
#line 708 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4605 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 534: /* symbol_stmt_expr  */
#line 643 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4611 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 535: /* list_stmt_expr  */
#line 611 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4617 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 536: /* ct_stmt  */
#line 557 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4623 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 537: /* payload_stmt  */
#line 555 "parser_bison.y" /* yacc.c:1257  */
      { stmt_free(((*yyvaluep).stmt)); }
#line 4629 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 538: /* payload_expr  */
#line 655 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4635 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 539: /* payload_raw_expr  */
#line 655 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4641 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 541: /* eth_hdr_expr  */
#line 658 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4647 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 543: /* vlan_hdr_expr  */
#line 658 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4653 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 545: /* arp_hdr_expr  */
#line 661 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4659 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 547: /* ip_hdr_expr  */
#line 664 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4665 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 549: /* icmp_hdr_expr  */
#line 664 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4671 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 551: /* ip6_hdr_expr  */
#line 667 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4677 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 553: /* icmp6_hdr_expr  */
#line 667 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4683 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 555: /* auth_hdr_expr  */
#line 670 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4689 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 557: /* esp_hdr_expr  */
#line 670 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4695 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 559: /* comp_hdr_expr  */
#line 670 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4701 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 561: /* udp_hdr_expr  */
#line 673 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4707 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 563: /* udplite_hdr_expr  */
#line 673 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4713 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 565: /* tcp_hdr_expr  */
#line 728 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4719 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 569: /* dccp_hdr_expr  */
#line 676 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4725 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 571: /* sctp_hdr_expr  */
#line 676 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4731 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 573: /* exthdr_expr  */
#line 680 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4737 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 574: /* hbh_hdr_expr  */
#line 682 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4743 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 576: /* rt_hdr_expr  */
#line 685 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4749 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 578: /* rt0_hdr_expr  */
#line 685 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4755 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 580: /* rt2_hdr_expr  */
#line 685 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4761 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 582: /* rt4_hdr_expr  */
#line 685 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4767 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 584: /* frag_hdr_expr  */
#line 682 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4773 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 586: /* dst_hdr_expr  */
#line 682 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4779 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 588: /* mh_hdr_expr  */
#line 688 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4785 "parser_bison.c" /* yacc.c:1257  */
        break;

    case 590: /* exthdr_exists_expr  */
#line 737 "parser_bison.y" /* yacc.c:1257  */
      { expr_free(((*yyvaluep).expr)); }
#line 4791 "parser_bison.c" /* yacc.c:1257  */
        break;


      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

/* User initialization code.  */
#line 123 "parser_bison.y" /* yacc.c:1429  */
{
	location_init(scanner, state, &yylloc);
	if (nft->debug_mask & NFT_DEBUG_SCANNER)
		nft_set_debug(1, scanner);
	if (nft->debug_mask & NFT_DEBUG_PARSER)
		yydebug = 1;
}

#line 4908 "parser_bison.c" /* yacc.c:1429  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, scanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 746 "parser_bison.y" /* yacc.c:1646  */
    {
				if ((yyvsp[0].cmd) != NULL) {
					LIST_HEAD(list);

					(yyvsp[0].cmd)->location = (yylsp[0]);

					list_add_tail(&(yyvsp[0].cmd)->list, &list);
					if (cmd_evaluate(&state->ectx, (yyvsp[0].cmd)) < 0) {
						cmd_free((yyvsp[0].cmd));
						if (++state->nerrs == nft->parser_max_errors)
							YYABORT;
					} else
						list_splice_tail(&list, state->cmds);
				}
			}
#line 5111 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 8:
#line 772 "parser_bison.y" /* yacc.c:1646  */
    {
				if (scanner_include_file(nft, scanner, (yyvsp[-1].string), &(yyloc)) < 0) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				xfree((yyvsp[-1].string));
			}
#line 5123 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 9:
#line 780 "parser_bison.y" /* yacc.c:1646  */
    {
				struct scope *scope = current_scope(state);

				if (symbol_lookup(scope, (yyvsp[-3].string)) != NULL) {
					erec_queue(error(&(yylsp[-3]), "redefinition of symbol '%s'", (yyvsp[-3].string)),
						   state->msgs);
					xfree((yyvsp[-3].string));
					YYERROR;
				}

				symbol_bind(scope, (yyvsp[-3].string), (yyvsp[-1].expr));
				xfree((yyvsp[-3].string));
			}
#line 5141 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 10:
#line 794 "parser_bison.y" /* yacc.c:1646  */
    {
				struct scope *scope = current_scope(state);

				symbol_bind(scope, (yyvsp[-3].string), (yyvsp[-1].expr));
				xfree((yyvsp[-3].string));
			}
#line 5152 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 11:
#line 801 "parser_bison.y" /* yacc.c:1646  */
    {
				struct scope *scope = current_scope(state);

				if (symbol_unbind(scope, (yyvsp[-1].string)) < 0) {
					erec_queue(error(&(yylsp[-1]), "undefined symbol '%s'", (yyvsp[-1].string)),
						   state->msgs);
					YYERROR;
				}
				xfree((yyvsp[-1].string));
			}
#line 5167 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 12:
#line 812 "parser_bison.y" /* yacc.c:1646  */
    {
				if (++state->nerrs == nft->parser_max_errors)
					YYABORT;
				yyerrok;
			}
#line 5177 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 13:
#line 819 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = NULL; }
#line 5183 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 14:
#line 820 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = NULL; }
#line 5189 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 15:
#line 821 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[-1].cmd); }
#line 5195 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 16:
#line 823 "parser_bison.y" /* yacc.c:1646  */
    {
				/*
				 * Very hackish workaround for bison >= 2.4: previous versions
				 * terminated parsing after EOF, 2.4+ tries to get further input
				 * in 'input' and calls the scanner again, causing a crash when
				 * the final input buffer has been popped. Terminate manually to
				 * avoid this. The correct fix should be to adjust the grammar
				 * to accept EOF in input, but for unknown reasons it does not
				 * work.
				 */
				if ((yyvsp[-1].cmd) != NULL) {
					LIST_HEAD(list);

					(yyvsp[-1].cmd)->location = (yylsp[-1]);

					list_add_tail(&(yyvsp[-1].cmd)->list, &list);
					if (cmd_evaluate(&state->ectx, (yyvsp[-1].cmd)) < 0) {
						cmd_free((yyvsp[-1].cmd));
						if (++state->nerrs == nft->parser_max_errors)
							YYABORT;
					} else
						list_splice_tail(&list, state->cmds);
				}
				if (state->nerrs)
					YYABORT;
				(yyval.cmd) = NULL;

				YYACCEPT;
			}
#line 5229 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 17:
#line 854 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5235 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 18:
#line 855 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5241 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 19:
#line 856 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5247 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 20:
#line 857 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5253 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 21:
#line 858 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5259 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 22:
#line 859 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5265 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 23:
#line 860 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5271 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 24:
#line 861 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5277 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 25:
#line 862 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5283 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 26:
#line 863 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5289 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 27:
#line 864 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5295 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 28:
#line 865 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5301 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 29:
#line 866 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5307 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 30:
#line 867 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5313 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 31:
#line 868 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.cmd) = (yyvsp[0].cmd); }
#line 5319 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 32:
#line 872 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5327 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 33:
#line 877 "parser_bison.y" /* yacc.c:1646  */
    {
				handle_merge(&(yyvsp[-3].table)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_TABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].table));
			}
#line 5337 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 34:
#line 883 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5345 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 35:
#line 888 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].chain)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_CHAIN, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].chain));
			}
#line 5356 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 36:
#line 895 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 5364 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 37:
#line 899 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 5372 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 38:
#line 904 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 5382 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 39:
#line 911 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 5392 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 40:
#line 917 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SETELEM, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 5400 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 41:
#line 922 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].flowtable)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].flowtable)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_FLOWTABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].flowtable));
			}
#line 5410 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 42:
#line 928 "parser_bison.y" /* yacc.c:1646  */
    {
				struct obj *obj;

				obj = obj_alloc(&(yyloc));
				obj->type = NFT_OBJECT_COUNTER;
				handle_merge(&obj->handle, &(yyvsp[0].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), obj);
			}
#line 5423 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 43:
#line 937 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_COUNTER, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].obj));
			}
#line 5431 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 44:
#line 941 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_QUOTA, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].obj));
			}
#line 5439 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 45:
#line 945 "parser_bison.y" /* yacc.c:1646  */
    {

				(yyval.cmd) = cmd_alloc_obj_ct(CMD_ADD, NFT_OBJECT_CT_HELPER, &(yyvsp[-5].handle), &(yyloc), (yyvsp[-4].obj));
			}
#line 5448 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 46:
#line 950 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_LIMIT, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].obj));
			}
#line 5456 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 47:
#line 956 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_REPLACE, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 5464 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 48:
#line 962 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5472 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 49:
#line 967 "parser_bison.y" /* yacc.c:1646  */
    {
				handle_merge(&(yyvsp[-3].table)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_TABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].table));
			}
#line 5482 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 50:
#line 973 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5490 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 51:
#line 978 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].chain)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_CHAIN, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].chain));
			}
#line 5501 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 52:
#line 986 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 5511 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 53:
#line 993 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 5521 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 54:
#line 999 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SETELEM, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 5529 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 55:
#line 1004 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].flowtable)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].flowtable)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_FLOWTABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].flowtable));
			}
#line 5539 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 56:
#line 1010 "parser_bison.y" /* yacc.c:1646  */
    {
				struct obj *obj;

				obj = obj_alloc(&(yyloc));
				obj->type = NFT_OBJECT_COUNTER;
				handle_merge(&obj->handle, &(yyvsp[0].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), obj);
			}
#line 5552 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 57:
#line 1019 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_COUNTER, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].obj));
			}
#line 5560 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 58:
#line 1023 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_QUOTA, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].obj));
			}
#line 5568 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 59:
#line 1027 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_CREATE, NFT_OBJECT_CT_HELPER, &(yyvsp[-5].handle), &(yyloc), (yyvsp[-4].obj));
			}
#line 5576 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 60:
#line 1031 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_LIMIT, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].obj));
			}
#line 5584 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1037 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_INSERT, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 5592 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 62:
#line 1043 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5600 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1047 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5608 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1051 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5616 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1055 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5624 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 66:
#line 1059 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_RULE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5632 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 67:
#line 1063 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5640 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 68:
#line 1067 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5648 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1071 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5656 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1075 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SETELEM, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 5664 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1079 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_FLOWTABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5672 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1083 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5680 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1087 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5688 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1091 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_QUOTA, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5696 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1095 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_QUOTA, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5704 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1099 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_DELETE, (yyvsp[-2].val), &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].obj));
			}
#line 5712 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1103 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_LIMIT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5720 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1107 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_LIMIT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5728 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1113 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_GET, CMD_OBJ_SETELEM, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 5736 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1119 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5744 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1123 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5752 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1127 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5760 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1131 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CHAINS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5768 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1135 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SETS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5776 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1139 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SETS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5784 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1143 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5792 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1147 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5800 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1151 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5808 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1155 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5816 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1159 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5824 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1163 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5832 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1167 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_QUOTA, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5840 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1171 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_LIMITS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5848 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1175 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_LIMITS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5856 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1179 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_LIMIT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5864 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1183 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_RULESET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5872 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1187 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5880 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1191 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5888 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1195 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5896 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1199 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5904 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1203 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_FLOWTABLES, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5912 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1207 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_MAPS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5920 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1211 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_MAP, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5928 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1215 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_LIST, (yyvsp[-1].val), &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5936 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1219 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CT_HELPERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5944 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1225 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5952 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1229 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5960 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1233 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_COUNTER, &(yyvsp[0].handle),&(yyloc), NULL);
			}
#line 5968 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1237 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5976 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1241 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5984 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1245 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_QUOTA, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 5992 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1251 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 6000 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1255 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 6008 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1259 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 6016 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1263 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_MAP, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 6024 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1267 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 6032 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1271 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 6040 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1275 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_RULESET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 6048 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1281 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.cmd) = cmd_alloc(CMD_RENAME, CMD_OBJ_CHAIN, &(yyvsp[-1].handle), &(yyloc), NULL);
				(yyval.cmd)->arg = (yyvsp[0].string);
			}
#line 6057 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1288 "parser_bison.y" /* yacc.c:1646  */
    {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_IMPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 6067 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1294 "parser_bison.y" /* yacc.c:1646  */
    {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_IMPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 6077 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1302 "parser_bison.y" /* yacc.c:1646  */
    {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_EXPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 6087 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1308 "parser_bison.y" /* yacc.c:1646  */
    {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_EXPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 6097 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1316 "parser_bison.y" /* yacc.c:1646  */
    {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct monitor *m = monitor_alloc((yyvsp[0].val), (yyvsp[-1].val), (yyvsp[-2].string));
				m->location = (yylsp[-2]);
				(yyval.cmd) = cmd_alloc(CMD_MONITOR, CMD_OBJ_MONITOR, &h, &(yyloc), m);
			}
#line 6108 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1324 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.string) = NULL; }
#line 6114 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1325 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 6120 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1328 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = CMD_MONITOR_OBJ_ANY; }
#line 6126 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1329 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = CMD_MONITOR_OBJ_TABLES; }
#line 6132 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1330 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = CMD_MONITOR_OBJ_CHAINS; }
#line 6138 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1331 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = CMD_MONITOR_OBJ_SETS; }
#line 6144 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1332 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = CMD_MONITOR_OBJ_RULES; }
#line 6150 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1333 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = CMD_MONITOR_OBJ_ELEMS; }
#line 6156 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1334 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = CMD_MONITOR_OBJ_RULESET; }
#line 6162 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1335 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = CMD_MONITOR_OBJ_TRACE; }
#line 6168 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1338 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFTNL_OUTPUT_DEFAULT; }
#line 6174 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1342 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = __NFT_OUTPUT_NOTSUPP; }
#line 6180 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1343 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = __NFT_OUTPUT_NOTSUPP; }
#line 6186 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1344 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFTNL_OUTPUT_JSON; }
#line 6192 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1348 "parser_bison.y" /* yacc.c:1646  */
    {
				struct handle h = { .family = NFPROTO_UNSPEC };
				(yyval.cmd) = cmd_alloc(CMD_DESCRIBE, CMD_OBJ_EXPR, &h, &(yyloc), NULL);
				(yyval.cmd)->expr = (yyvsp[0].expr);
			}
#line 6202 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1356 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.table) = table_alloc();
				open_scope(state, &(yyval.table)->scope);
			}
#line 6211 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1363 "parser_bison.y" /* yacc.c:1646  */
    {
				if (strcmp((yyvsp[0].string), "dormant") == 0) {
					(yyvsp[-2].table)->flags = TABLE_F_DORMANT;
					xfree((yyvsp[0].string));
				} else {
					erec_queue(error(&(yylsp[0]), "unknown table option %s", (yyvsp[0].string)),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
			}
#line 6227 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1376 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.table) = (yyvsp[(-1) - (0)].table); }
#line 6233 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1383 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].chain)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].chain)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				close_scope(state);
				list_add_tail(&(yyvsp[-4].chain)->list, &(yyvsp[-7].table)->chains);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 6246 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1394 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].set)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].set)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].set)->list, &(yyvsp[-7].table)->sets);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 6258 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1404 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].set)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].set)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].set)->list, &(yyvsp[-7].table)->sets);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 6270 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1415 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].flowtable)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].flowtable)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].flowtable)->list, &(yyvsp[-7].table)->flowtables);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 6282 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1425 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_COUNTER;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 6295 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1436 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_QUOTA;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 6308 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1445 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_CT_HELPER;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-8].table)->objs);
				(yyval.table) = (yyvsp[-8].table);
			}
#line 6321 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1456 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_LIMIT;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 6334 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1467 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.chain) = chain_alloc(NULL);
				open_scope(state, &(yyval.chain)->scope);
			}
#line 6343 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1473 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.chain) = (yyvsp[(-1) - (0)].chain); }
#line 6349 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1479 "parser_bison.y" /* yacc.c:1646  */
    {
				list_add_tail(&(yyvsp[-1].rule)->list, &(yyvsp[-2].chain)->rules);
				(yyval.chain) = (yyvsp[-2].chain);
			}
#line 6358 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1486 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.set) = set_alloc(NULL);
			}
#line 6366 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1491 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.set) = (yyvsp[(-1) - (0)].set); }
#line 6372 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1495 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->key = (yyvsp[-1].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 6381 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1500 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->flags = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 6390 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1505 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->timeout = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 6399 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1510 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->gc_int = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 6408 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1515 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->init = (yyvsp[0].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 6417 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1520 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].set)->automerge = true;
				(yyval.set) = (yyvsp[-1].set);
			}
#line 6426 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1532 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 6434 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1538 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_SET_CONSTANT; }
#line 6440 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1539 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_SET_INTERVAL; }
#line 6446 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1540 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_SET_TIMEOUT; }
#line 6452 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1544 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.set) = set_alloc(NULL);
			}
#line 6460 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1549 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.set) = (yyvsp[(-1) - (0)].set); }
#line 6466 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1553 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->timeout = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 6475 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1560 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->datatype = (yyvsp[-1].expr)->dtype;

				expr_free((yyvsp[-1].expr));
				(yyvsp[-5].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 6488 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1571 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->objtype = NFT_OBJECT_COUNTER;
				(yyvsp[-5].set)->flags  |= NFT_SET_OBJECT;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 6499 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1580 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->objtype = NFT_OBJECT_QUOTA;
				(yyvsp[-5].set)->flags  |= NFT_SET_OBJECT;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 6510 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1589 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->objtype = NFT_OBJECT_LIMIT;
				(yyvsp[-5].set)->flags  |= NFT_SET_OBJECT;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 6521 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1596 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->flags |= (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 6530 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1601 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].set)->init = (yyvsp[0].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 6539 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1609 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].set)->policy = (yyvsp[0].val);
			}
#line 6547 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1613 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].set)->desc.size = (yyvsp[0].val);
			}
#line 6555 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1618 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_SET_POL_PERFORMANCE; }
#line 6561 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1619 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_SET_POL_MEMORY; }
#line 6567 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1623 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.flowtable) = flowtable_alloc(NULL);
			}
#line 6575 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1628 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.flowtable) = (yyvsp[(-1) - (0)].flowtable); }
#line 6581 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1632 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.flowtable)->hookstr	= chain_hookname_lookup((yyvsp[-3].string));
				if ((yyval.flowtable)->hookstr == NULL) {
					erec_queue(error(&(yylsp[-3]), "unknown chain hook %s", (yyvsp[-3].string)),
						   state->msgs);
					xfree((yyvsp[-3].string));
					YYERROR;
				}
				xfree((yyvsp[-3].string));

				(yyval.flowtable)->priority = (yyvsp[-1].val);
			}
#line 6598 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1645 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.flowtable)->dev_expr = (yyvsp[-1].expr);
			}
#line 6606 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1651 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 6615 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1658 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = compound_expr_alloc(&(yyloc), NULL);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 6624 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1663 "parser_bison.y" /* yacc.c:1646  */
    {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 6633 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1671 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       (yyvsp[0].string));
			}
#line 6643 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1679 "parser_bison.y" /* yacc.c:1646  */
    {
				const struct datatype *dtype = datatype_lookup_byname((yyvsp[0].string));
				if (dtype == NULL) {
					erec_queue(error(&(yylsp[0]), "unknown datatype %s", (yyvsp[0].string)),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyval.expr) = constant_expr_alloc(&(yylsp[0]), dtype, dtype->byteorder,
							 dtype->size, NULL);
			}
#line 6659 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1694 "parser_bison.y" /* yacc.c:1646  */
    {
				if ((yyvsp[-2].expr)->ops->type != EXPR_CONCAT) {
					(yyval.expr) = concat_expr_alloc(&(yyloc));
					compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				} else {
					struct location rhs[] = {
						[1]	= (yylsp[-1]),
						[2]	= (yylsp[0]),
					};
					location_update(&(yyvsp[0].expr)->location, rhs, 2);

					(yyval.expr) = (yyvsp[-2].expr);
					(yyval.expr)->location = (yyloc);
				}
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 6680 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1713 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.obj) = obj_alloc(NULL);
			}
#line 6688 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1718 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 6694 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1722 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].obj)->counter = *(yyvsp[0].counter);
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 6703 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1728 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 6709 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1732 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].obj)->quota = *(yyvsp[0].quota);
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 6718 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1738 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 6724 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1742 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 6732 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1747 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 6738 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1751 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].obj)->limit = *(yyvsp[0].limit);
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 6747 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1757 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 6753 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1758 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.string) = xstrdup("mark"); }
#line 6759 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1759 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.string) = xstrdup("dscp"); }
#line 6765 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1760 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.string) = xstrdup("ecn"); }
#line 6771 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1761 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.string) = xstrdup("classid"); }
#line 6777 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1765 "parser_bison.y" /* yacc.c:1646  */
    {
				const char *chain_type = chain_type_name_lookup((yyvsp[-5].string));

				if (chain_type == NULL) {
					erec_queue(error(&(yylsp[-5]), "unknown chain type %s", (yyvsp[-5].string)),
						   state->msgs);
					xfree((yyvsp[-5].string));
					YYERROR;
				}
				(yyvsp[-7].chain)->type		= xstrdup(chain_type);
				xfree((yyvsp[-5].string));

				(yyvsp[-7].chain)->hookstr	= chain_hookname_lookup((yyvsp[-3].string));
				if ((yyvsp[-7].chain)->hookstr == NULL) {
					erec_queue(error(&(yylsp[-3]), "unknown chain hook %s", (yyvsp[-3].string)),
						   state->msgs);
					xfree((yyvsp[-3].string));
					YYERROR;
				}
				xfree((yyvsp[-3].string));

				(yyvsp[-7].chain)->dev		= (yyvsp[-2].string);
				(yyvsp[-7].chain)->priority	= (yyvsp[0].val);
				(yyvsp[-7].chain)->flags	|= CHAIN_F_BASECHAIN;
			}
#line 6807 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1792 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = (yyvsp[0].val); }
#line 6813 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1793 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = -(yyvsp[0].val); }
#line 6819 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1796 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 6825 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1797 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.string) = NULL; }
#line 6831 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1801 "parser_bison.y" /* yacc.c:1646  */
    {
				if ((yyvsp[-2].chain)->policy != -1) {
					erec_queue(error(&(yyloc), "you cannot set chain policy twice"),
						   state->msgs);
					YYERROR;
				}
				(yyvsp[-2].chain)->policy	= (yyvsp[0].val);
			}
#line 6844 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1811 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NF_ACCEPT; }
#line 6850 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1812 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NF_DROP;   }
#line 6856 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1824 "parser_bison.y" /* yacc.c:1646  */
    {
				struct error_record *erec;
				uint64_t res;

				erec = time_parse(&(yylsp[0]), (yyvsp[0].string), &res);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.val) = res;
			}
#line 6873 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1838 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_IPV4; }
#line 6879 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1842 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_IPV4; }
#line 6885 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1843 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_IPV6; }
#line 6891 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1844 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_INET; }
#line 6897 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1845 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_ARP; }
#line 6903 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1846 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_BRIDGE; }
#line 6909 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1847 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_NETDEV; }
#line 6915 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1851 "parser_bison.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= (yyvsp[-1].val);
				(yyval.handle).table.location = (yylsp[0]);
				(yyval.handle).table.name	= (yyvsp[0].string);
			}
#line 6926 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1860 "parser_bison.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family 		= (yyvsp[-2].val);
				(yyval.handle).handle.id 		= (yyvsp[0].val);
				(yyval.handle).handle.location	= (yyloc);
			}
#line 6937 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1869 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).chain.name	= (yyvsp[0].string);
				(yyval.handle).chain.location = (yylsp[0]);
			}
#line 6947 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1877 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.handle) 			= (yyvsp[-2].handle);
				(yyval.handle).handle.location 	= (yyloc);
				(yyval.handle).handle.id 		= (yyvsp[0].val);
			}
#line 6957 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1885 "parser_bison.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).chain.name		= (yyvsp[0].string);
				(yyval.handle).chain.location	= (yylsp[0]);
			}
#line 6967 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1893 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).set.name	= (yyvsp[0].string);
				(yyval.handle).set.location	= (yylsp[0]);
			}
#line 6977 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1901 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.handle) 			= (yyvsp[-2].handle);
				(yyval.handle).handle.location 	= (yyloc);
				(yyval.handle).handle.id 		= (yyvsp[0].val);
			}
#line 6987 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1909 "parser_bison.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).set.name	= (yyvsp[0].string);
				(yyval.handle).set.location	= (yylsp[0]);
			}
#line 6997 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1918 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).flowtable	= (yyvsp[0].string);
			}
#line 7006 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1925 "parser_bison.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).flowtable	= (yyvsp[0].string);
			}
#line 7015 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1932 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).obj.name	= (yyvsp[0].string);
				(yyval.handle).obj.location	= (yylsp[0]);
			}
#line 7025 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1940 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.handle) 			= (yyvsp[-2].handle);
				(yyval.handle).handle.location	= (yyloc);
				(yyval.handle).handle.id		= (yyvsp[0].val);
			}
#line 7035 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1948 "parser_bison.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).obj.name		= (yyvsp[0].string);
				(yyval.handle).obj.location		= (yylsp[0]);
			}
#line 7045 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1956 "parser_bison.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).handle.location	= (yyloc);
				(yyval.handle).handle.id		= (yyvsp[0].val);
			}
#line 7055 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1964 "parser_bison.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).position.location	= (yyloc);
				(yyval.handle).position.id		= (yyvsp[0].val);
			}
#line 7065 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1972 "parser_bison.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).index.location	= (yyloc);
				(yyval.handle).index.id		= (yyvsp[0].val) + 1;
			}
#line 7075 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1980 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.handle) = (yyvsp[0].handle);
			}
#line 7083 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1984 "parser_bison.y" /* yacc.c:1646  */
    {
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 7092 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1989 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[0].handle).position.location = (yyvsp[0].handle).handle.location;
				(yyvsp[0].handle).position.id = (yyvsp[0].handle).handle.id;
				(yyvsp[0].handle).handle.id = 0;
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 7104 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1997 "parser_bison.y" /* yacc.c:1646  */
    {
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 7113 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 273:
#line 2004 "parser_bison.y" /* yacc.c:1646  */
    {
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 7122 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 274:
#line 2011 "parser_bison.y" /* yacc.c:1646  */
    {
				if (strlen((yyvsp[0].string)) > UDATA_COMMENT_MAXLEN) {
					erec_queue(error(&(yylsp[0]), "comment too long, %d characters maximum allowed", UDATA_COMMENT_MAXLEN),
						   state->msgs);
					YYERROR;
				}
				(yyval.string) = (yyvsp[0].string);
			}
#line 7135 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2022 "parser_bison.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= NFPROTO_UNSPEC;
			}
#line 7144 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2027 "parser_bison.y" /* yacc.c:1646  */
    {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= (yyvsp[0].val);
			}
#line 7153 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2034 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.rule)->comment = NULL;
			}
#line 7161 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2038 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.rule)->comment = (yyvsp[0].string);
			}
#line 7169 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2044 "parser_bison.y" /* yacc.c:1646  */
    {
				struct stmt *i;

				(yyval.rule) = rule_alloc(&(yyloc), NULL);
				list_for_each_entry(i, (yyvsp[0].list), list)
					(yyval.rule)->num_stmts++;
				list_splice_tail((yyvsp[0].list), &(yyval.rule)->stmts);
				xfree((yyvsp[0].list));
			}
#line 7183 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2056 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail(&(yyvsp[0].stmt)->list, (yyval.list));
			}
#line 7193 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2062 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.list) = (yyvsp[-1].list);
				list_add_tail(&(yyvsp[0].stmt)->list, (yyvsp[-1].list));
			}
#line 7202 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2091 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = verdict_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 7210 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2095 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = verdict_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 7218 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2101 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 7226 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2107 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 7235 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2112 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_SET,
						       current_scope(state),
						       (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 7246 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2121 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = set_expr_alloc(&(yyloc), NULL);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 7255 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2126 "parser_bison.y" /* yacc.c:1646  */
    {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 7264 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2134 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mapping_expr_alloc(&(yyloc), (yyvsp[-3].expr), (yyvsp[-1].expr));
			}
#line 7272 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2140 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = connlimit_stmt_alloc(&(yyloc));
				(yyval.stmt)->connlimit.count	= (yyvsp[0].val);
			}
#line 7281 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2145 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = connlimit_stmt_alloc(&(yyloc));
				(yyval.stmt)->connlimit.count = (yyvsp[0].val);
				(yyval.stmt)->connlimit.flags = NFT_CONNLIMIT_F_INV;
			}
#line 7291 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2156 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = counter_stmt_alloc(&(yyloc));
			}
#line 7299 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2160 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_COUNTER;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 7309 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2168 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 7317 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2175 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->counter.packets = (yyvsp[0].val);
			}
#line 7325 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2179 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->counter.bytes	 = (yyvsp[0].val);
			}
#line 7333 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2189 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = log_stmt_alloc(&(yyloc));
			}
#line 7341 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2195 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 7349 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2202 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->log.prefix	 = (yyvsp[0].string);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_PREFIX;
			}
#line 7358 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2207 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->log.group	 = (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_GROUP;
			}
#line 7367 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2212 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->log.snaplen	 = (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_SNAPLEN;
			}
#line 7376 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2217 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->log.qthreshold = (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_QTHRESHOLD;
			}
#line 7385 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2222 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->log.level	= (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_LEVEL;
			}
#line 7394 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2227 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->log.logflags	|= (yyvsp[0].val);
			}
#line 7402 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2233 "parser_bison.y" /* yacc.c:1646  */
    {
				if (!strcmp("emerg", (yyvsp[0].string)))
					(yyval.val) = LOG_EMERG;
				else if (!strcmp("alert", (yyvsp[0].string)))
					(yyval.val) = LOG_ALERT;
				else if (!strcmp("crit", (yyvsp[0].string)))
					(yyval.val) = LOG_CRIT;
				else if (!strcmp("err", (yyvsp[0].string)))
					(yyval.val) = LOG_ERR;
				else if (!strcmp("warn", (yyvsp[0].string)))
					(yyval.val) = LOG_WARNING;
				else if (!strcmp("notice", (yyvsp[0].string)))
					(yyval.val) = LOG_NOTICE;
				else if (!strcmp("info", (yyvsp[0].string)))
					(yyval.val) = LOG_INFO;
				else if (!strcmp("debug", (yyvsp[0].string)))
					(yyval.val) = LOG_DEBUG;
				else if (!strcmp("audit", (yyvsp[0].string)))
					(yyval.val) = LOGLEVEL_AUDIT;
				else {
					erec_queue(error(&(yylsp[0]), "invalid log level"),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
				xfree((yyvsp[0].string));
			}
#line 7434 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2263 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = (yyvsp[0].val);
			}
#line 7442 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2267 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = NF_LOG_IPOPT;
			}
#line 7450 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2271 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = NF_LOG_UID;
			}
#line 7458 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2275 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = NF_LOG_MACDECODE;
			}
#line 7466 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2279 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = NF_LOG_MASK;
			}
#line 7474 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2285 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 7482 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2292 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = NF_LOG_TCPSEQ;
			}
#line 7490 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2296 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = NF_LOG_TCPOPT;
			}
#line 7498 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2302 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate	= (yyvsp[-3].val);
				(yyval.stmt)->limit.unit	= (yyvsp[-1].val);
				(yyval.stmt)->limit.burst	= (yyvsp[0].val);
				(yyval.stmt)->limit.type	= NFT_LIMIT_PKTS;
				(yyval.stmt)->limit.flags = (yyvsp[-4].val);
			}
#line 7511 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2311 "parser_bison.y" /* yacc.c:1646  */
    {
				struct error_record *erec;
				uint64_t rate, unit;

				erec = rate_parse(&(yyloc), (yyvsp[-1].string), &rate, &unit);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate	= rate * (yyvsp[-2].val);
				(yyval.stmt)->limit.unit	= unit;
				(yyval.stmt)->limit.burst	= (yyvsp[0].val);
				(yyval.stmt)->limit.type	= NFT_LIMIT_PKT_BYTES;
				(yyval.stmt)->limit.flags = (yyvsp[-3].val);
			}
#line 7534 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2330 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_LIMIT;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 7544 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2337 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_QUOTA_F_INV; }
#line 7550 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2338 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = 0; }
#line 7556 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2339 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = 0; }
#line 7562 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2342 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.string) = xstrdup("bytes"); }
#line 7568 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2343 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 7574 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2346 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = 0; }
#line 7580 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2348 "parser_bison.y" /* yacc.c:1646  */
    {
				struct error_record *erec;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[0].string), &rate);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.val) = (yyvsp[-1].val) * rate;
			}
#line 7597 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2363 "parser_bison.y" /* yacc.c:1646  */
    {
				struct error_record *erec;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[-1].string), &rate);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.stmt) = quota_stmt_alloc(&(yyloc));
				(yyval.stmt)->quota.bytes	= (yyvsp[-2].val) * rate;
				(yyval.stmt)->quota.used = (yyvsp[0].val);
				(yyval.stmt)->quota.flags	= (yyvsp[-3].val);
			}
#line 7617 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2379 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_QUOTA;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 7627 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2386 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_LIMIT_F_INV; }
#line 7633 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2387 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = 0; }
#line 7639 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2388 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = 0; }
#line 7645 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2391 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = 0; }
#line 7651 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2392 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = (yyvsp[-1].val); }
#line 7657 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2393 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = (yyvsp[-1].val); }
#line 7663 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2395 "parser_bison.y" /* yacc.c:1646  */
    {
				struct error_record *erec;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[0].string), &rate);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.val) = (yyvsp[-1].val) * rate;
			}
#line 7680 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2409 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = 1ULL; }
#line 7686 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2410 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = 1ULL * 60; }
#line 7692 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2411 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = 1ULL * 60 * 60; }
#line 7698 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2412 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = 1ULL * 60 * 60 * 24; }
#line 7704 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2413 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = 1ULL * 60 * 60 * 24 * 7; }
#line 7710 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2420 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = reject_stmt_alloc(&(yyloc));
			}
#line 7718 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2426 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[0].stmt)->reject.type = -1;
				(yyvsp[0].stmt)->reject.icmp_code = -1;
			}
#line 7727 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2431 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].stmt)->reject.family = NFPROTO_IPV4;
				(yyvsp[-4].stmt)->reject.type = NFT_REJECT_ICMP_UNREACH;
				(yyvsp[-4].stmt)->reject.expr =
					symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
							  current_scope(state),
							  (yyvsp[0].string));
				(yyvsp[-4].stmt)->reject.expr->dtype = &icmp_code_type;
				xfree((yyvsp[0].string));
			}
#line 7742 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2442 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].stmt)->reject.family = NFPROTO_IPV6;
				(yyvsp[-4].stmt)->reject.type = NFT_REJECT_ICMP_UNREACH;
				(yyvsp[-4].stmt)->reject.expr =
					symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
							  current_scope(state),
							  (yyvsp[0].string));
				(yyvsp[-4].stmt)->reject.expr->dtype = &icmpv6_code_type;
				xfree((yyvsp[0].string));
			}
#line 7757 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2453 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].stmt)->reject.type = NFT_REJECT_ICMPX_UNREACH;
				(yyvsp[-4].stmt)->reject.expr =
					symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
							  current_scope(state),
							  (yyvsp[0].string));
				(yyvsp[-4].stmt)->reject.expr->dtype = &icmpx_code_type;
				xfree((yyvsp[0].string));
			}
#line 7771 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2463 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].stmt)->reject.type = NFT_REJECT_TCP_RST;
			}
#line 7779 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2471 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_SNAT); }
#line 7785 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2472 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_DNAT); }
#line 7791 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2475 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 7797 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2476 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 7803 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2477 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 7809 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2478 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 7815 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2479 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 7821 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2480 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 7827 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2481 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 7833 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2482 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 7839 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2483 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 7845 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2484 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 7851 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2489 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 7859 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2493 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 7867 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2500 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 7875 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2507 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 7883 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2514 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 7891 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2524 "parser_bison.y" /* yacc.c:1646  */
    {
				if ((yyval.expr)->ops->type != EXPR_CONCAT) {
					(yyval.expr) = concat_expr_alloc(&(yyloc));
					compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				} else {
					struct location rhs[] = {
						[1]	= (yylsp[-1]),
						[2]	= (yylsp[0]),
					};
					location_update(&(yyvsp[0].expr)->location, rhs, 2);

					(yyval.expr) = (yyvsp[-2].expr);
					(yyval.expr)->location = (yyloc);
				}
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 7912 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2547 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 7920 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2550 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 7926 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2554 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = prefix_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].val));
			}
#line 7934 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2560 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = range_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 7942 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2566 "parser_bison.y" /* yacc.c:1646  */
    {
				struct expr *expr;

				expr = constant_expr_alloc(&(yyloc), &integer_type,
							   BYTEORDER_HOST_ENDIAN,
							   0, NULL);
				(yyval.expr) = prefix_expr_alloc(&(yyloc), expr, 0);
			}
#line 7955 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2587 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 7963 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2591 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 7971 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2595 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[-2].expr);
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 7980 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2600 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].stmt)->nat.addr = (yyvsp[-2].expr);
				(yyvsp[-4].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 7989 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2605 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 7997 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2609 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 8005 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2613 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 8013 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2622 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_MASQ); }
#line 8019 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2626 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 8027 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2630 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].stmt)->nat.proto = (yyvsp[-1].expr);
				(yyvsp[-4].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 8036 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2635 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 8044 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2644 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_REDIR); }
#line 8050 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2648 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 8058 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2652 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 8066 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2656 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 8074 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2660 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[-1].expr);
				(yyvsp[-3].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 8083 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2665 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-4].stmt)->nat.proto = (yyvsp[-1].expr);
				(yyvsp[-4].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 8092 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2672 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = dup_stmt_alloc(&(yyloc));
				(yyval.stmt)->dup.to = (yyvsp[0].expr);
			}
#line 8101 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2677 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = dup_stmt_alloc(&(yyloc));
				(yyval.stmt)->dup.to = (yyvsp[-2].expr);
				(yyval.stmt)->dup.dev = (yyvsp[0].expr);
			}
#line 8111 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2684 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_IPV4; }
#line 8117 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2685 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_IPV6; }
#line 8123 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2689 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = fwd_stmt_alloc(&(yyloc));
				(yyval.stmt)->fwd.dev = (yyvsp[0].expr);
			}
#line 8132 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2694 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = fwd_stmt_alloc(&(yyloc));
				(yyval.stmt)->fwd.family = (yyvsp[-4].val);
				(yyval.stmt)->fwd.addr = (yyvsp[-2].expr);
				(yyval.stmt)->fwd.dev = (yyvsp[0].expr);
			}
#line 8143 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2704 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 8151 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2709 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NF_NAT_RANGE_PROTO_RANDOM; }
#line 8157 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2710 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NF_NAT_RANGE_PROTO_RANDOM_FULLY; }
#line 8163 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2711 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NF_NAT_RANGE_PERSISTENT; }
#line 8169 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2719 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = queue_stmt_alloc(&(yyloc));
			}
#line 8177 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2725 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 8185 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2732 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->queue.queue = (yyvsp[0].expr);
				(yyvsp[-2].stmt)->queue.queue->location = (yyloc);
			}
#line 8194 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2737 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].stmt)->queue.flags |= (yyvsp[0].val);
			}
#line 8202 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2744 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 8210 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2749 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_QUEUE_FLAG_BYPASS; }
#line 8216 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2750 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_QUEUE_FLAG_CPU_FANOUT; }
#line 8222 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2758 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[0]), (yyvsp[0].expr));
			}
#line 8230 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2764 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = set_stmt_alloc(&(yyloc));
				(yyval.stmt)->set.op  = (yyvsp[-2].val);
				(yyval.stmt)->set.key = (yyvsp[-1].expr);
				(yyval.stmt)->set.set = (yyvsp[0].expr);
			}
#line 8241 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2771 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = set_stmt_alloc(&(yyloc));
				(yyval.stmt)->set.op  = (yyvsp[-4].val);
				(yyval.stmt)->set.key = (yyvsp[-1].expr);
				(yyval.stmt)->set.set = (yyvsp[-3].expr);
			}
#line 8252 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2779 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_DYNSET_OP_ADD; }
#line 8258 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2780 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_DYNSET_OP_UPDATE; }
#line 8264 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2784 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = map_stmt_alloc(&(yyloc));
				(yyval.stmt)->map.op  = (yyvsp[-6].val);
				(yyval.stmt)->map.map = map_expr_alloc(&(yyloc), (yyvsp[-3].expr), (yyvsp[-1].expr));
				(yyval.stmt)->map.set = (yyvsp[-5].expr);
			}
#line 8275 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2793 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-5].stmt)->meter.key  = (yyvsp[-2].expr);
				(yyvsp[-5].stmt)->meter.stmt = (yyvsp[-1].stmt);
				(yyval.stmt)->location  = (yyloc);
				(yyval.stmt) = (yyvsp[-5].stmt);
			}
#line 8286 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2799 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.stmt) = (yyvsp[0].stmt); }
#line 8292 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2803 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = meter_stmt_alloc(&(yyloc));
			}
#line 8300 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2809 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 8308 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2816 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].stmt)->meter.name = (yyvsp[0].string);
			}
#line 8316 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2822 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = meter_stmt_alloc(&(yyloc));
				(yyval.stmt)->meter.name = (yyvsp[-4].string);
				(yyval.stmt)->meter.size = 0;
				(yyval.stmt)->meter.key  = (yyvsp[-2].expr);
				(yyval.stmt)->meter.stmt = (yyvsp[-1].stmt);
				(yyval.stmt)->location  = (yyloc);
			}
#line 8329 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2831 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = meter_stmt_alloc(&(yyloc));
				(yyval.stmt)->meter.name = (yyvsp[-6].string);
				(yyval.stmt)->meter.size = (yyvsp[-4].val);
				(yyval.stmt)->meter.key  = (yyvsp[-2].expr);
				(yyval.stmt)->meter.stmt = (yyvsp[-1].stmt);
				(yyval.stmt)->location  = (yyloc);
			}
#line 8342 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2842 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = expr_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 8350 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2848 "parser_bison.y" /* yacc.c:1646  */
    {
				struct scope *scope = current_scope(state);
				struct symbol *sym;

				sym = symbol_get(scope, (yyvsp[0].string));
				if (!sym) {
					erec_queue(error(&(yylsp[0]), "unknown identifier '%s'", (yyvsp[0].string)),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}

				(yyval.expr) = variable_expr_alloc(&(yyloc), scope, sym);
				xfree((yyvsp[0].string));
			}
#line 8370 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2867 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 8381 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2874 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_SET,
						       current_scope(state),
						       (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 8392 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2883 "parser_bison.y" /* yacc.c:1646  */
    {
				char str[64];

				snprintf(str, sizeof(str), "%" PRIu64, (yyvsp[0].val));
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       str);
			}
#line 8405 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2893 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8411 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2894 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8417 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2895 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8423 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2896 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8429 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2897 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8435 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2898 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8441 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2899 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8447 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2900 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8453 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2901 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8459 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2902 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8465 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2903 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8471 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2904 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8477 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2905 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 8483 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2909 "parser_bison.y" /* yacc.c:1646  */
    {
				if (((yyvsp[-1].val) & (NFTA_FIB_F_SADDR|NFTA_FIB_F_DADDR)) == 0) {
					erec_queue(error(&(yylsp[-1]), "fib: need either saddr or daddr"), state->msgs);
					YYERROR;
				}

				if (((yyvsp[-1].val) & (NFTA_FIB_F_SADDR|NFTA_FIB_F_DADDR)) ==
					  (NFTA_FIB_F_SADDR|NFTA_FIB_F_DADDR)) {
					erec_queue(error(&(yylsp[-1]), "fib: saddr and daddr are mutually exclusive"), state->msgs);
					YYERROR;
				}

				if (((yyvsp[-1].val) & (NFTA_FIB_F_IIF|NFTA_FIB_F_OIF)) ==
					  (NFTA_FIB_F_IIF|NFTA_FIB_F_OIF)) {
					erec_queue(error(&(yylsp[-1]), "fib: iif and oif are mutually exclusive"), state->msgs);
					YYERROR;
				}

				(yyval.expr) = fib_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 8508 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2931 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) =NFT_FIB_RESULT_OIF; }
#line 8514 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2932 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) =NFT_FIB_RESULT_OIFNAME; }
#line 8520 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2933 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) =NFT_FIB_RESULT_ADDRTYPE; }
#line 8526 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2936 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFTA_FIB_F_SADDR; }
#line 8532 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2937 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFTA_FIB_F_DADDR; }
#line 8538 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2938 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFTA_FIB_F_MARK; }
#line 8544 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2939 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFTA_FIB_F_IIF; }
#line 8550 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2940 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFTA_FIB_F_OIF; }
#line 8556 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2944 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 8564 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2952 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 8572 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2956 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 8580 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2963 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 8588 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2970 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 8596 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2977 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 8604 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2987 "parser_bison.y" /* yacc.c:1646  */
    {
				if ((yyval.expr)->ops->type != EXPR_CONCAT) {
					(yyval.expr) = concat_expr_alloc(&(yyloc));
					compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				} else {
					struct location rhs[] = {
						[1]	= (yylsp[-1]),
						[2]	= (yylsp[0]),
					};
					location_update(&(yyvsp[0].expr)->location, rhs, 2);

					(yyval.expr) = (yyvsp[-2].expr);
					(yyval.expr)->location = (yyloc);
				}
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 8625 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3006 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = prefix_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].val));
			}
#line 8633 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3012 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = range_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 8641 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3023 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 8649 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3034 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 8658 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3041 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = set_expr_alloc(&(yyloc), NULL);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 8667 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3046 "parser_bison.y" /* yacc.c:1646  */
    {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 8676 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3054 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 8684 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3058 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 8692 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3062 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mapping_expr_alloc(&(yyloc), (yyvsp[-3].expr), (yyvsp[-1].expr));
			}
#line 8700 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3069 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 8709 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3076 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[0]), (yyvsp[0].expr));
			}
#line 8717 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3086 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[0]), (yyvsp[0].expr));
			}
#line 8725 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3092 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr)	= (yyvsp[-1].expr);
			}
#line 8733 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3099 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].expr)->timeout = (yyvsp[0].val);
			}
#line 8741 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3103 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-1].expr)->comment = (yyvsp[0].string);
			}
#line 8749 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3121 "parser_bison.y" /* yacc.c:1646  */
    {
				struct counter *counter;

				counter = xzalloc(sizeof(*counter));
				counter->packets = (yyvsp[-2].val);
				counter->bytes = (yyvsp[0].val);
				(yyval.counter) = counter;
			}
#line 8762 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3132 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_COUNTER;
				(yyval.obj)->counter = *(yyvsp[0].counter);
			}
#line 8772 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3140 "parser_bison.y" /* yacc.c:1646  */
    {
				struct error_record *erec;
				struct quota *quota;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[-1].string), &rate);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				quota = xzalloc(sizeof(*quota));
				quota->bytes	= (yyvsp[-2].val) * rate;
				quota->used	= (yyvsp[0].val);
				quota->flags	= (yyvsp[-3].val);
				(yyval.quota) = quota;
			}
#line 8795 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 547:
#line 3161 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_QUOTA;
				(yyval.obj)->quota = *(yyvsp[0].quota);
			}
#line 8805 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 548:
#line 3168 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_OBJECT_CT_HELPER; }
#line 8811 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 549:
#line 3171 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPPROTO_TCP; }
#line 8817 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 550:
#line 3172 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPPROTO_UDP; }
#line 8823 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 551:
#line 3176 "parser_bison.y" /* yacc.c:1646  */
    {
				struct ct_helper *ct;
				int ret;

				ct = &(yyvsp[-5].obj)->ct_helper;

				ret = snprintf(ct->name, sizeof(ct->name), "%s", (yyvsp[-3].string));
				if (ret <= 0 || ret >= (int)sizeof(ct->name)) {
					erec_queue(error(&(yylsp[-3]), "invalid name '%s', max length is %u\n", (yyvsp[-3].string), (int)sizeof(ct->name)), state->msgs);
					YYERROR;
				}

				ct->l4proto = (yyvsp[-1].val);
			}
#line 8842 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 552:
#line 3191 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-3].obj)->ct_helper.l3proto = (yyvsp[-1].val);
			}
#line 8850 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 553:
#line 3197 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.obj) = obj_alloc(&(yyloc));
			}
#line 8858 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 554:
#line 3203 "parser_bison.y" /* yacc.c:1646  */
    {
				struct limit *limit;
				limit = xzalloc(sizeof(*limit));
				limit->rate	= (yyvsp[-3].val);
				limit->unit	= (yyvsp[-1].val);
				limit->burst	= (yyvsp[0].val);
				limit->type	= NFT_LIMIT_PKTS;
				limit->flags	= (yyvsp[-4].val);
				(yyval.limit) = limit;
			}
#line 8873 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 555:
#line 3214 "parser_bison.y" /* yacc.c:1646  */
    {
				struct limit *limit;
				struct error_record *erec;
				uint64_t rate, unit;

				erec = rate_parse(&(yyloc), (yyvsp[-1].string), &rate, &unit);
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				limit = xzalloc(sizeof(*limit));
				limit->rate	= rate * (yyvsp[-2].val);
				limit->unit	= unit;
				limit->burst	= (yyvsp[0].val);
				limit->type	= NFT_LIMIT_PKT_BYTES;
				limit->flags	= (yyvsp[-3].val);
				(yyval.limit) = limit;
			}
#line 8897 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 556:
#line 3236 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_LIMIT;
				(yyval.obj)->limit = *(yyvsp[0].limit);
			}
#line 8907 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 557:
#line 3244 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = relational_expr_alloc(&(yyloc), OP_IMPLICIT, (yyvsp[-1].expr), (yyvsp[0].expr));
			}
#line 8915 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 558:
#line 3248 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = relational_expr_alloc(&(yyloc), OP_IMPLICIT, (yyvsp[-1].expr), (yyvsp[0].expr));
			}
#line 8923 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 559:
#line 3252 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = relational_expr_alloc(&(yylsp[-1]), (yyvsp[-1].val), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 8931 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 560:
#line 3258 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = list_expr_alloc(&(yyloc));
				compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 8941 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 561:
#line 3264 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].expr)->location = (yyloc);
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 8951 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 562:
#line 3271 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8957 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 563:
#line 3272 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8963 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 564:
#line 3273 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 8969 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 566:
#line 3278 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 8977 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 567:
#line 3282 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 8985 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 569:
#line 3289 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 8993 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 571:
#line 3296 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 9001 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 573:
#line 3303 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 9009 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 576:
#line 3313 "parser_bison.y" /* yacc.c:1646  */
    {
				if ((yyval.expr)->ops->type != EXPR_CONCAT) {
					(yyval.expr) = concat_expr_alloc(&(yyloc));
					compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				} else {
					struct location rhs[] = {
						[1]	= (yylsp[-1]),
						[2]	= (yylsp[0]),
					};
					location_update(&(yyvsp[0].expr)->location, rhs, 2);

					(yyval.expr) = (yyvsp[-2].expr);
					(yyval.expr)->location = (yyloc);
				}
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 9030 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 577:
#line 3331 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = true; }
#line 9036 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 578:
#line 3332 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = false; }
#line 9042 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 579:
#line 3336 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &boolean_type,
							 BYTEORDER_HOST_ENDIAN,
							 1, &(yyvsp[0].val));
			}
#line 9052 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 580:
#line 3343 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = symbol_value(&(yyloc), "ether"); }
#line 9058 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 581:
#line 3344 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = symbol_value(&(yyloc), "ip"); }
#line 9064 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 582:
#line 3345 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = symbol_value(&(yyloc), "ip6"); }
#line 9070 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 583:
#line 3346 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = symbol_value(&(yyloc), "vlan"); }
#line 9076 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 584:
#line 3347 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = symbol_value(&(yyloc), "arp"); }
#line 9082 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 585:
#line 3348 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = symbol_value(&(yyloc), "dnat"); }
#line 9088 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 586:
#line 3349 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = symbol_value(&(yyloc), "snat"); }
#line 9094 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 587:
#line 3350 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = symbol_value(&(yyloc), "ecn"); }
#line 9100 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 588:
#line 3351 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = symbol_value(&(yyloc), "reset"); }
#line 9106 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 589:
#line 3352 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = symbol_value(&(yyloc), "original"); }
#line 9112 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 590:
#line 3353 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = symbol_value(&(yyloc), "reply"); }
#line 9118 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 591:
#line 3354 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = symbol_value(&(yyloc), "label"); }
#line 9124 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 592:
#line 3357 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 9130 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 593:
#line 3358 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 9136 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 594:
#line 3359 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 9142 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 595:
#line 3360 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 9148 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 596:
#line 3362 "parser_bison.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_TCP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 9159 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 597:
#line 3369 "parser_bison.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_UDP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 9170 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 598:
#line 3376 "parser_bison.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_UDPLITE;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 9181 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 599:
#line 3383 "parser_bison.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_ESP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 9192 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 600:
#line 3390 "parser_bison.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_AH;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 9203 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 601:
#line 3397 "parser_bison.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_ICMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 9214 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 602:
#line 3404 "parser_bison.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_ICMPV6;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 9225 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 603:
#line 3411 "parser_bison.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_COMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 9236 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 604:
#line 3418 "parser_bison.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_DCCP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 9247 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 605:
#line 3425 "parser_bison.y" /* yacc.c:1646  */
    {
				uint8_t data = IPPROTO_SCTP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 9258 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 606:
#line 3432 "parser_bison.y" /* yacc.c:1646  */
    {
				uint8_t data = ICMP_REDIRECT;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &icmp_type_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 9269 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 607:
#line 3438 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 9275 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 608:
#line 3441 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = OP_EQ; }
#line 9281 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 609:
#line 3442 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = OP_NEQ; }
#line 9287 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 610:
#line 3443 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = OP_LT; }
#line 9293 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 611:
#line 3444 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = OP_GT; }
#line 9299 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 612:
#line 3445 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = OP_GTE; }
#line 9305 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 613:
#line 3446 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = OP_LTE; }
#line 9311 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 614:
#line 3450 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NF_ACCEPT, NULL);
			}
#line 9319 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 615:
#line 3454 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NF_DROP, NULL);
			}
#line 9327 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 616:
#line 3458 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_CONTINUE, NULL);
			}
#line 9335 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 617:
#line 3462 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_JUMP, (yyvsp[0].string));
			}
#line 9343 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 618:
#line 3466 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_GOTO, (yyvsp[0].string));
			}
#line 9351 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 619:
#line 3470 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_RETURN, NULL);
			}
#line 9359 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 620:
#line 3476 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = meta_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 9367 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 621:
#line 3480 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = meta_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 9375 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 622:
#line 3484 "parser_bison.y" /* yacc.c:1646  */
    {
				struct error_record *erec;
				unsigned int key;

				erec = meta_key_parse(&(yyloc), (yyvsp[0].string), &key);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.expr) = meta_expr_alloc(&(yyloc), key);
			}
#line 9393 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 625:
#line 3503 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_LEN; }
#line 9399 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 626:
#line 3504 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_PROTOCOL; }
#line 9405 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 627:
#line 3505 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_PRIORITY; }
#line 9411 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 628:
#line 3506 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_PRANDOM; }
#line 9417 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 629:
#line 3509 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_MARK; }
#line 9423 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 630:
#line 3510 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_IIF; }
#line 9429 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 631:
#line 3511 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_IIFNAME; }
#line 9435 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 632:
#line 3512 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_IIFTYPE; }
#line 9441 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 633:
#line 3513 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_OIF; }
#line 9447 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 634:
#line 3514 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_OIFNAME; }
#line 9453 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 635:
#line 3515 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_OIFTYPE; }
#line 9459 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 636:
#line 3516 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_SKUID; }
#line 9465 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 637:
#line 3517 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_SKGID; }
#line 9471 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 638:
#line 3518 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_NFTRACE; }
#line 9477 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 639:
#line 3519 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_RTCLASSID; }
#line 9483 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 640:
#line 3520 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_BRI_IIFNAME; }
#line 9489 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 641:
#line 3521 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_BRI_OIFNAME; }
#line 9495 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 642:
#line 3522 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_BRI_IIFNAME; }
#line 9501 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 643:
#line 3523 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_BRI_OIFNAME; }
#line 9507 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 644:
#line 3524 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_PKTTYPE; }
#line 9513 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 645:
#line 3525 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_CPU; }
#line 9519 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 646:
#line 3526 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_IIFGROUP; }
#line 9525 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 647:
#line 3527 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_OIFGROUP; }
#line 9531 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 648:
#line 3528 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_META_CGROUP; }
#line 9537 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 649:
#line 3532 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
			}
#line 9545 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 650:
#line 3536 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
			}
#line 9553 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 651:
#line 3540 "parser_bison.y" /* yacc.c:1646  */
    {
				struct error_record *erec;
				unsigned int key;

				erec = meta_key_parse(&(yyloc), (yyvsp[-2].string), &key);
				xfree((yyvsp[-2].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.stmt) = meta_stmt_alloc(&(yyloc), key, (yyvsp[0].expr));
			}
#line 9571 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 652:
#line 3554 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = notrack_stmt_alloc(&(yyloc));
			}
#line 9579 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 653:
#line 3558 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = flow_offload_stmt_alloc(&(yyloc), (yyvsp[0].string));
			}
#line 9587 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 654:
#line 3564 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = socket_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 9595 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 655:
#line 3569 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_SOCKET_TRANSPARENT; }
#line 9601 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 656:
#line 3572 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = 0; }
#line 9607 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 657:
#line 3573 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = (yyvsp[0].val); }
#line 9613 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 658:
#line 3576 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_NG_INCREMENTAL; }
#line 9619 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 659:
#line 3577 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_NG_RANDOM; }
#line 9625 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 660:
#line 3581 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = numgen_expr_alloc(&(yyloc), (yyvsp[-3].val), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 9633 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 661:
#line 3587 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = hash_expr_alloc(&(yyloc), (yyvsp[-3].val), true, (yyvsp[-1].val), (yyvsp[0].val), NFT_HASH_JENKINS);
				(yyval.expr)->hash.expr = (yyvsp[-5].expr);
			}
#line 9642 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 662:
#line 3592 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = hash_expr_alloc(&(yyloc), (yyvsp[-1].val), false, 0, (yyvsp[0].val), NFT_HASH_JENKINS);
				(yyval.expr)->hash.expr = (yyvsp[-3].expr);
			}
#line 9651 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 663:
#line 3597 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = hash_expr_alloc(&(yyloc), (yyvsp[-1].val), false, 0, (yyvsp[0].val), NFT_HASH_SYM);
			}
#line 9659 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 664:
#line 3602 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_IPV4; }
#line 9665 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 665:
#line 3603 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFPROTO_IPV6; }
#line 9671 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 666:
#line 3607 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = rt_expr_alloc(&(yyloc), (yyvsp[0].val), true);
			}
#line 9679 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 667:
#line 3611 "parser_bison.y" /* yacc.c:1646  */
    {
				enum nft_rt_keys rtk = (yyvsp[0].val);

				switch ((yyvsp[-1].val)) {
				case NFPROTO_IPV4:
					break;
				case NFPROTO_IPV6:
					if ((yyvsp[0].val) == NFT_RT_NEXTHOP4)
						rtk = NFT_RT_NEXTHOP6;
					break;
				default:
					YYERROR;
					break;
				}

				(yyval.expr) = rt_expr_alloc(&(yyloc), rtk, false);
			}
#line 9701 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 668:
#line 3630 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_RT_CLASSID; }
#line 9707 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 669:
#line 3631 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_RT_NEXTHOP4; }
#line 9713 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 670:
#line 3632 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_RT_TCPMSS; }
#line 9719 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 671:
#line 3636 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[0].val), -1, NFPROTO_UNSPEC);
			}
#line 9727 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 672:
#line 3640 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[0].val), (yyvsp[-1].val), NFPROTO_UNSPEC);
			}
#line 9735 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 673:
#line 3644 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[0].val), (yyvsp[-2].val), (yyvsp[-1].val));
			}
#line 9743 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 674:
#line 3649 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IP_CT_DIR_ORIGINAL; }
#line 9749 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 675:
#line 3650 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IP_CT_DIR_REPLY; }
#line 9755 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 676:
#line 3653 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_L3PROTOCOL; }
#line 9761 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 677:
#line 3654 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_PROTOCOL; }
#line 9767 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 678:
#line 3655 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_MARK; }
#line 9773 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 679:
#line 3656 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_STATE; }
#line 9779 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 680:
#line 3657 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_DIRECTION; }
#line 9785 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 681:
#line 3658 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_STATUS; }
#line 9791 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 682:
#line 3659 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_EXPIRATION; }
#line 9797 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 683:
#line 3660 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_HELPER; }
#line 9803 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 684:
#line 3661 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_SRC; }
#line 9809 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 685:
#line 3662 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_DST; }
#line 9815 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 686:
#line 3663 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_PROTO_SRC; }
#line 9821 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 687:
#line 3664 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_PROTO_DST; }
#line 9827 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 688:
#line 3665 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_LABELS; }
#line 9833 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 689:
#line 3666 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_EVENTMASK; }
#line 9839 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 691:
#line 3670 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_SRC; }
#line 9845 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 692:
#line 3671 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_DST; }
#line 9851 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 693:
#line 3672 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_L3PROTOCOL; }
#line 9857 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 694:
#line 3673 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_PROTOCOL; }
#line 9863 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 695:
#line 3674 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_PROTO_SRC; }
#line 9869 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 696:
#line 3675 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_PROTO_DST; }
#line 9875 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 698:
#line 3679 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_SRC; }
#line 9881 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 699:
#line 3680 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_DST; }
#line 9887 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 700:
#line 3683 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_BYTES; }
#line 9893 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 701:
#line 3684 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_PKTS; }
#line 9899 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 702:
#line 3685 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_AVGPKT; }
#line 9905 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 703:
#line 3686 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = NFT_CT_ZONE; }
#line 9911 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 706:
#line 3694 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = list_expr_alloc(&(yyloc));
				compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 9921 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 707:
#line 3700 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyvsp[-2].expr)->location = (yyloc);
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 9931 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 708:
#line 3708 "parser_bison.y" /* yacc.c:1646  */
    {
				switch ((yyvsp[-2].val)) {
				case NFT_CT_HELPER:
					(yyval.stmt) = objref_stmt_alloc(&(yyloc));
					(yyval.stmt)->objref.type = NFT_OBJECT_CT_HELPER;
					(yyval.stmt)->objref.expr = (yyvsp[0].expr);
					break;
				default:
					(yyval.stmt) = ct_stmt_alloc(&(yyloc), (yyvsp[-2].val), -1, (yyvsp[0].expr));
					break;
				}
			}
#line 9948 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 709:
#line 3721 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.stmt) = ct_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[-3].val), (yyvsp[0].expr));
			}
#line 9956 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 710:
#line 3727 "parser_bison.y" /* yacc.c:1646  */
    {
				if ((yyvsp[-2].expr)->ops->type == EXPR_EXTHDR)
					(yyval.stmt) = exthdr_stmt_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
				else
					(yyval.stmt) = payload_stmt_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 9967 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 727:
#line 3754 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), NULL, 0);
				payload_init_raw((yyval.expr), (yyvsp[-4].val), (yyvsp[-2].val), (yyvsp[0].val));
				(yyval.expr)->byteorder		= BYTEORDER_BIG_ENDIAN;
				(yyval.expr)->payload.is_raw	= true;
			}
#line 9978 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 728:
#line 3762 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = PROTO_BASE_LL_HDR; }
#line 9984 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 729:
#line 3763 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = PROTO_BASE_NETWORK_HDR; }
#line 9990 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 730:
#line 3764 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = PROTO_BASE_TRANSPORT_HDR; }
#line 9996 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 731:
#line 3768 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_eth, (yyvsp[0].val));
			}
#line 10004 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 732:
#line 3773 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ETHHDR_SADDR; }
#line 10010 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 733:
#line 3774 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ETHHDR_DADDR; }
#line 10016 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 734:
#line 3775 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ETHHDR_TYPE; }
#line 10022 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 735:
#line 3779 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_vlan, (yyvsp[0].val));
			}
#line 10030 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 736:
#line 3784 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = VLANHDR_VID; }
#line 10036 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 737:
#line 3785 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = VLANHDR_CFI; }
#line 10042 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 738:
#line 3786 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = VLANHDR_PCP; }
#line 10048 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 739:
#line 3787 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = VLANHDR_TYPE; }
#line 10054 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 740:
#line 3791 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_arp, (yyvsp[0].val));
			}
#line 10062 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 741:
#line 3796 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ARPHDR_HRD; }
#line 10068 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 742:
#line 3797 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ARPHDR_PRO; }
#line 10074 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 743:
#line 3798 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ARPHDR_HLN; }
#line 10080 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 744:
#line 3799 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ARPHDR_PLN; }
#line 10086 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 745:
#line 3800 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ARPHDR_OP; }
#line 10092 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 746:
#line 3804 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ip, (yyvsp[0].val));
			}
#line 10100 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 747:
#line 3809 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_VERSION; }
#line 10106 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 748:
#line 3810 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_HDRLENGTH; }
#line 10112 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 749:
#line 3811 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_DSCP; }
#line 10118 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 750:
#line 3812 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_ECN; }
#line 10124 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 751:
#line 3813 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_LENGTH; }
#line 10130 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 752:
#line 3814 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_ID; }
#line 10136 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 753:
#line 3815 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_FRAG_OFF; }
#line 10142 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 754:
#line 3816 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_TTL; }
#line 10148 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 755:
#line 3817 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_PROTOCOL; }
#line 10154 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 756:
#line 3818 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_CHECKSUM; }
#line 10160 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 757:
#line 3819 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_SADDR; }
#line 10166 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 758:
#line 3820 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPHDR_DADDR; }
#line 10172 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 759:
#line 3824 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_icmp, (yyvsp[0].val));
			}
#line 10180 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 760:
#line 3829 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_TYPE; }
#line 10186 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 761:
#line 3830 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_CODE; }
#line 10192 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3831 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_CHECKSUM; }
#line 10198 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 763:
#line 3832 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_ID; }
#line 10204 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3833 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_SEQ; }
#line 10210 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3834 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_GATEWAY; }
#line 10216 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3835 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMPHDR_MTU; }
#line 10222 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3839 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ip6, (yyvsp[0].val));
			}
#line 10230 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3844 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_VERSION; }
#line 10236 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3845 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_DSCP; }
#line 10242 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3846 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_ECN; }
#line 10248 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3847 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_FLOWLABEL; }
#line 10254 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3848 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_LENGTH; }
#line 10260 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3849 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_NEXTHDR; }
#line 10266 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3850 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_HOPLIMIT; }
#line 10272 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3851 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_SADDR; }
#line 10278 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3852 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IP6HDR_DADDR; }
#line 10284 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3855 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_icmp6, (yyvsp[0].val));
			}
#line 10292 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3860 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_TYPE; }
#line 10298 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3861 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_CODE; }
#line 10304 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3862 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_CHECKSUM; }
#line 10310 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3863 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_PPTR; }
#line 10316 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3864 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_MTU; }
#line 10322 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3865 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_ID; }
#line 10328 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3866 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_SEQ; }
#line 10334 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3867 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ICMP6HDR_MAXDELAY; }
#line 10340 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3871 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ah, (yyvsp[0].val));
			}
#line 10348 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3876 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = AHHDR_NEXTHDR; }
#line 10354 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3877 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = AHHDR_HDRLENGTH; }
#line 10360 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3878 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = AHHDR_RESERVED; }
#line 10366 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3879 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = AHHDR_SPI; }
#line 10372 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3880 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = AHHDR_SEQUENCE; }
#line 10378 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3884 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_esp, (yyvsp[0].val));
			}
#line 10386 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3889 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ESPHDR_SPI; }
#line 10392 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3890 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = ESPHDR_SEQUENCE; }
#line 10398 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3894 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_comp, (yyvsp[0].val));
			}
#line 10406 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3899 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = COMPHDR_NEXTHDR; }
#line 10412 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3900 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = COMPHDR_FLAGS; }
#line 10418 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3901 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = COMPHDR_CPI; }
#line 10424 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3905 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_udp, (yyvsp[0].val));
			}
#line 10432 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3910 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_SPORT; }
#line 10438 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3911 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_DPORT; }
#line 10444 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3912 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_LENGTH; }
#line 10450 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3913 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_CHECKSUM; }
#line 10456 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3917 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_udplite, (yyvsp[0].val));
			}
#line 10464 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3922 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_SPORT; }
#line 10470 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3923 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_DPORT; }
#line 10476 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3924 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_LENGTH; }
#line 10482 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3925 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = UDPHDR_CHECKSUM; }
#line 10488 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3929 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_tcp, (yyvsp[0].val));
			}
#line 10496 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3933 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = tcpopt_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 10504 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3937 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = tcpopt_expr_alloc(&(yyloc), (yyvsp[0].val), TCPOPTHDR_FIELD_KIND);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 10513 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3943 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_SPORT; }
#line 10519 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3944 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_DPORT; }
#line 10525 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3945 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_SEQ; }
#line 10531 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3946 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_ACKSEQ; }
#line 10537 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3947 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_DOFF; }
#line 10543 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3948 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_RESERVED; }
#line 10549 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3949 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_FLAGS; }
#line 10555 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3950 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_WINDOW; }
#line 10561 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3951 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_CHECKSUM; }
#line 10567 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3952 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPHDR_URGPTR; }
#line 10573 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3955 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_EOL; }
#line 10579 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3956 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_NOOP; }
#line 10585 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3957 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_MAXSEG; }
#line 10591 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3958 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_WINDOW; }
#line 10597 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3959 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_SACK_PERMITTED; }
#line 10603 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 827:
#line 3960 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_SACK0; }
#line 10609 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 828:
#line 3961 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_SACK0; }
#line 10615 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 829:
#line 3962 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_SACK1; }
#line 10621 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 830:
#line 3963 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_SACK2; }
#line 10627 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3964 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_SACK3; }
#line 10633 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3965 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_ECHO; }
#line 10639 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3966 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_TIMESTAMP; }
#line 10645 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 834:
#line 3969 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_FIELD_KIND; }
#line 10651 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 835:
#line 3970 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_FIELD_LENGTH; }
#line 10657 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3971 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_FIELD_SIZE; }
#line 10663 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 837:
#line 3972 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_FIELD_COUNT; }
#line 10669 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 838:
#line 3973 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_FIELD_LEFT; }
#line 10675 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 839:
#line 3974 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_FIELD_RIGHT; }
#line 10681 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 840:
#line 3975 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_FIELD_TSVAL; }
#line 10687 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 841:
#line 3976 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = TCPOPTHDR_FIELD_TSECR; }
#line 10693 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 842:
#line 3980 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_dccp, (yyvsp[0].val));
			}
#line 10701 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3985 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = DCCPHDR_SPORT; }
#line 10707 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3986 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = DCCPHDR_DPORT; }
#line 10713 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 845:
#line 3987 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = DCCPHDR_TYPE; }
#line 10719 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 846:
#line 3991 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_sctp, (yyvsp[0].val));
			}
#line 10727 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3996 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = SCTPHDR_SPORT; }
#line 10733 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 848:
#line 3997 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = SCTPHDR_DPORT; }
#line 10739 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 849:
#line 3998 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = SCTPHDR_VTAG; }
#line 10745 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 850:
#line 3999 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = SCTPHDR_CHECKSUM; }
#line 10751 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 859:
#line 4013 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_hbh, (yyvsp[0].val));
			}
#line 10759 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 860:
#line 4018 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = HBHHDR_NEXTHDR; }
#line 10765 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 861:
#line 4019 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = HBHHDR_HDRLENGTH; }
#line 10771 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 862:
#line 4023 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt, (yyvsp[0].val));
			}
#line 10779 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 863:
#line 4028 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = RTHDR_NEXTHDR; }
#line 10785 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 864:
#line 4029 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = RTHDR_HDRLENGTH; }
#line 10791 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 865:
#line 4030 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = RTHDR_TYPE; }
#line 10797 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 866:
#line 4031 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = RTHDR_SEG_LEFT; }
#line 10803 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 867:
#line 4035 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt0, (yyvsp[0].val));
			}
#line 10811 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 868:
#line 4041 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = RT0HDR_ADDR_1 + (yyvsp[-1].val) - 1;
			}
#line 10819 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 869:
#line 4047 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt2, (yyvsp[0].val));
			}
#line 10827 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 870:
#line 4052 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = RT2HDR_ADDR; }
#line 10833 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 871:
#line 4056 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt4, (yyvsp[0].val));
			}
#line 10841 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 872:
#line 4061 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = RT4HDR_LASTENT; }
#line 10847 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 873:
#line 4062 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = RT4HDR_FLAGS; }
#line 10853 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 874:
#line 4063 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = RT4HDR_TAG; }
#line 10859 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 875:
#line 4065 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.val) = RT4HDR_SID_1 + (yyvsp[-1].val) - 1;
			}
#line 10867 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 876:
#line 4071 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_frag, (yyvsp[0].val));
			}
#line 10875 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 877:
#line 4076 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = FRAGHDR_NEXTHDR; }
#line 10881 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 878:
#line 4077 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = FRAGHDR_RESERVED; }
#line 10887 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 879:
#line 4078 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = FRAGHDR_FRAG_OFF; }
#line 10893 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 880:
#line 4079 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = FRAGHDR_RESERVED2; }
#line 10899 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 881:
#line 4080 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = FRAGHDR_MFRAGS; }
#line 10905 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 882:
#line 4081 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = FRAGHDR_ID; }
#line 10911 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 883:
#line 4085 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_dst, (yyvsp[0].val));
			}
#line 10919 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 884:
#line 4090 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = DSTHDR_NEXTHDR; }
#line 10925 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 885:
#line 4091 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = DSTHDR_HDRLENGTH; }
#line 10931 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 886:
#line 4095 "parser_bison.y" /* yacc.c:1646  */
    {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_mh, (yyvsp[0].val));
			}
#line 10939 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 887:
#line 4100 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = MHHDR_NEXTHDR; }
#line 10945 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 888:
#line 4101 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = MHHDR_HDRLENGTH; }
#line 10951 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 889:
#line 4102 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = MHHDR_TYPE; }
#line 10957 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 890:
#line 4103 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = MHHDR_RESERVED; }
#line 10963 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 891:
#line 4104 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = MHHDR_CHECKSUM; }
#line 10969 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 892:
#line 4108 "parser_bison.y" /* yacc.c:1646  */
    {
				const struct exthdr_desc *desc;

				desc = exthdr_find_proto((yyvsp[0].val));

				/* Assume that NEXTHDR template is always
				 * the fist one in list of templates.
				 */
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), desc, 1);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 10985 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 893:
#line 4121 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPPROTO_HOPOPTS; }
#line 10991 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 894:
#line 4122 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPPROTO_ROUTING; }
#line 10997 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 895:
#line 4123 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPPROTO_FRAGMENT; }
#line 11003 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 896:
#line 4124 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPPROTO_DSTOPTS; }
#line 11009 "parser_bison.c" /* yacc.c:1646  */
    break;

  case 897:
#line 4125 "parser_bison.y" /* yacc.c:1646  */
    { (yyval.val) = IPPROTO_MH; }
#line 11015 "parser_bison.c" /* yacc.c:1646  */
    break;


#line 11019 "parser_bison.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, nft, scanner, state, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, nft, scanner, state, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, nft, scanner, state);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, nft, scanner, state);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, nft, scanner, state, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, nft, scanner, state);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, nft, scanner, state);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 4128 "parser_bison.y" /* yacc.c:1906  */

